<?php
// $Id: ticket.admin.group.inc,v 1.1.4.2 2009/07/09 11:40:21 york Exp $

/**
 * ticket_admin_help: help
 */
function ticket_admin_help() {
  $output .= t("<h1>E-mail example:</h1>\r\n<dl>\r\n<dt><b>Group e-mail address:</b></dt>\r\n  <dd>Depending on settings mails sent to the the following address will either directly transformed to a trouble ticket or will be put on a temporal collector queue. This address is also used as the From-address of the outgoing mails. If this field is left void, the mail sending/receiving subsystem will be turned off.</dd>\r\n<dt><b>Incoming e-mail address example:</b></dt>\r\n  <dd>Sender example expression. Those tickets for that the sender matches the expression will be automatically converted to trouble tickets, otherwise they will be put on a temporary collector queue. Those mails that do not match to the expression will be transformed to a temporary Queue Element. Global symbol '*' can be used. If this field is left void, the mail receiving subsystem will be turned off. </dd>\r\n</dl>\r\n\r\n<h2>Trouble ticket:</h2> The mail format when creating a ticket is given here. <br />\r\n<dl>\r\n<dt><b>Subject of mail ticket:</b></dt>\r\n  <dd>Outgoing mail subject format. Valid expressions are shown in the table below: </dd>\r\n<dt><b>Ticket header example:</b></dt>\r\n  <dd>This is shown in the upper body of all outgoing mail tickets. Valid expressions are shown in the table below.</dd>\r\n<dt><b>Ticket body example:</b></dt>\r\n  <dd>Its appearance is dependent on \"Event-mail content\" setting. In any case it is positioned between the mail header and footer. Valid expressions are shown in the table below.</dd>\r\n<dt><b>Ticket footer example:</b></dt>\r\n  <dd>It appears at the bottom part of all outgoing mail. Valid expressions are shown in the table below.</dd>\r\n</dl>\r\n<h2>Events:</h2>  Format of updated mail tickets  is defined here. <br />\r\n<dl>\r\n<dt><b>Event position:</b></dt>\r\n  <dd>It determines the placement of \"Event example\".</dd>\r\n<dt><b>Event separator:</b></dt>\r\n  <dd>The string given here will be inserted among events in mail tickets.</dd>\r\n<dt><b>Event e-mail subject:</b></dt>\r\n  <dd>Format of outgoing mail subject. If left void, it uses the value of \"Ticket e-mail subject\". Valid expressions are shown in the table below.</dd>\r\n<dt><b>Event example:</b></dt>\r\n  <dd>Its function and placement are the same as in case of \"Ticket body example\". Valid expressions are shown in the table below.</dd>\r\n<dt><b>Event mail content:</b></dt>\r\n  <dd>Event content elements and their sequence can be given here.</dd>\r\n</dl>\r\n<dl>\r\n<dt><b>Unmodified ticket warning:</b></dt>\r\n  <dd>In this section a warning message can be configured for those tickets that have not been modified for a while.</dd>\r\n<dt><b>Unmodified since:</b></dt>\r\n  <dd>A warning message will be sent on behalf of those open tickets that have not been modified since the time given. If this value is \"0\", no warning message will be sent.</dd>\r\n<dt><b>Unmodified ticket warning mail subject:</b></dt>\r\n  <dd>The subject of warning mail.</dd>\r\n<dt><b>Unmodified ticket mail template:</b></dt>\r\n  <dd>Content of mail periodically sent on behalf of the unmodified ticket.</dd>\r\n</dl>\r\n<h2>Valid expressions (more info on e-mail example page):</h2>\r\n<ul>\r\n<li> a-z A-Z 0-9 ,.-+*/%[]{}() </li>\r\n<li> %actions: Actions </li>\r\n<li> %affected: Affected </li>\r\n<li> %assigned: Assigned to </li>\r\n<li> %detail: Details </li>\r\n<li> %ec: Event updated by </li>\r\n<li> %edate: Event time </li>\r\n<li> %edesc: Event description </li>\r\n<li> %eid: Event identifier </li>\r\n<li> %fix: Fix </li>\r\n<li> %fixer: Fixer </li>\r\n<li> %g: Group </li>\r\n<li> %pf: Problem ended </li>\r\n<li> %pl: Problem duration </li>\r\n<li> %pri: Priority </li>\r\n<li> %ps: Problem started </li>\r\n<li> %ra: Re-assigned to </li>\r\n<li> %sc: Scope </li>\r\n<li> %si: Site </li>\r\n<li> %ss: Summary </li>\r\n<li> %st: Status </li>\r\n<li> %tc: Created by </li>\r\n<li> %tid: Ticket identifier </li>\r\n<li> %ttf: Time to fix </li>\r\n<li> %type: Type </li>\r\n</ul>");

  $output .= t("<h1>Status settings:</h1>\r\n<dl>\r\n<dt><b>Status:</b></dt>\r\n  <dd>Status name. <br />\r\n<dt><b>Closed:</b></dt>\r\n  <dd>If it is of closed type, it can be selected when closing a ticket. Otherwise, it can be the status of the update event.</dd>\r\n<dt><b>Permitted:</b></dt>\r\n  <dd>To preserve the integrity of the ticketing system it cannot be deleted. If the property is not permitted, the system treats it as deleted.</dd>\r\n<dt><b>Weight:</b></dt>\r\n  <dd>It determines the sequence of elements, as in other cases in Dupal.</dd>\r\n<dt><b>Level:</b></dt>\r\n  <dd>Its primary purpose is to allow distinguishing tickets being in different status.</dd>\r\n</dl>");
  return $output;
}

/**
 * ticket_admin_group_list_form: Ticket group admisztracios listaja
 * @return array - $form: group list form
 */
function ticket_admin_group_list_form() {
  $SQL = "SELECT u_id, unit_name FROM {ticket_unit}";
  $SQL .= " ORDER BY active DESC, weight ASC, unit_name ASC";
  $rs_unit = db_query($SQL);

  $form['#tree'] = TRUE;
  while ($urow = db_fetch_array($rs_unit)) {
    $form[$urow['u_id']]['name'] = array( '#value' => $urow['unit_name'] );
    if ( ticket_access('ticket administer', $urow['u_id'], 0) ) {
      $form[$urow['u_id']]['add'] = array('#value' => l(t('new group'), 'admin/ticket/group/add/'. $urow['u_id']) );
    }
    else {
      $form[$urow['u_id']]['add'] = array('#value' => t('new group'));
    }

    $SQL = "SELECT gid, group_name, weight, active FROM {ticket_group}";
    $SQL .= " WHERE u_id = %d ORDER BY active DESC, weight ASC, group_name ASC";
    $result = db_query($SQL, $urow['u_id']);
    while ($row = db_fetch_array($result)) {
      $form[$urow['u_id']][$row['gid']]['info'] =  array('#value' => $row['group_name']);
      $form[$urow['u_id']][$row['gid']]['weight'] = array(
        '#type' => 'weight',
        '#default_value' => $row['weight'],
        '#attributes' => array('class' => 'group-weight group-weight-'. $row['gid']),
      );
      if ( ticket_access('ticket administer', $urow['u_id'], $row['gid']) ) {
        $form[$urow['u_id']][$row['gid']]['configure'] = array('#value' => l(t('edit group'), 'admin/ticket/group/edit/'. $row['gid']) );
        if ($row['active']) {
          $form[$urow['u_id']][$row['gid']]['active'] = array('#value' => l(t('disable'), 'admin/ticket/group/active/'. $row['gid'] .'/0') );
        }
        else {
          $form[$urow['u_id']][$row['gid']]['active'] = array('#value' => l(t('enable'), 'admin/ticket/group/active/'. $row['gid'] .'/1') );
        }
      }
      else {
        $form[$urow['u_id']][$row['gid']]['configure'] = array('#value' => t('edit group'));
      }
    }
  }

  $form["submit"] = array(
    "#type" => "submit",
    "#value" => t('Save configuration'),
  );

  return $form;
}

function ticket_admin_group_list_form_submit($form, &$form_state) {
  foreach ($form_state['values'] as $u_id => $groups) {
    if ( is_numeric($u_id) ) {
      foreach ($groups as $gid => $weight) {
        $SQL = "UPDATE {ticket_group} SET weight = %d WHERE gid = %d";
        db_query($SQL, $weight['weight'], $gid);
      }
    }
  }
}

/**
 * _ticket_admin_group_form:
 * @param $def - group form default erteki
 * @return array - $form: group add/edit form
 */
function _ticket_admin_group_form($def = array()) {
  $form['name'] = array(
    '#type' => 'textfield',
    '#title' => t('Group name'),
    '#default_value' => isset($def['group_name']) ? $def['group_name'] : NULL,
    '#size' => 60,
    '#maxlength' => 255,
    '#required' => TRUE,
  );

  $form['desc'] = array(
    '#type' => 'textarea',
    '#title' => t('Description'),
    '#default_value' => isset($def['description']) ? $def['description'] : NULL,
    '#required' => FALSE,
  );

  $form['weight'] = array(
    '#type' => 'weight',
    '#title' => t('Weight'),
    "#type" => "weight",
    '#default_value' => isset($def['weight']) ? $def['weight'] : NULL,
  );

  $form['active'] = array(
    '#type' => 'select',
    '#title' => t('Active'),
    '#default_value' => isset($def['active']) ? $def['active'] : NULL,
    '#options' => array(
      '1' => t('Yes'),
      '0' => t('No'),
    ),
  );
  return $form;
}

/**
 * ticket_admin_group_add: csoport letrehozasa
 * @param $u_id - unit id
 * @return array - $form: group add form
 */
function ticket_admin_group_add(&$form_state, $u_id) {
  drupal_set_title( t('Add group in !unit_name', array('!unit_name' => _ticket_unit_name($u_id))) );

  $def['weight'] = 0;
  $form = _ticket_admin_group_form($def);
  $form['u_id'] = array(
    '#type' => 'value',
    '#value' => $u_id,
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );
  return $form;
}

/**
 * ticket_admin_group_add_validate: add group formrol erkezo adatok ellenorzese
 */
function ticket_admin_group_add_validate($form, &$form_state) {
  /** azonos nevu csoport egy uniton belul nem johet letre */
  $result = db_query("SELECT count(u_id) as num FROM {ticket_group} WHERE u_id = %d AND group_name = '%s'", $form_state['values']['u_id'], $form_state['values']['name']);
  $row = db_fetch_array($result);
  if ( $row['num'] ) {
    form_set_error('', t('You must select a name for this group of settings.'));
  }
}

/**
 * ticket_admin_group_add_submit: csoport hozzaadas
 */
function ticket_admin_group_add_submit($form, &$form_state) {
  /** group hozzaadasa */
  $SQL = "INSERT INTO {ticket_group} (u_id, group_name, description, weight, active) VALUES (%d, '%s', '%s', %d, %d)";
  db_query($SQL, $form_state['values']['u_id'], $form_state['values']['name'], $form_state['values']['desc'], $form_state['values']['weight'], $form_state['values']['active']);
  $gid = db_last_insert_id('{ticket_group}', 'gid');
  _ticket_admin_group_add_extension($gid);

  /** group menupont letrehozasa a megfelelo unit alatt */
  $menu = db_fetch_array(db_query("SELECT mlid AS plid, menu_name FROM {menu_links} WHERE link_path = '%s'", 'ticket/'. $form_state['values']['u_id']));
  $menu['router_path'] = 'ticket/%/%';
  $menu['module'] = 'ticket';
  $menu['mlid'] = 0;
  $menu['link_title'] = $form_state['values']['name'];
  $menu['link_path'] = 'ticket/'. $form_state['values']['u_id'] .'/'. $gid;
  if (!db_result(db_query("SELECT mlid FROM {menu_links} WHERE link_path = '%s' AND plid = %d", $menu['link_path'], $menu['plid']))) {
    $mlid = menu_link_save($menu);
    $group_base = db_fetch_array(db_query("SELECT mlid AS plid, menu_name, module FROM {menu_links} WHERE mlid = %d ", $mlid));

    $group_list = $group_base;
    $group_list['mlid'] = $mild;
    $group_list['router_path'] = 'ticket/%/%/list';
    $group_list['link_title'] = 'List';
    $group_list['link_path'] = 'ticket/'. $form_state['values']['u_id'] .'/'. $gid .'/list';
    $group_list['weight'] = 8;
    menu_link_save($group_list);

    $group_search = $group_base;
    $group_search['mlid'] = $mild;
    $group_search['router_path'] = 'ticket/%/%/search';
    $group_search['link_title'] = 'Search';
    $group_search['link_path'] = 'ticket/'. $form_state['values']['u_id'] .'/'. $gid .'/search';
    $group_search['weight'] = 9;
    menu_link_save($group_search);

    $group_export = $group_base;
    $group_export['mlid'] = $mild;
    $group_export['router_path'] = 'ticket/%/%/export';
    $group_export['link_title'] = 'Export';
    $group_export['link_path'] = 'ticket/'. $form_state['values']['u_id'] .'/'. $gid .'/export';
    $group_export['weight'] = 10;
    menu_link_save($group_export);

    $group_add = $group_base;
    $group_add['mlid'] = $mild;
    $group_add['router_path'] = 'ticket/%/%/add';
    $group_add['link_title'] = 'Add ticket';
    $group_add['link_path'] = 'ticket/'. $form_state['values']['u_id'] .'/'. $gid .'/add';
    menu_link_save($group_add);

    $group_queue = $group_base;
    $group_queue['mlid'] = $mild;
    $group_queue['router_path'] = 'ticket/%/%/queue';
    $group_queue['link_title'] = 'Queue (0)';
    $group_queue['link_path'] = 'ticket/'. $form_state['values']['u_id'] .'/'. $gid .'/queue';
    menu_link_save($group_queue);
  }
  drupal_goto('admin/ticket/group/edit/'. $gid);
}

/**
 * ticket_admin_group_edit: group szerkesztes
 * @param $form_state - drupal $form_state variable
 * @param $gid - group id
 * @return array - $form: group edit form
 */
function ticket_admin_group_edit(&$form_state, $gid) {
  /** csoport lekerdezese, a vissza adott ertekek atadasa a formnak */
  $result = db_query("SELECT * FROM {ticket_group} WHERE gid = %d", $gid);
  $def = db_fetch_array($result);

  $form = _ticket_admin_group_form($def);
  $form['gid'] = array(
    '#type' => 'value',
    '#value' => $gid,
  );
  $form['u_id'] = array(
    '#type' => 'value',
    '#value' => $def['u_id'],
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );
  drupal_set_title( t('!unit_name &rArr; !group_name', array('!unit_name' => _ticket_unit_name($def['u_id']), '!group_name' => $def['group_name']) ) );
  return $form;
}

/**
 * ticket_admin_group_edit_validate: edit group formrol erkezo adatok ellenorzese
 */
function ticket_admin_group_edit_validate($form, &$form_state) {
  /** azonos nevu csoport egy uniton belul nem johet letre */
  $result = db_query("SELECT count(u_id) as num FROM {ticket_group} WHERE u_id = %d AND gid <> %d AND group_name = '%s'", $form_state['values']['u_id'], $form_state['values']['gid'], $form_state['values']['name']);
  $row = db_fetch_array($result);
  if ( $row['num'] ) {
    form_set_error('', t('You must select a name for this group of settings.'));
  }
}

/**
 * ticket_admin_group_edit_submit: csoport modositas
 */
function ticket_admin_group_edit_submit($form, &$form_state) {
  /** csoport szerkesztese */
  $SQL = "UPDATE {ticket_group} SET group_name = '%s', description = '%s', weight = %d, active = %d WHERE gid = %d";
  db_query($SQL, $form_state['values']['name'], $form_state['values']['desc'], $form_state['values']['weight'], $form_state['values']['active'], $form_state['values']['gid']);

  /** group menupont modositasa a unit menu alatt */
  $menu = db_fetch_array(db_query("SELECT * FROM {menu_links} WHERE link_path = '%s'", 'ticket/'. $form_state['values']['u_id'] .'/'. $form_state['values']['gid']));
  $menu['link_title'] = $form_state['values']['name'];
  $menu['options'] = array();
  menu_link_save($menu);
  drupal_goto('admin/ticket/group');
}

/**
 * ticket_admin_group_active: group allapotanak modositasa: bekapcsolt / kikapcsolt
 */
function ticket_admin_group_active($gid, $active) {
  $SQL = "UPDATE {ticket_group} SET active = %d WHERE gid = %d";
  db_query($SQL, $active, $gid);
  $result = db_query("SELECT u_id FROM {ticket_group} WHERE gid = %d", $gid);
  $row = db_fetch_array($result);

  /** menupont ki/be kapcsolasa csoport allapotanak megfeleloen */
  $menu = db_fetch_array(db_query("SELECT * FROM {menu_links} WHERE link_path = '%s'", 'ticket/'. $row['u_id'] .'/'. $gid));
  $menu['hidden'] = !$active;
  $menu['options'] = array();
  menu_link_save($menu);
  drupal_goto('admin/ticket/group');
}

/************************************************************
 ************************* TEMPLATE *************************
 ************************************************************/

/**
 * _ticket_admin_email_form:
 * @param $def - group form default erteki
 */
function _ticket_admin_email_form($def = array()) {
  $form['mail_address'] = array(
    '#type' => 'textfield',
    '#title' => t('Group e-mail address'),
    '#description' => t('Mails sent to the following address will be transferred to the Group Collector Queue. Depending on the Incoming Mail pattern mail having been sent to this address is either transformed to a ticket or produce a Queue Element. The address given here is also the sender address of ticket update mails.'),
    '#default_value' => isset($def['mail_address']) ? $def['mail_address'] : NULL,
    '#size' => 60,
    '#maxlength' => 255,
    '#required' => FALSE,
  );

  $form['sender_address'] = array(
    '#type' => 'textfield',
    '#title' => t('Incoming e-mail pattern'),
    '#description' => t("Sender e-mail pattern. If the sender's e-mail fits the pattern here, the mail will be automatically transferred to a ticket. Otherwise, the mail will be converted as a Queue Element. Global '*' can be used here"),
    '#default_value' => isset($def['sender_address']) ? $def['sender_address'] : NULL,
    '#size' => 60,
    '#maxlength' => 255,
    '#required' => FALSE,
  );

  $form['ticket'] = array(
    '#type' => 'fieldset',
    '#title' => t('Ticket') .':',
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $form['ticket']['tsubject'] = array(
    '#type' => 'textfield',
    '#title' => t('Ticket e-mail subject'),
    '#description' => t("Format of outgoing mail subject. Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: <b>%tid</b> - Ticket id, <b>%g</b> - Group, <b>%tc</b> - Ticket creator, <b>%pri</b> - Priority, <b>%type</b> - Type, <b>%st</b> - Status, <b>%sc</b> - Scope, <b>%si</b> - Site, <b>%fixer</b> - Fixer, <b>%assigned</b> - Assigned to, <b>%ps</b> - Problem start, <b>%ss</b> - Short summary."),
    '#default_value' => isset($def['tsubject']) ? $def['tsubject'] : NULL,
    '#size' => 60,
    '#maxlength' => 50,
    '#required' => TRUE,
  );

  $form['ticket']['tt_header'] = array(
    '#type' => 'textarea',
    '#title' => t('Ticket header template'),
    '#default_value' => isset($def['tt_header']) ? $def['tt_header'] : NULL,
    '#description' => t("Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: the same as in the case of mail subject, plus: <b>%pl</b> - Problem length, <b>%pf</b> - Problem finish, <b>%detail</b> - Detail, <b>%affected</b> - Affected, <b>%actions</b> - Actions, <b>%ttf</b> - Time to fix, <b>%fix</b> - Fix, <b>%tfiles</b> - Ticket attachments."),
    '#rows' => '8',
    '#required' => FALSE,
  );

  $form['ticket']['tt_body'] = array(
    '#type' => 'textarea',
    '#title' => t('Ticket body template'),
    '#default_value' => isset($def['tt_body']) ? $def['tt_body'] : NULL,
    '#description' => t("Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: the same as in case of mail header."),
    '#rows' => '8',
    '#required' => FALSE,
  );

  $form['ticket']['tt_footer'] = array(
    '#type' => 'textarea',
    '#title' => t('Ticket footer template'),
    '#default_value' => isset($def['tt_footer']) ? $def['tt_footer'] : NULL,
    '#description' => t("Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: the same as in case of mail header."),
    '#rows' => '8',
    '#required' => FALSE,
  );

  $form['event'] = array(
    '#type' => 'fieldset',
    '#title' => t('Events') .':',
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $event_pos = array(
    t('Before body'),
    t('After body'),
  );

  $form['event']['e_pos'] = array(
    '#type' => 'select',
    '#title' => t('Event placement'),
    '#options' => $event_pos,
    '#default_value' => isset($def['e_pos']) ? $def['e_pos'] : NULL,
    '#description' => t("Event's position relative to Ticket Body."),
  );

  $form['event']['sep'] = array(
    '#type' => 'textfield',
    '#title' => t('Event separator'),
    '#description' => t('Character string to separate Events from Ticket Body. (max. 80 character).'),
    '#default_value' => isset($def['sep']) ? $def['sep'] : NULL,
    '#size' => 60,
    '#maxlength' => 80,
    '#required' => FALSE,
  );

  $form['event']['esubject'] = array(
    '#type' => 'textfield',
    '#title' => t('Event e-mail subject'),
    '#description' => t("Subject format of the outgoing mails. If left void, then the value given in 'Ticket e-mail subject' will be used. Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: the same as in case of mail subject, plus: <b>%eid</b> - Event ID, <b>%st</b> - Status, <b>%ra</b> - Re-assigned."),
    '#default_value' => isset($def['esubject']) ? $def['esubject'] : NULL,
    '#size' => 60,
    '#maxlength' => 50,
  );

  $form['event']['etemplate'] = array(
    '#type' => 'textarea',
    '#title' => t('Event template'),
    '#default_value' => isset($def['etemplate']) ? $def['etemplate'] : NULL,
    '#description' => t("Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: the same as in case of ticket templates, plus: <b>%ec</b> - Event creator, <b>%edate</b> - Event created, <b>%edesc</b> - Event description, <b>%eid</b> - Event ID, <b>%st</b> - Status, <b>%ra</b> - Re-assigned, <b>%efiles</b> - Ticket event attachments."),
    '#rows' => '4',
    '#required' => FALSE,
  );

  $event_type = array(
    t('Ticket and events in ascending order'),
    t('Ticket and events in descending order'),
    t('Only events in acsending order'),
    t('Only events in descending order'),
    t('Only new event')
  );

  $form['event']['e_type'] = array(
    '#type' => 'select',
    '#title' => t('Content of event mail'),
    '#options' => $event_type,
    '#default_value' => isset($def['e_type']) ? $def['e_type'] : NULL,
  );

  $form['assigned'] = array(
    '#type' => 'fieldset',
    '#title' => t('Warning mail to ticket owner') .':',
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $form['assigned']['asubject'] = array(
    '#type' => 'textfield',
    '#title' => t('Warning mail subject'),
    '#description' => t("Subject format of the reassigned to mails. Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: the same as in case of event mail subject."),
    '#default_value' => isset($def['asubject']) ? $def['asubject'] : NULL,
    '#size' => 60,
    '#maxlength' => 80,
  );

  $form['assigned']['atemplate'] = array(
    '#type' => 'textarea',
    '#title' => t('Warning mail template'),
    '#default_value' => isset($def['atemplate']) ? $def['atemplate'] : NULL,
    '#description' => t("Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: the same as in case of event templates."),
    '#rows' => '2',
    '#required' => FALSE,
  );

  $form['unchanged'] = array(
    '#type' => 'fieldset',
    '#title' => t('Unchanged ticket warning') .':',
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $form['unchanged']['unchanged_day'] = array(
    '#type' => 'textfield',
    '#title' => t('Number of days since the ticket is unchanged'),
    '#default_value' => isset($def['unchanged_day']) ? $def['unchanged_day'] : NULL,
    '#size' => 10,
    '#maxlength' => 3,
    '#required' => TRUE,
  );

  $form['unchanged']['usubject'] = array(
    '#type' => 'textfield',
    '#title' => t('Unchanged ticket e-mail subject'),
    '#default_value' => isset($def['usubject']) ? $def['usubject'] : NULL,
    '#size' => 60,
    '#maxlength' => 80,
  );

  $form['unchanged']['utemplate'] = array(
    '#type' => 'textarea',
    '#title' => t('Unchanged ticket e-mail template'),
    '#default_value' => isset($def['utemplate']) ? $def['utemplate'] : NULL,
    '#description' => t("Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: <b>%tid</b> - Ticket id, <b>%g</b> - Group, <b>%tc</b> - Ticket creator, <b>%pri</b> - Priority, <b>%type</b> - Type, <b>%st</b> - Status, <b>%sc</b> - Scope, <b>%si</b> - Site, <b>%fixer</b> - Fixer, <b>%assigned</b> - Assigned, <b>%ps</b> - Problem start, <b>%pl</b> - Problem length, <b>%lm</b> - Last modification, <b>%ss</b> - Short summary."),
    '#rows' => '2',
    '#required' => FALSE,
  );

  $form['queued'] = array(
    '#type' => 'fieldset',
    '#title' => t('Queued request notification') .':',
    '#collapsible' => TRUE,
    '#collapsed' => FALSE
  );

  $form['queued']['qsubject'] = array(
    '#type' => 'textfield',
    '#title' => t('Queued request e-mail subject'),
    '#description' => t("Format of outgoing mail subject. Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: <b>%qid</b> - Queue id, <b>%g</b> - Group, <b>%tc</b> - Ticket creator, <b>%pri</b> - Priority, <b>%sc</b> - Scope, <b>%si</b> - Site, <b>%cd</b> - Create date, <b>%ss</b> - Short summary, <b>%dt</b> - Detail. If you don't want notification leave this field empty.'"),
    '#default_value' => isset($def['qsubject']) ? $def['qsubject'] : NULL,
    '#size' => 60,
    '#maxlength' => 50,
    '#required' => FALSE,
  );

  $form['queued']['qtemplate'] = array(
    '#type' => 'textarea',
    '#title' => t('Queued request body template'),
    '#default_value' => isset($def['qtemplate']) ? $def['qtemplate'] : NULL,
    '#description' => t("Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: the same as in case of queued request e-mail subject. If you don't want notification leave this field empty."),
    '#rows' => '8',
    '#required' => FALSE,
  );

  return $form;
}

/**
 * ticket_admin_edit_template: template szerkesztes
 * @param $form_state - drupal form variable
 * @param $gid - group id
 */
function ticket_admin_group_template_edit(&$form_state, $gid) {
  /** csoport lekerdezese, a vissza adott ertekek atadasa a formnak */
  $result = db_query("SELECT * FROM {ticket_template} WHERE gid = %d", $gid);
  $def = db_fetch_array($result);

  $form = _ticket_admin_email_form($def);
  $form['gid'] = array(
    '#type' => 'value',
    '#value' => $gid,
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );
  //  _ticket_breadcrumb('admin/ticket/'.$row['u_id'], array('admin/ticket/'.$row['u_id'] => t('list groups')));
  drupal_set_title( t('!unit_name &rArr; !group_name', array('!unit_name' => _ticket_unit_name('', $gid), '!group_name' => _ticket_group_name($gid)) ) );

  return $form;
}

/**
 * ticket_admin_edit_template_validate: template ellenorzes
 */
function ticket_admin_group_template_edit_validate($form, &$form_state) {
  /** e-mail cim ellenorzes */
  if ($form_state['values']['mail_address'] != '') {
    if (!valid_email_address($form_state['values']['mail_address']) ) {
      form_set_error('mail_address', t('Faulty e-mail address!'));
    }
    else {
      $result = db_query("SELECT count(*) AS num FROM {ticket_template} WHERE gid <> %d AND mail_address = '%s'", $form_state['values']['gid'], $form_state['values']['mail_address']);
      $row = db_fetch_array($result);
      if ( $row['num'] ) {
        form_set_error('mail_address', t('Another group is using this e-mail address.'));
      }
    }
  }
}

/**
 * ticket_admin_edit_template_submit: template jellemzok modositasa
 */
function ticket_admin_group_template_edit_submit($form, &$form_state) {
  /** e-mail jellemzok szerkesztese */
  $SQL = "UPDATE {ticket_template} SET mail_address = '%s', sender_address = '%s', tsubject = '%s', esubject = '%s', asubject = '%s'";
  $SQL .= ", usubject = '%s', qsubject = '%s', sep = '%s', e_type = %d, e_pos = %d, unchanged_day = %d, tt_header = '%s', tt_body = '%s'";
  $SQL .= ", tt_footer = '%s', etemplate = '%s', atemplate = '%s', utemplate = '%s', qtemplate = '%s' WHERE gid = %d";
  db_query($SQL, $form_state['values']['mail_address'], $form_state['values']['sender_address'], $form_state['values']['tsubject'], $form_state['values']['esubject'], $form_state['values']['asubject'], $form_state['values']['usubject'], $form_state['values']['qsubject'], $form_state['values']['sep'], $form_state['values']['e_type'], $form_state['values']['e_pos'], $form_state['values']['unchanged_day'], $form_state['values']['tt_header'], $form_state['values']['tt_body'], $form_state['values']['tt_footer'], $form_state['values']['etemplate'], $form_state['values']['atemplate'], $form_state['values']['utemplate'], $form_state['values']['qtemplate'], $form_state['values']['gid']);
}

/************************************************************
 ************ FIXER, PRIORITY, SCOPE, SITE, TYPE ************
 ************************************************************/

/**
 * ticket_admin_group_set_form: csoport tulajdonsagokhoz tartozo altalanos form
 * @param $form_state - drupal form variable
 * @param $set  form settings
 * @return array $form  drupal form
 */
function ticket_admin_group_set_form(&$form_state, $set) {
  /** tree form struktura bekapcsolasa */
  $form['#tree'] = TRUE;
  foreach ($set['var'] as $key => $var) {
    $form[$key]['name'] = array(
      '#type' => 'textfield',
      '#default_value' => $var['name'],
      '#size' => 40,
      '#maxlength' => 255,
    );
    $form[$key]['weight'] = array(
      '#type' => 'weight',
      "#type" => "weight",
      '#default_value' => $var['weight'],
    );
    $form[$key]['active'] = array(
      '#type' => 'checkbox',
      '#default_value' => $var['active'],
    );
    $form[$key]['default'] = array(
      '#type' => 'value',
      '#default_value' => $var['default'],
    );
  }

  $form['type'] = array(
    '#type' => 'value',
    '#value' => $set['type'],
  );

  $form['gid'] = array(
    '#type' => 'value',
    '#value' => $set['gid'],
  );

  $form['reset'] = array(
    '#type' => 'submit',
    '#value' => t('Reset')
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );
  return $form;
}

/**
 * ticket_admin_group_set_form_validate: csoport tulajdonsagok ellenorzese
 */
function ticket_admin_group_set_form_validate($form, &$form_state) {
  /** ures mezo es azonos nevu tulajdonsag elnevezes nem lehet */
  if ( $form_state['values']['op'] != t('Reset') ) {
    switch ($form_state['values']['type']) {
      case 'fixer':
        $SQL = "SELECT count(gid) as num FROM {ticket_fixer} WHERE gid = %d AND fixer_id <> %d AND fixer_name = '%s'";
        $name = t('fixer');
      break;

      case 'priority':
        $SQL = "SELECT count(gid) as num FROM {ticket_priority} WHERE gid = %d AND priority_id <> %d AND priority_name = '%s'";
        $name = t('priority');
      break;

      case 'scope':
        $SQL = "SELECT count(gid) as num FROM {ticket_scope} WHERE gid = %d AND scope_id <> %d AND scope_name = '%s'";
        $name = t('scope');
      break;

      case 'site':
        $SQL = "SELECT count(gid) as num FROM {ticket_site} WHERE gid = %d AND site_id <> %d AND site_name = '%s'";
        $name = t('site');
      break;

      case 'type':
        $SQL = "SELECT count(gid) as num FROM {ticket_type} WHERE gid = %d AND type_id <> %d AND type_name = '%s'";
        $name = t('type');
      break;
    }
    if ( ($form_state['values']['type'] == 'priority') || ($form_state['values']['type'] == 'type') ) {
      $active = 0;
      foreach ($form_state['values'] as $key => $var) {
        if ( (is_numeric($key)) ) {
          $active += $var['active'];
        }
      }
      if (!$active) {
        form_set_error('', t('One element should remain active!'));
      }
    }
    foreach ($form_state['values'] as $key => $var) {
      if ( (is_numeric($key)) ) {
        if (trim($var['name']) == '') {
          form_set_error($key .'][name', t('%name field is required.', array('%name' => $name) ) );
        }
        else {
          $result = db_query($SQL, $form_state['values']['gid'], $key, $var['name']);
          $row = db_fetch_array($result);

          if ( $row['num'] ) {
            form_set_error('', t('You must select a name for this %name of settings.', array('%name' => $name) ) );
          }
        }
      }
    }
  }
}

/**
 * ticket_admin_group_set_form_submit: csoport tulajdonsag beallitasa
 */
function ticket_admin_group_set_form_submit($form, &$form_state) {
  if ( $form_state['values']['op'] != t('Reset') ) {
    switch ($form_state['values']['type']) {
      case 'fixer':
        $SQL = "UPDATE {ticket_fixer} SET fixer_name = '%s', weight = %d, active = %d WHERE fixer_id = %d";
        $SQL_erase_def = "UPDATE {ticket_fixer} SET def = 0 WHERE fixer_id = %d";
        $SQL_new_def = "UPDATE {ticket_fixer} SET def = 1 WHERE gid = %d AND active = 1 LIMIT 1";
      break;

      case 'priority':
        $SQL = "UPDATE {ticket_priority} SET priority_name = '%s', weight = %d, active = %d WHERE priority_id = %d";
        $SQL_erase_def = "UPDATE {ticket_priority} SET def = 0 WHERE priority_id = %d";
        $SQL_new_def = "UPDATE {ticket_priority} SET def = 1 WHERE gid = %d AND active = 1 LIMIT 1";
      break;

      case 'scope':
        $SQL = "UPDATE {ticket_scope} SET scope_name = '%s', weight = %d, active = %d WHERE scope_id = %d";
        $SQL_erase_def = "UPDATE {ticket_scope} SET def = 0 WHERE scope_id = %d";
        $SQL_new_def = "UPDATE {ticket_scope} SET def = 1 WHERE gid = %d AND active = 1 LIMIT 1";
      break;

      case 'site':
        $SQL = "UPDATE {ticket_site} SET site_name = '%s', weight = %d, active = %d WHERE site_id = %d";
        $SQL_erase_def = "UPDATE {ticket_site} SET def = 0 WHERE site_id = %d";
        $SQL_new_def = "UPDATE {ticket_site} SET def = 1 WHERE gid = %d AND active = 1 LIMIT 1";
      break;

      case 'type':
        $SQL = "UPDATE {ticket_type} SET type_name = '%s', weight = %d, active = %d WHERE type_id = %d";
        $SQL_erase_def = "UPDATE {ticket_type} SET def = 0 WHERE type_id = %d";
        $SQL_new_def = "UPDATE {ticket_type} SET def = 1 WHERE gid = %d AND active = 1 LIMIT 1";
      break;
    }
    $new_def = 0;
    foreach ($form_state['values'] as $key => $var) {
      if ( is_numeric($key) ) {
        if ( ($var['active'] == 0) && ($var['default'] == 1) ) {
          $new_def = $key;
        }
        db_query($SQL, $var['name'], $var['weight'], $var['active'], $key);
      }
    }
    if ( $new_def ) {
      db_query($SQL_erase_def, $new_def);
      db_query($SQL_new_def, $form_state['values']['gid']);
    }
  }
}

/**
 * ticket_admin_group_set_def_form: csoport tulajdonsagokhoz tartozo altalanos form
 *                                  alapertelmezett ertek bealliashoz
 * @param $form_state - drupal form variable
 * @param $def  form settings
 * @return array $form  drupal forms
 */
function ticket_admin_group_set_def_form(&$form_state, $def) {
  /** default $action form elkeszitese */
  switch ($def['type']) {
    case 'fixer':
      $title = t('Default fixer');
    break;

    case 'priority':
      $title = t('Default priority');
    break;

    case 'scope':
      $title = t('Default scope');
    break;

    case 'site':
      $title = t('Default site');
    break;

    case 'type':
      $title = t('Default type');
    break;

    case 'status_open':
      $title = t('Default open status');
    break;

    case 'status_closed':
      $title = t('Default closed status');
    break;
  }

  $form['default'] = array(
    '#type' => 'fieldset',
    '#title' => $title .':',
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $form['default']['def'] = array(
    '#type' => 'select',
    '#options' => $def['var'],
    '#default_value' => $def['select'],
  );

  $form['default']['type'] = array(
    '#type' => 'value',
    '#value' => $def['type'],
  );

  $form['default']['gid'] = array(
    '#type' => 'value',
    '#value' => $def['gid'],
  );

  $form['default']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );

  return $form;
}

/**
 * ticket_admin_group_set_def_form_submit: csoport tulajdonsag alapertelmezett elem beallitasa
 */
function ticket_admin_group_set_def_form_submit($form, &$form_state) {
  switch ($form_state['values']['type']) {
    case 'fixer':
      $SQL0 = 'UPDATE {ticket_fixer} SET def = 0 WHERE gid = %d';
      $SQL1 = 'UPDATE {ticket_fixer} SET def = 1 WHERE fixer_id = %d';
    break;

    case 'priority':
      $SQL0 = 'UPDATE {ticket_priority} SET def = 0 WHERE gid = %d';
      $SQL1 = 'UPDATE {ticket_priority} SET def = 1 WHERE priority_id = %d';
    break;

    case 'scope':
      $SQL0 = 'UPDATE {ticket_scope} SET def = 0 WHERE gid = %d';
      $SQL1 = 'UPDATE {ticket_scope} SET def = 1 WHERE scope_id = %d';
    break;

    case 'site':
      $SQL0 = 'UPDATE {ticket_site} SET def = 0 WHERE gid = %d';
      $SQL1 = 'UPDATE {ticket_site} SET def = 1 WHERE site_id = %d';
    break;

    case 'type':
      $SQL0 = 'UPDATE {ticket_type} SET def = 0 WHERE gid = %d';
      $SQL1 = 'UPDATE {ticket_type} SET def = 1 WHERE type_id = %d';
    break;

    case 'status_open':
      $SQL0 = 'UPDATE {ticket_status} SET def = 0 WHERE closed = 0 AND gid = %d';
      $SQL1 = 'UPDATE {ticket_status} SET def = 1 WHERE closed = 0 AND status_id = %d';
    break;

    case 'status_closed':
      $SQL0 = 'UPDATE {ticket_status} SET def = 0 WHERE closed = 1 AND gid = %d';
      $SQL1 = 'UPDATE {ticket_status} SET def = 1 WHERE closed = 1 AND status_id = %d';
    break;
  }

  db_query($SQL0, $form_state['values']['gid']);
  db_query($SQL1, $form_state['values']['def']);
}


/**
 * ticket_admin_group_set_add_form: csoport tulajdonsagokhoz tartozo altalanos form
 *                                  ertek hozzaadasa bealliashoz
 * @param $form_state - drupal form variable
 * @param $gid  ticket group id
 * @return array $form  drupal forms
 */
function ticket_admin_group_set_add_form(&$form_state, $add) {
  /** add $action form elkeszitese */
  $form['add'] = array(
    '#type' => 'fieldset',
    '#title' => $add['txt']['fieldset'] .':',
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $form['add']['name'] = array(
    '#type' => 'textfield',
    '#title' => $add['txt']['name'],
    '#size' => 60,
    '#maxlength' => 255,
    '#required' => TRUE,
  );

  $form['add']['weight'] = array(
    '#type' => 'weight',
    '#title' => t('Weight'),
  );

  $form['add']['active'] = array(
    '#type' => 'select',
    '#title' => t('Active'),
    '#options' => array(
      '1' => t('Yes'),
      '0' => t('No'),
    ),
  );

  $form['add']['gid'] = array(
    '#type' => 'value',
    '#value' => $add['gid'],
  );

  $form['add']['type'] = array(
    '#type' => 'value',
    '#value' => $add['type'],
  );

  $form['add']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );

  return $form;
}

/**
 * ticket_admin_group_set_add_form_validate: add set formrol erkezo adatok ellenorzese
 */
function ticket_admin_group_set_add_form_validate($form, &$form_state) {
  /** azonos nevu $action egy csoporton belul nem johet letre */
  switch ($form_state['values']['type']) {
    case 'fixer':
      $SQL = "SELECT count(gid) as num FROM {ticket_fixer} WHERE gid = %d AND fixer_name = '%s'";
    break;

    case 'priority':
      $SQL = "SELECT count(gid) as num FROM {ticket_priority} WHERE gid = %d AND priority_name = '%s'";
    break;

    case 'scope':
      $SQL = "SELECT count(gid) as num FROM {ticket_scope} WHERE gid = %d AND scope_name = '%s'";
    break;

    case 'site':
      $SQL = "SELECT count(gid) as num FROM {ticket_site} WHERE gid = %d AND site_name = '%s'";
    break;

    case 'type':
      $SQL = "SELECT count(gid) as num FROM {ticket_type} WHERE gid = %d AND type_name = '%s'";
    break;
  }

  $result = db_query($SQL, $form_state['values']['gid'], $form_state['values']['name']);
  $row = db_fetch_array($result);
  if ( $row['num'] ) {
    form_set_error('', t('You must select a name for this %name of settings.', array('%name' => $form_state['values']['type']) ) );
  }
}

/**
 * ticket_admin_add_set_submit: [fixer|priority] hozzaadas
 */
function ticket_admin_group_set_add_form_submit($form, &$form_state) {
  switch ($form_state['values']['type']) {
    case 'fixer':
      $SQL = "INSERT INTO {ticket_fixer} (gid, fixer_name, weight, active) VALUES (%d, '%s', %d, %d)";
    break;

    case 'priority':
      $SQL = "INSERT INTO {ticket_priority} (gid, priority_name, weight, active) VALUES (%d, '%s', %d, %d)";
    break;

    case 'scope':
      $SQL = "INSERT INTO {ticket_scope} (gid, scope_name, weight, active) VALUES (%d, '%s', %d, %d)";
    break;

    case 'site':
      $SQL = "INSERT INTO {ticket_site} (gid, site_name, weight, active) VALUES (%d, '%s', %d, %d)";
    break;

    case 'type':
      $SQL = "INSERT INTO {ticket_type} (gid, type_name, weight, active) VALUES (%d, '%s', %d, %d)";
    break;
  }
  db_query($SQL, $form_state['values']['gid'], $form_state['values']['name'], $form_state['values']['weight'], $form_state['values']['active']);
  _ticket_admin_chk_db_default($form_state['values']['gid'], $form_state['values']['type']);
}

/**
 * ticket_admin_group_fixer_edit: javito hozzaadas, szerkesztes
 * @param $gid - group id
 */
function ticket_admin_group_fixer_edit($gid) {
  $add['gid'] = $set['gid'] = $def['gid'] = $gid;
  $add['type'] = $set['type'] = $def['type'] = 'fixer';

  $output = '';
  /** Csoporthoz tartozo $action lista lekerdezese */
  $result = db_query('SELECT * FROM {ticket_fixer} WHERE gid = %d  ORDER BY active DESC, weight ASC, fixer_name ASC', $gid);

  $num_rows = FALSE;
  /** lekerdezes feldolgozasa */
  while ($row = db_fetch_array($result)) {
    $set['var'][$row['fixer_id']]['name'] = $row['fixer_name'];
    $set['var'][$row['fixer_id']]['weight'] = $row['weight'];
    $set['var'][$row['fixer_id']]['active'] = $row['active'];
    $set['var'][$row['fixer_id']]['default'] = $row['def'];
    /** default ertekek elokeszitese */
    if ($row['active']) {
      $def['var'][$row['fixer_id']] = $row['fixer_name'];
      if ($row['def']) {
        $def['select'] = $row['fixer_id'];
      }
    }
    $num_rows = TRUE;
  }
  if ( $num_rows ) {
    /** fixer form elkeszitese */
    $output .= drupal_get_form('ticket_admin_group_set_form', $set);
    if ( isset($def['var']) ) {
      $output .= drupal_get_form('ticket_admin_group_set_def_form', $def);
    }
  }

  $add['txt']['fieldset'] = t('Add fixer');
  $add['txt']['name'] = t('Fixer name');
  $output .= drupal_get_form('ticket_admin_group_set_add_form', $add);

  drupal_set_title( t('!unit_name &rArr; !group_name', array('!unit_name' => _ticket_unit_name('', $gid), '!group_name' => _ticket_group_name($gid)) ) );

  return $output;
}

/**
 * ticket_admin_group_priority_edit: prioritas hozzaadas, szerkesztes
 * @param $gid - group id
 */
function ticket_admin_group_priority_edit($gid) {
  $add['gid'] = $set['gid'] = $def['gid'] = $gid;
  $add['type'] = $set['type'] = $def['type'] = 'priority';

  $output = '';
  /** Csoporthoz tartozo $action lista lekerdezese */
  $result = db_query('SELECT * FROM {ticket_priority} WHERE gid = %d  ORDER BY active DESC, weight ASC, priority_name ASC', $gid);

  $num_rows = FALSE;
  /** lekerdezes feldolgozasa */
  while ($row = db_fetch_array($result)) {
    $set['var'][$row['priority_id']]['name'] = $row['priority_name'];
    $set['var'][$row['priority_id']]['weight'] = $row['weight'];
    $set['var'][$row['priority_id']]['active'] = $row['active'];
    $set['var'][$row['priority_id']]['default'] = $row['def'];
    /** default ertekek elokeszitese */
    if ($row['active']) {
      $def['var'][$row['priority_id']] = $row['priority_name'];
      if ($row['def']) {
        $def['select'] = $row['priority_id'];
      }
    }
    $num_rows = TRUE;
  }
  if ( $num_rows ) {
    /** priority form elkeszitese */
    $output .= drupal_get_form('ticket_admin_group_set_form', $set);
    if ( isset($def['var']) ) {
      $output .= drupal_get_form('ticket_admin_group_set_def_form', $def);
    }
  }

  $add['txt']['fieldset'] = t('Add priority');
  $add['txt']['name'] = t('Priority name');
  $output .= drupal_get_form('ticket_admin_group_set_add_form', $add);

  drupal_set_title( t('!unit_name &rArr; !group_name', array('!unit_name' => _ticket_unit_name('', $gid), '!group_name' => _ticket_group_name($gid)) ) );

  return $output;
}

/**
 * ticket_admin_group_scope_edit: hatokor hozzaadas, szerkesztes
 * @param $gid - group id
 */
function ticket_admin_group_scope_edit($gid) {
  $add['gid'] = $set['gid'] = $def['gid'] = $gid;
  $add['type'] = $set['type'] = $def['type'] = 'scope';

  $output = '';
  /** Csoporthoz tartozo $action lista lekerdezese */
  $result = db_query('SELECT * FROM {ticket_scope} WHERE gid = %d  ORDER BY active DESC, weight ASC, scope_name ASC', $gid);

  $num_rows = FALSE;
  /** lekerdezes feldolgozasa */
  while ($row = db_fetch_array($result)) {
    $set['var'][$row['scope_id']]['name'] = $row['scope_name'];
    $set['var'][$row['scope_id']]['weight'] = $row['weight'];
    $set['var'][$row['scope_id']]['active'] = $row['active'];
    $set['var'][$row['scope_id']]['default'] = $row['def'];
    /** default ertekek elokeszitese */
    if ($row['active']) {
      $def['var'][$row['scope_id']] = $row['scope_name'];
      if ($row['def']) {
        $def['select'] = $row['scope_id'];
      }
    }
    $num_rows = TRUE;
  }
  if ( $num_rows ) {
    /** scope form elkeszitese */
    $output .= drupal_get_form('ticket_admin_group_set_form', $set);
    if ( isset($def['var']) ) {
      $output .= drupal_get_form('ticket_admin_group_set_def_form', $def);
    }
  }

  $add['txt']['fieldset'] = t('Add scope');
  $add['txt']['name'] = t('Scope name');
  $output .= drupal_get_form('ticket_admin_group_set_add_form', $add);

  drupal_set_title( t('!unit_name &rArr; !group_name', array('!unit_name' => _ticket_unit_name('', $gid), '!group_name' => _ticket_group_name($gid)) ) );

  return $output;
}

/**
 * ticket_admin_group_site_edit: helyszin hozzaadas, szerkesztes
 * @param $gid - group id
 */
function ticket_admin_group_site_edit($gid) {
  $add['gid'] = $set['gid'] = $def['gid'] = $gid;
  $add['type'] = $set['type'] = $def['type'] = 'site';

  $output = '';
  /** Csoporthoz tartozo $action lista lekerdezese */
  $result = db_query('SELECT * FROM {ticket_site} WHERE gid = %d  ORDER BY active DESC, weight ASC, site_name ASC', $gid);

  $num_rows = FALSE;
  /** lekerdezes feldolgozasa */
  while ($row = db_fetch_array($result)) {
    $set['var'][$row['site_id']]['name'] = $row['site_name'];
    $set['var'][$row['site_id']]['weight'] = $row['weight'];
    $set['var'][$row['site_id']]['active'] = $row['active'];
    $set['var'][$row['site_id']]['default'] = $row['def'];
    /** default ertekek elokeszitese */
    if ($row['active']) {
      $def['var'][$row['site_id']] = $row['site_name'];
      if ($row['def']) {
        $def['select'] = $row['site_id'];
      }
    }
    $num_rows = TRUE;
  }
  if ( $num_rows ) {
    /** site form elkeszitese */
    $output .= drupal_get_form('ticket_admin_group_set_form', $set);
    if ( isset($def['var']) ) {
      $output .= drupal_get_form('ticket_admin_group_set_def_form', $def);
    }
  }

  $add['txt']['fieldset'] = t('Add site');
  $add['txt']['name'] = t('Site name');
  $output .= drupal_get_form('ticket_admin_group_set_add_form', $add);

  drupal_set_title( t('!unit_name &rArr; !group_name', array('!unit_name' => _ticket_unit_name('', $gid), '!group_name' => _ticket_group_name($gid)) ) );

  return $output;
}

/**
 * ticket_admin_group_type_edit: tipus hozzaadas, szerkesztes
 * @param $gid - group id
 */
function ticket_admin_group_type_edit($gid) {
  $add['gid'] = $set['gid'] = $def['gid'] = $gid;
  $add['type'] = $set['type'] = $def['type'] = 'type';

  $output = '';
  /** Csoporthoz tartozo $action lista lekerdezese */
  $result = db_query('SELECT * FROM {ticket_type} WHERE gid = %d  ORDER BY active DESC, weight ASC, type_name ASC', $gid);

  $num_rows = FALSE;
  /** lekerdezes feldolgozasa */
  while ($row = db_fetch_array($result)) {
    $set['var'][$row['type_id']]['name'] = $row['type_name'];
    $set['var'][$row['type_id']]['weight'] = $row['weight'];
    $set['var'][$row['type_id']]['active'] = $row['active'];
    $set['var'][$row['type_id']]['default'] = $row['def'];
    /** default ertekek elokeszitese */
    if ($row['active']) {
      $def['var'][$row['type_id']] = $row['type_name'];
      if ($row['def']) {
        $def['select'] = $row['type_id'];
      }
    }
    $num_rows = TRUE;
  }
  if ( $num_rows ) {
    /** type form elkeszitese */
    $output .= drupal_get_form('ticket_admin_group_set_form', $set);
    if ( isset($def['var']) ) {
      $output .= drupal_get_form('ticket_admin_group_set_def_form', $def);
    }
  }

  $add['txt']['fieldset'] = t('Add type');
  $add['txt']['name'] = t('Type name');
  $output .= drupal_get_form('ticket_admin_group_set_add_form', $add);

  drupal_set_title( t('!unit_name &rArr; !group_name', array('!unit_name' => _ticket_unit_name('', $gid), '!group_name' => _ticket_group_name($gid)) ) );

  return $output;
}

/************************************************************
 ************************** E-MAIL **************************
 ************************************************************/

/**
 * ticket_admin_group_email_form: csoport tulajdonsagokhoz tartozo altalanos form
 * @param $form_state - drupal form variable
 * @param $set  form settings
 * @return array $form  drupal forms
 */
function ticket_admin_group_email_form(&$form_state, $set) {
  /** tree form struktura bekapcsolasa */
  $form['#tree'] = TRUE;
  foreach ($set['var'] as $key => $var) {
    $form[$key]['def'] = array(
      '#type' => 'checkbox',
      '#default_value' => $var['def'],
    );
    $form[$key]['name'] = array(
      '#type' => 'textfield',
      '#default_value' => $var['name'],
      '#size' => 40,
      '#maxlength' => 255,
    );
    $form[$key]['mailto'] = array(
      '#type' => 'textfield',
      '#default_value' => $var['mailto'],
      '#size' => 40,
      '#maxlength' => 255,
    );
    $form[$key]['active'] = array(
      '#type' => 'checkbox',
      '#default_value' => $var['active'],
    );
    $form[$key]['default'] = array(
      '#type' => 'value',
      '#default_value' => $var['default'],
    );
  }

  $form['gid'] = array(
    '#type' => 'value',
    '#value' => $set['gid'],
  );

  $form['reset'] = array(
    '#type' => 'submit',
    '#value' => t('Reset')
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );
  return $form;
}

/**
 * ticket_admin_group_email_form_validate: set mail formrol erkezo adatok ellenorzese
 */
function ticket_admin_group_email_form_validate($form, &$form_state) {
  /** ures mezo es azonos nevu mail name nem lehet */
  if ( $form_state['values']['op'] != t('Reset') ) {
    foreach ($form_state['values'] as $key => $var) {
      if ( (is_numeric($key)) ) {
        if ($var['name'] == '') {
          form_set_error($key .'][name', t('%name field is required.', array('%name' => t('E-mail name') ) ) );
        }
        elseif ($form[$key]['mailto'] == '') {
          form_set_error($key .'][mailto', t('%name field is required.', array('%name' => t('E-mail address') ) ) );
        }
        else {
          $SQL = "SELECT count(gid) as num FROM {ticket_email} WHERE gid = %d AND email_id <> %d AND email_name = '%s'";
          $result = db_query($SQL, $form_state['values']['gid'], $key, $var['name']);
          $row = db_fetch_array($result);

          if ( !valid_email_address($var['mailto']) ) {
            form_set_error($key .'][mailto', t('Faulty e-mail address!'));
          }

          if ( $row['num'] ) {
            form_set_error('', t('You must select a name for this mail of settings.'));
          }
        }
      }
    }
  }
}

/**
 * ticket_admin_group_email_form_submit: mail beallitas
 */
function ticket_admin_group_email_form_submit($form, &$form_state) {
  /** mail settings */
  if ( $form_state['values']['op'] != t('Reset') ) {
    foreach ($form_state['values'] as $key => $var) {
      if ( (is_numeric($key)) ) {
        $SQL = "UPDATE {ticket_email} SET email_name = '%s', mailto = '%s', def = %d, active = %d WHERE email_id = %d";
        db_query($SQL, $var['name'], $var['mailto'], $var['def'], $var['active'], $key);
      }
    }
  }
}

/**
 * ticket_admin_group_email_add_form: csoport e-mail tulajdonsagahoz tartozo form
 * @param $form_state - drupal form variable
 * @param $gid  ticket group id
 * @return array $form  drupal forms
 */
function ticket_admin_group_email_add_form(&$form_state, $gid) {
  /** add $action form elkeszitese */
  $form['add'] = array(
    '#type' => 'fieldset',
    '#title' => t('Add e-mail address') .':',
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $form['add']['name'] = array(
    '#type' => 'textfield',
    '#title' => t('E-mail name'),
    '#size' => 60,
    '#maxlength' => 255,
    '#required' => TRUE,
  );

  $form['add']['mailto'] = array(
    '#type' => 'textfield',
    '#title' => t('E-mail address'),
    '#size' => 60,
    '#maxlength' => 255,
    '#required' => TRUE,
  );

  $form['add']['def'] = array(
    '#type' => 'select',
    '#title' => t('Default'),
    '#default_value' => 0,
    '#options' => array(
      '1' => t('Yes'),
      '0' => t('No'),
    ),
  );

  $form['add']['active'] = array(
    '#type' => 'select',
    '#title' => t('Active'),
    '#options' => array(
      '1' => t('Yes'),
      '0' => t('No'),
  ),
  );

  $form['add']['gid'] = array(
    '#type' => 'value',
    '#value' => $gid,
  );

  $form['add']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );

  return $form;
}

/**
 * ticket_admin_group_email_add_form_validate: add mail formrol erkezo adatok ellenorzese
 */
function ticket_admin_group_email_add_form_validate($form, &$form_state) {
  /** azonos nevu mail egy csoporton belul nem johet letre */
  $result = db_query("SELECT count(gid) as num FROM {ticket_email} WHERE gid = %d AND email_name = '%s'", $form_state['values']['gid'], $form_state['values']['name']);
  $row = db_fetch_array($result);
  if ( $row['num'] ) {
    form_set_error('', t('You must select a name for this mail of settings.'));
  }
  if ( !valid_email_address($form_state['values']['mailto']) ) {
    form_set_error('mailto', t('Faulty e-mail address!'));
  }
}

/**
 * ticket_admin_group_email_add_form_submit: mail hozzaadas
 */
function ticket_admin_group_email_add_form_submit($form, &$form_state) {
  /** mail hozzaadasa */
  $SQL = 'INSERT INTO {ticket_email} (gid, email_name, mailto, def, active)';
  $SQL .= " VALUES (%d, '%s', '%s', %d, %d)";
  db_query($SQL, $form_state['values']['gid'], $form_state['values']['name'], $form_state['values']['mailto'], $form_state['values']['def'], $form_state['values']['active']);
}


/**
 * ticket_admin_group_mail_edit: E-mail cim hozzaadas, szerkesztes
 * @param $gid - group id
 */
function ticket_admin_group_email_edit($gid) {
  $output = '';

  $row = db_fetch_array(db_query('SELECT mail_address FROM {ticket_template} WHERE gid = %d', $gid));
  if ( empty($row['mail_address']) && !count($_POST) ) {
    drupal_set_message(t('There is no group e-mail address given. No mail will be delivered about the ticket.'), 'warning');
  }
  /** Csoporthoz tartozo $action lista lekerdezese */
  $result = db_query('SELECT * FROM {ticket_email} WHERE gid = %d ORDER BY active DESC, email_name ASC', $gid);

  $num_rows = FALSE;
  /** lekerdezes feldolgozasa */
  while ($row = db_fetch_array($result)) {
    $set['var'][$row['email_id']]['def'] = $row['def'];
    $set['var'][$row['email_id']]['name'] = $row['email_name'];
    $set['var'][$row['email_id']]['mailto'] = $row['mailto'];
    $set['var'][$row['email_id']]['active'] = $row['active'];
    $set['var'][$row['email_id']]['default'] = $row['def'];
    $num_rows = TRUE;
  }
  if ( $num_rows ) {
    /** fixer form elkeszitese */
    $set['gid'] = $gid;
    $output .= drupal_get_form('ticket_admin_group_email_form', $set);
  }

  $output .= drupal_get_form('ticket_admin_group_email_add_form', $gid);

  drupal_set_title( t('!unit_name &rArr; !group_name', array('!unit_name' => _ticket_unit_name('', $gid), '!group_name' => _ticket_group_name($gid)) ) );

  return $output;
}

/************************************************************
 ************************** STATUS **************************
 ************************************************************/

/**
 * ticket_admin_group_status_form: csoport tulajdonsagokhoz tartozo altalanos form
 * @param $form_state - drupal form variable
 * @param $set  form settings
 * @return array $form  drupal forms
 */
function ticket_admin_group_status_form(&$form_state, $set) {
  global $ticket_conf;

  foreach ($ticket_conf['stage'] as $key => $value) {
    $stage[$key] = 'stage-'. $key;
  }

  /** tree form struktura bekapcsolasa */
  $form['#tree'] = TRUE;
  foreach ($set['var'] as $key => $var) {
    $form[$key]['name'] = array(
      '#type' => 'textfield',
      '#default_value' => $var['name'],
      '#size' => 40,
      '#maxlength' => 255,
    );
    $form[$key]['closed'] = array(
      '#type' => 'select',
      '#options' => array('1' => t('Yes'), '0' => t('No') ),
      '#default_value' => $var['closed'],
    );
    $form[$key]['weight'] = array(
      '#type' => 'weight',
      "#type" => "weight",
      '#default_value' => $var['weight'],
    );
    $form[$key]['active'] = array(
      '#type' => 'checkbox',
      '#default_value' => $var['active'],
    );
    $form[$key]['stage'] = array(
      '#input' => TRUE,
      '#type' => 'select',
      '#options' => $ticket_conf['stage'],
      '#class' => $stage,
      '#default_value' => $var['stage'],
      '#theme' => 'color_select',
    );

    $form[$key]['default'] = array(
      '#type' => 'value',
      '#default_value' => $var['default'],
    );
  }

  $form['gid'] = array(
    '#type' => 'value',
    '#value' => $set['gid'],
  );

  $form['reset'] = array(
    '#type' => 'submit',
    '#value' => t('Reset')
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );
  return $form;
}

/**
 * ticket_admin_group_status_form_submit: status beallitas
 */
function ticket_admin_group_status_form_submit($form, &$form_state) {
  /** status settings */
  if ( $form_state['values']['op'] != t('Reset') ) {
    $new_def[0] = $new_def[1] = 0;
    foreach ($form_state['values'] as $key => $var) {
      if ( is_numeric($key) ) {
        if ( ($var['active'] == 0) && ($var['default'] == 1) ) {
          $new_def[$var['closed']] = $key;
        }
        $SQL = "UPDATE {ticket_status} SET status_name = '%s', weight = %d, closed = %d, stage = %d, active = %d WHERE status_id = %d";
        db_query($SQL, $var['name'], $var['weight'], $var['closed'], $var['stage'], $var['active'], $key);
      }
    }
    if ( $new_def[0] ) {
      db_query("UPDATE {ticket_status} SET def = 0 WHERE status_id = %d", $new_def[0]);
      db_query("UPDATE {ticket_status} SET def = 1 WHERE gid = %d AND closed = 0 AND active = 1 LIMIT 1", $form_state['values']['gid']);
    }

    if ( $new_def[1] ) {
      db_query("UPDATE {ticket_status} SET def = 0 WHERE status_id = %d", $new_def[1]);
      db_query("UPDATE {ticket_status} SET def = 1 WHERE gid = %d AND closed = 1 AND active = 1 LIMIT 1", $form_state['values']['gid']);
    }
  }
}

/**
 * ticket_admin_group_status_form_validate: status formrol erkezo adatok ellenorzese
 */
function ticket_admin_group_status_form_validate($form, &$form_state) {
  /** ures mezo es azonos nevu status nem lehet */
  if ( $form_state['values']['op'] != t('Reset') ) {
    $active['0'] = $active['1'] = 0;
    foreach ($form_state['values'] as $array) {
      if ( is_array($array) ) {
        $active[$array['closed']] += $array['active'];
      }
    }
    if (!$active['0']) {
      form_set_error('', t('At least one non-closed type element should remain active!'));
    }
    if (!$active['1']) {
      form_set_error(' ', t('At least one closed type element should remain active!'));
    }

    foreach ($form_state['values'] as $key => $var) {
      if ( is_numeric($key) ) {
        if (trim($var['name']) == '') {
          form_set_error($key .'][name', t('%name field is required.', array('%name' => t('status') ) ) );
        }
        else {
          $SQL = "SELECT count(gid) as num FROM {ticket_status} WHERE gid = %d AND status_id <> %d AND status_name = '%s'";
          $result = db_query($SQL, $form_state['values']['gid'], $key, $var['name']);
          $row = db_fetch_array($result);

          if ( $row['num'] ) {
            form_set_error('', t('You must select a name for this status of settings.'));
          }
        }
      }
    }
  }
}



/**
 * ticket_admin_group_status_add_form: csoport status tulajdonsagahoz tartozo form
 * @param $form_state - drupal form variable
 * @param $gid  ticket group id
 * @return array $form  drupal forms
 */
function ticket_admin_group_status_add_form(&$form_state, $gid) {
  global $ticket_conf;

  foreach ($ticket_conf['stage'] as $key => $value) {
    $stage[$key] = 'stage-'. $key;
  }

  /** add $action form elkeszitese */
  $form['add'] = array(
    '#type' => 'fieldset',
    '#title' => t('Add status') .':',
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );
  $form['add']['name'] = array(
    '#type' => 'textfield',
    '#title' => t('Status name'),
    '#size' => 60,
    '#maxlength' => 255,
    '#required' => TRUE,
  );

  $form['add']['weight'] = array(
    '#type' => 'weight',
    '#title' => t('Weight'),
    '#default_value' => 0,
  );

  $form['add']['stage'] = array(
    '#input' => TRUE,
    '#type' => 'select',
    '#title' => t('Stage'),
    '#options' => $ticket_conf['stage'],
    '#class' => $stage,
    '#default_value' => '',
    '#theme' => 'color_select',
  );

  $form['add']['closed'] = array(
    '#type' => 'select',
    '#title' => t('Closed'),
    '#default_value' => 0,
    '#options' => array(
      '1' => t('Yes'),
      '0' => t('No'),
    ),
  );

  $form['add']['active'] = array(
    '#type' => 'select',
    '#title' => t('Active'),
    '#options' => array(
      '1' => t('Yes'),
      '0' => t('No'),
    ),
  );

  $form['add']['gid'] = array(
    '#type' => 'value',
    '#value' => $gid,
  );

  $form['add']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );

  return $form;
}

/**
 * ticket_admin_group_status_add_form_validate: add status formrol erkezo adatok ellenorzese
 */
function ticket_admin_group_status_add_form_validate($form, &$form_state) {
  /** azonos nevu status egy csoporton belul nem johet letre */
  $result = db_query("SELECT count(gid) as num FROM {ticket_status} WHERE gid = %d AND status_name = '%s'", $form_state['values']['gid'], $form_state['values']['name']);
  $row = db_fetch_array($result);
  if ( $row['num'] ) {
    form_set_error('', t('You must select a name for this mail of settings.'));
  }
}

/**
 * ticket_admin_group_status_add_form_submit: status hozzaadas
 */
function ticket_admin_group_status_add_form_submit($form, &$form_state) {
  /** mail hozzaadasa */
  $SQL = 'INSERT INTO {ticket_status} (gid, status_name, weight, stage, closed, active)';
  $SQL .= " VALUES (%d, '%s', %d, %d, %d, %d)";
  db_query($SQL, $form_state['values']['gid'], $form_state['values']['name'], $form_state['values']['weight'], $form_state['values']['stage'], $form_state['values']['closed'], $form_state['values']['active']);
  _ticket_admin_chk_db_default($form_state['values']['gid'], 'status');
}

/**
 * ticket_admin_group_status_edit: status hozzaadas, szerkesztes
 * @param $gid - group id
 */
function ticket_admin_group_status_edit($gid) {
  $set['gid'] = $def[0]['gid'] = $def[1]['gid'] = $gid;
  $def[0]['type'] = 'status_open';
  $def[1]['type'] = 'status_closed';
  drupal_add_css(drupal_get_path('module', 'ticket') .'/ticket.css');

  $output = '';
  /** Csoporthoz tartozo $action lista lekerdezese */
  $result = db_query('SELECT * FROM {ticket_status} WHERE gid = %d  ORDER BY active DESC, closed ASC, weight ASC, status_name ASC', $gid);

  $num_rows = FALSE;
  /** lekerdezes feldolgozasa */
  while ($row = db_fetch_array($result)) {
    $set['var'][$row['status_id']]['name'] = $row['status_name'];
    $set['var'][$row['status_id']]['closed'] = $row['closed'];
    $set['var'][$row['status_id']]['active'] = $row['active'];
    $set['var'][$row['status_id']]['weight'] = $row['weight'];
    $set['var'][$row['status_id']]['stage'] = $row['stage'];

    /** default ertekek elokeszitese */
    if ($row['active']) {
      $def[$row['closed']]['var'][$row['status_id']] = $row['status_name'];
      if ($row['def']) {
        $def[$row['closed']]['select'] = $row['status_id'];
      }
    }
    $num_rows = TRUE;
  }
  if ( $num_rows ) {
    /** status form elkeszitese */
    $output .= drupal_get_form('ticket_admin_group_status_form', $set);
    if ( isset($def[0]['var']) ) {
      $output .= drupal_get_form('ticket_admin_group_set_def_form', $def[0]);
    }
    if ( isset($def[1]['var']) ) {
      $output .= drupal_get_form('ticket_admin_group_set_def_form', $def[1]);
    }
  }

  $output .= drupal_get_form('ticket_admin_group_status_add_form', $gid);

  drupal_set_title( t('!unit_name &rArr; !group_name', array('!unit_name' => _ticket_unit_name('', $gid), '!group_name' => _ticket_group_name($gid)) ) );

  return $output;
}
