<?php
// $Id: ticket.pages.inc,v 1.2.2.4 2009/07/22 13:29:27 york Exp $

/**
 * _ticket_chk_emails: e-mail felsorolasban levo mailcimek ellenorzese.
 * @param: $emails - e-mail cimek
 */
function _ticket_chk_emails($emails) {
  $emails =  str_replace(',', ' ', $emails);
  $emails =  str_replace('  ', ' ', $emails);
  $emails = explode(' ', $emails);

  foreach ($emails as $email) {
    $email = trim($email);
    if ( ($email != '') && !(valid_email_address($email)) ) {
      return FALSE;
    }
  }
  return TRUE;
}

/**
 * _ticket_mail_send: level kuldese
 * @param $gid - group id
 * @param $tid - ticket id
 * @param $type - mail type
 */
function _ticket_mail_send($gid, $tid, $type = 0) {
  // ticket csoporthoz tartozo minta lekerdezese
  $result = db_query("SELECT * FROM {ticket_template} WHERE gid = %d", $gid);
  $template = db_fetch_array($result);

  // ha nincs meg adva felado cim akkor nem kerul kikuldesre level.
  if ($template['mailto'] != '') {
    // $mail valtozoba kerul a felado cime
    $mail['mailfrom'] = $template['mailto'];

    // akik masolatot kapnak a levelrol
    $result = db_query("SELECT cc FROM {ticket_ticket} WHERE tid = %d", $tid);
    $row = db_fetch_array($result);
    $mail['cc'] = implode(', ', explode(' ', str_replace(', ', ' ', $row['cc']) ) );

    // akiknek kikuldesre kerul a level
    $SQL = "SELECT tm.mailto, tm.mail_name FROM {ticket_mail} tm, {ticket_rel_ticket_mail} trm WHERE trm.tid = %d AND trm.mail_id = tm.mail_id";
    $result = db_query($SQL, $tid);
    $mailto = array();
    while ($row = db_fetch_array($result)) {
      $mailto[] = $row['mail_name'] .' <'. $row['mailto'] .'>';
    }
    $mail['mailto'] = implode(', ', $mailto);

    // ticket minta kiertekelese
    _ticket_mail_template_ticket($gid, $tid, $template);
    // $type = 0 - ha uj ticket keszult
    // $type = 1 - ha uj esemeny kovetkezett be
    // $type = 2 - ha a ticket lezarasra kerult
    if ($type) {
      // esemeny minta kiertekelese
      _ticket_mail_template_event($gid, $tid, $template);

      if ( ($template['esubject'] == '') || ($type == 2)) {
        $mail['subject'] = $template['tsubject'];
      }
      else {
        $mail['subject'] = $template['esubject'];
      }
      // beallitasoknak megfeleloen osszeallitja a leveltartalmat
      if ( ($template['e_type'] <= 1) || ($type == 2)) {
        if ($template['e_pos']) {
          $mail['message'] = $template['tt_header'] ."\n". $template['tt_body'] ."\n". $template['event'] ."\n". $template['tt_footer'];
        }
        else {
          $mail['message'] = $template['tt_header'] ."\n". $template['event'] ."\n". $template['tt_body'] ."\n". $template['tt_footer'];
        }

      }
      else {
        $mail['message'] = $template['tt_header'] ."\n". $template['event'] ."\n". $template['tt_footer'];
      }
    }
    else {
      $mail['subject'] = $template['tsubject'];
      $mail['message'] = $template['tt_header'] ."\n". $template['tt_body'] ."\n". $template['tt_footer'];
    }
    // a level szelesegenek beallitasa
    $mail['message'] = wordwrap($mail['message'], 70);
    $mail['message'] = str_replace("\n.", "\n..", $mail['message']);

    // level fejlecenek elkeszitese
    $mail['header'] = "From: ". $mail['mailfrom'] ."\nReply-to: ". $mail['mailfrom'] ."\nX-Mailer: Drupal";
    if ($mail['cc'] != '') {
      $mail['header'] .= "\nCC: ". $mail['cc'];
    }
    // e-mail elkuldese
    user_mail($mail['mailto'], $mail['subject'], $mail['message'], $mail['header']);
  }
}

/**
 * _ticket_list_sql_sort: ticket lekerdezesek kiratasanak alapertelmezett sorrendje.
 */
function _ticket_list_sql_sort() {
  if ( empty($_GET['order']) ) {
    if ( empty($_SESSION['ticket_list_order']) ) {
      $_SESSION['ticket_list_order'] = 'Date updated';
    }
    $_GET['order'] = $_SESSION['ticket_list_order'];
  }
  else {
    $_SESSION['ticket_list_order'] = $_GET['order'];
  }

  if ( empty($_GET['sort']) ) {
    if ( empty($_SESSION['ticket_list_sort']) ) {
      $_SESSION['ticket_list_sort'] = 'asc';
    }
    $_GET['sort'] = $_SESSION['ticket_list_sort'];
  }
  else {
    $_SESSION['ticket_list_sort'] = $_GET['sort'];
  }
}

/**
 * _ticket_list_table: ticket lekerdezesek kiratasa.
 * @param $result - SQL result
 * @param $u_id - unit id
 */
function _ticket_list_table($result, $u_id) {
  $rows = array();
  // tablazat sorainak elkeszitese
  while ($row = db_fetch_array($result)) {
    $row['summary'] = l($row['summary'], 'ticket/'. $u_id .'/'. $row['gid'] .'/'. $row['tid']);
    $row['tid'] = l($row['tid'], 'ticket/'. $u_id .'/'. $row['gid'] .'/'. $row['tid']);
    $row['name'] = theme('username', user_load($row['uid']));

    $rows[] = array(
    array('data' => $row['tid']),
    array('data' => $row['summary']),
    array('data' => $row['type_name']),
    array('data' => $row['status_name'], 'class' => 'stage-'. $row['stage']),
    array('data' => $row['name']),
    array('data' => $row['priority_name'], 'class' => 'priority-'. $row['weight']),
    array('data' => format_date($row['start'], 'small'), 'class' => 'date'),
    array('data' => format_date($row['created'], 'small'), 'class' => 'date'),
    array('data' => $row['num']),
    );
  }
  return $rows;
}

/**
 * _ticket_file_save: file elmentese az adatbazisba
 */
function _ticket_file_save($tid, $eid, $uid, $file) {
  $data = @file_get_contents($file['filepath']);
  $SQL = "INSERT INTO {ticket_files} (fid, tid, eid, uid, filename, filemime, filesize, timestamp, list, data)";
  $SQL .= " VALUES (%d, %d, %d, %d, '%s', '%s', %d, %d, %d, '%s')";
  db_query($SQL, $file['fid'], $tid, $eid, $uid, $file['filename'], $file['filemime'], $file['filesize'], $file['timestamp'], $file['list'], $data );
  _ticket_file_delete($file);
}

/**
 * _ticket_file_delete: az adatbazisba exportalt file torlese a hattertarrol
 */
function _ticket_file_delete($file) {
  file_delete($file['filepath']);
  $result = db_query("DELETE FROM {files} WHERE fid = %d", $file['fid']);
}

/**
 * ticket_info: ticket unitok es csoportok rovid ismertetoje
 * @param: $u_id - unit id
 */
function ticket_info($u_id = NULL) {
  // theme_add_style($path = 'modules/ticket/style.css', $media = 'all');
  // a megjeleno menukhoz informacio lekerdezese
  if ( is_numeric($u_id) ) {
    $SQL = "SELECT u_id, unit_name, description FROM {ticket_unit} WHERE active = 1 AND u_id = %d ORDER BY weight ASC, unit_name ASC";
    $result = db_query($SQL, $u_id);
  }
  elseif ( empty($u_id) ) {
    $SQL = "SELECT u_id, unit_name, description FROM {ticket_unit} WHERE active = 1 ORDER BY weight ASC, unit_name ASC";
    $result = db_query($SQL);
  }

  $num_rows = FALSE;
  while ($row = db_fetch_array($result)) {
    if (ticket_access(array('ticket reader', 'ticket outsider', 'ticket manager'), $row['u_id'], '*')) {
      $num_rows = TRUE;
      $t_info[$row['u_id']]['name'] = $row['unit_name'];
      $t_info[$row['u_id']]['desc'] = $row['description'];
      $SQL = "SELECT gid, group_name, description FROM {ticket_group} WHERE active = 1 AND u_id = %d ORDER BY weight ASC, group_name ASC";
      $result_g = db_query($SQL, $row['u_id']);
      while ($row_g = db_fetch_array($result_g)) {
        if (ticket_access(array('ticket reader', 'ticket outsider', 'ticket manager'), $row['u_id'], '*')) {
          $t_info[$row['u_id']]['groups'][$row_g['gid']]['name'] = $row_g['group_name'];
          $t_info[$row['u_id']]['groups'][$row_g['gid']]['access'] = ticket_access(array('ticket manager', 'ticket outsider'), $row['u_id'], $row_g['gid']);
          $t_info[$row['u_id']]['groups'][$row_g['gid']]['desc'] = $row_g['description'];
        }
      }
    }
  }

  if ($num_rows) {
    return theme('ticket_info', $t_info);
  }
  elseif ( $u_id == NULL ) {
    return '';
  }
  else {
    drupal_goto('ticket');
  }
}

/**
 * theme_ticket_info: ticket unitok es csoportok rovid ismertetoje
 * @param: $t_info - ticket unitok es csoportok rovid ismertetojet tartalmazza
 */
function theme_ticket_info($t_infos) {
  // lista kiiratasa
  drupal_add_css(drupal_get_path('module', 'ticket') .'/ticket.css');

  $output = '<div id="ticket"> <ul>';
  foreach ($t_infos as $key => $t_info) {
    // unit hozza adasa a listahoz
    $output .= '<li class="ticket-unit">'. l($t_info['name'], 'ticket/'. $key);
    if ($t_info['desc'] != '') {
      $output .= '<ul><li class = "ticket_desc">'. $t_info['desc'] .'</li>';
    }
    // csoportok hozza adasa a listahoz
    if ( count($t_info['groups']) ) {
      foreach ($t_info['groups'] as $gkey => $info) {
        if ( $gkey ) {
          $output .= '<li class="ticket-group">'. l($info['name'], 'ticket/'. $key .'/'. $gkey);

          // add menupont ha van hozza jogod
          if ( $info['access']) {
            $output .= ' ('. l(t('add ticket'), 'ticket/'. $key .'/'. $gkey .'/add') .')';
          }
          // leiras hozzaadasa a listahoz, ha van:)
          if ($info['desc'] != '') {
            $output .= '<ul><li class = "ticket_desc">'. $info['desc'] .'</li></ul>';
          }
          $output .= '</li>';
        }
      }
    }
    if ($t_info['desc'] != '') {
      $output .= '</ul>';
    }
    $output .= '</li>';
  }
  $output .= '</ul> </div>';
  return $output;
}

/**
 * ticket_add_sw: ticket hozzadasa
 * @param: $u_id - unit id
 * @param: $gid - group id
 */
function ticket_add_sw($u_id, $gid) {
  if ( _ticket_menu_active($u_id, $gid) ) {
    drupal_add_css(drupal_get_path('module', 'ticket') .'/ticket.css');

    if ( ticket_access('ticket manager', $u_id, $gid) ) {
      $output = drupal_get_form('ticket_add', $u_id, $gid);
      return '<div id="ticket">'. $output .'</div>';

    }
    elseif ( ticket_access('ticket outsider', $u_id, $gid) ) {
      $output = drupal_get_form('ticket_add_queue', $u_id, $gid);
      return '<div id="ticket_queue">'. $output .'</div>';
    }
    else {
      drupal_access_denied();
      return;
    }
  }
  else {
    drupal_goto('ticket/'. $u_id);
  }
}

/**
 * _ticket_form:
 * @param $u_id - unit id
 * @param $gid - group id
 * @param $def - form default erteki
 */
function _ticket_form($u_id, $gid, $add, $def = array()) {
  // tablazat elemeinek elokeszitese
  $table[1][] = '<tr><td>';
  $table[1][] = '</td>';
  $table[2][] = '<td class= "ticket-form-table">';
  $table[2][] = '</td></tr>';

  $table[] = '<td class= "ticket-form-table">';
  $table[] = '</td></tr></table>';
  $i = 1;

  $SQL = 'SELECT type_id, type_name, def FROM {ticket_type} WHERE gid = %d AND active = 1 ORDER BY weight, type_name';
  $result = db_query($SQL, $gid);
  while ($row = db_fetch_array($result)) {
    $type[$row['type_id']] = $row['type_name'];
    if ( ($row['def']) && ( !isset($def['type']) && $add ) ) {
      $def['type_id'] = $row['type_id'];
    }
  }

  $form['type'] = array(
    '#type' => 'select',
    '#title' => t('Type'),
    '#options' => $type,
    '#default_value' => $def['type_id'],
    '#prefix' => '<table><tr><td><div class="ticket-form-line-select">',
    '#suffix' => '</div></td>',
    '#required' => TRUE,
  );

  $SQL = 'SELECT priority_id, priority_name, weight, def FROM {ticket_priority} WHERE gid = %d AND active = 1 ORDER BY weight, priority_name';
  $result = db_query($SQL, $gid);
  while ($row = db_fetch_array($result)) {
    $priority[$row['priority_id']] = $row['priority_name'];
    $priority_class[$row['priority_id']] = 'priority-'. $row['weight'];
    if ( ($row['def']) && ( !isset($def['priority_id']) && $add ) ) {
      $def['priority_id'] = $row['priority_id'];
    }
  }

  $form['priority'] = array(
    '#input' => TRUE,
    '#type' => 'select',
    '#title' => t('Priority'),
    '#options' => $priority,
    '#class' => $priority_class,
    '#default_value' => $def['priority_id'],
    '#prefix' => '<td class= "ticket-form-table"><div class="ticket-form-line-select">',
    '#suffix' => '</div></td></tr>',
    '#required' => TRUE,
    '#theme' => 'color_select',
  );

  if ($add) {
    // Tikethez csak akkor lehet statust beallitani amikor letrehozzuk.
    $SQL = 'SELECT status_id, status_name, weight, def, stage FROM {ticket_status} WHERE gid = %d AND closed = 0 AND active = 1 ORDER BY weight, status_name';
    $result = db_query($SQL, $gid);
    $stage = array();
    while ($row = db_fetch_array($result)) {
      $status[$row['status_id']] = $row['status_name'];
      $stage[$row['status_id']] = 'stage-'. $row['stage'];
      if ( ($row['def']) && ( !isset($def['status_id']) ) ) {
        $def['status_id'] = $row['status_id'];
      }
    }

    if ( ($i)%2 ) {
      $open = $table[1][0];
      $close = $table[1][1];
    }
    else {
      $open = $table[2][0];
      $close = $table[2][1];
    }

    $form['status'] = array(
      '#input' => TRUE,
      '#type' => 'select',
      '#title' => t('Status'),
      '#options' => $status,
      '#class' => $stage,
      '#default_value' => $def['status_id'],
      '#prefix' => $open .'<div class="ticket-form-line-select">',
      '#suffix' => '</div>'. $close,
      '#required' => TRUE,
      '#theme' => 'color_select',
    );
    $i++;
  }

  $SQL = 'SELECT scope_id, scope_name, def FROM {ticket_scope} WHERE gid = %d AND active = 1 ORDER BY weight, scope_name';
  $result = db_query($SQL, $gid);
  while ($row = db_fetch_array($result)) {
    $scope[$row['scope_id']] = $row['scope_name'];
    if ( ($row['def']) && ( !isset($def['scope_id']) && $add ) ) {
      $def['scope_id'] = $row['scope_id'];
    }
  }
  if ( count($scope) ) {
    if ( ($i)%2 ) {
      $open = $table[1][0];
      $close = $table[1][1];
    }
    else {
      $open = $table[2][0];
      $close = $table[2][1];
    }

    $form['scope'] = array(
      '#type' => 'select',
      '#title' => t('Scope'),
      '#options' => $scope,
      '#default_value' => $def['scope_id'],
      '#prefix' => $open .'<div class="ticket-form-line-select">',
      '#suffix' => '</div>'. $close,
      '#required' => TRUE,
    );
    $i++;
  }
  else {
    $form['scope'] = array(
      '#type' => 'value',
      '#value' => 1,
    );
  }

  $SQL = 'SELECT site_id, site_name, def FROM {ticket_site} WHERE gid = %d AND active = 1 ORDER BY weight, site_name';
  $result = db_query($SQL, $gid);
  while ($row = db_fetch_array($result)) {
    $site[$row['site_id']] = $row['site_name'];
    if ( ($row['def']) && ( !isset($def['site_id']) ) && $add ) {
      $def['site_id'] = $row['site_id'];
    }
  }

  if ( count($site) ) {
    if ( ($i)%2 ) {
      $open = $table[1][0];
      $close = $table[1][1];
    }
    else {
      $open = $table[2][0];
      $close = $table[2][1];
    }

    $form['site'] = array(
      '#type' => 'select',
      '#title' => t('Site'),
      '#options' => $site,
      '#default_value' => $def['site_id'],
      '#prefix' => $open .'<div class="ticket-form-line-select">',
      '#suffix' => '</div>'. $close,
      '#required' => TRUE,
    );
    $i++;
  }
  else {
    $form['site'] = array(
      '#type' => 'value',
      '#value' => 1,
    );
  }

  $SQL = 'SELECT fixer_id, fixer_name, def FROM {ticket_fixer} WHERE gid = %d AND active = 1 ORDER BY weight, fixer_name';
  $result = db_query($SQL, $gid);
  while ($row = db_fetch_array($result)) {
    $fixer[$row['fixer_id']] = $row['fixer_name'];
    if ( ($row['def']) && ( !isset($def['fixer_id']) && $add ) ) {
      $def['fixer_id'] = $row['fixer_id'];
    }
  }

  if ( count($fixer) ) {
    if ( ($i)%2 ) {
      $open = $table[1][0];
      $close = $table[1][1];
    }
    else {
      $open = $table[2][0];
      $close = $table[2][1];
    }

    $form['fixer'] = array(
      '#type' => 'select',
      '#title' => t('Fixer'),
      '#options' => $fixer,
      '#default_value' => $def['fixer_id'],
      '#prefix' => $open .'<div class="ticket-form-line-select">',
      '#suffix' => '</div>'. $close,
      '#required' => TRUE,
    );
    $i++;
  }
  else {
    $form['fixer'] = array(
      '#type' => 'value',
      '#value' => 1,
    );
  }

  $SQL = "SELECT u.uid, u.name FROM {ticket_permission} tp, {users_roles} ur, {users} u ";
  $SQL .= " WHERE ( ( (tp.u_id = 0 OR tp.u_id = %d) AND tp.gid = 0 ) OR tp.gid = %d) AND tp.perm LIKE '%ticket manager%'";
  $SQL .= " AND ur.rid = tp.rid AND ur.uid = u.uid ORDER BY u.name";
  $result = db_query($SQL, $u_id, $gid);

  if ($add) {
    // Ezeket az ertekeket csak uj ticket letrehozasakor lehet beallitani.
    while ($row = db_fetch_array($result)) {
      $assigned[$row['uid']] = $row['name'];
    }
    if ( count($assigned) ) {
      if ( ($i)%2 ) {
        $open = $table[1][0];
        $close = $table[1][1];
      }
      else {
        $open = $table[2][0];
        $close = $table[2][1];
      }

      $form['assigned'] = array(
        '#type' => 'select',
        '#title' => t('Assigned to'),
        '#options' => $assigned,
        '#default_value' => $def['assigned'],
        '#prefix' => $open .'<div class="ticket-form-line-select">',
        '#suffix' => '</div>'. $close,
        '#required' => TRUE,
      );
      $i++;
    }

    if ( ($i)%2 ) {
      $close = '</table>';
    }
    else {
      $close = '<td class= "ticket-form-table"></td></tr></table>';
    }

    $form['start'] = array(
      '#type' => 'textfield',
      '#title' => t('Problem started'),
      '#default_value' => $def['start'],
      '#maxlength' => '19', '#size' => '30',
      '#description' => t('Date format: year-month-day, year-month-day hour:minute'),
      '#prefix' => $close .'<div class="ticket-form-line">',
      '#suffix' => '</div>',
    );
  }
  else {
    // Hibajegy szerkesztesekor nem modosithato elemek
    if ( ($i)%2 ) {
      $open = $table[1][0];
      $close = $table[1][1];
    }
    else {
      $open = $table[2][0];
      $close = $table[2][1];
    }

    $form['assigned'] = array(
      '#type' => 'item',
      '#title' => t('Assigned to'),
      '#value' => theme('username', user_load($def['assigned'])),
      '#prefix' => $open .'<div class="ticket-form-line-select">',
      '#suffix' => '</div>'. $close,
    );
    $i++;

    // tablazat hibamentes lezarasa
    if ( ($i)%2 ) {
      $close = '</table>';
    }
    else {
      $close = '<td class= "ticket-form-table"><br /></td></tr></table>';
    }

    $form['start'] = array(
      '#type' => 'item',
      '#title' => t('Problem started'),
      '#value' => $def['start'],
      '#prefix' => $close .'<div class="ticket-form-line">',
      '#suffix' => '</div>',
    );
  }

  $form['finish'] = array(
    '#type' => 'textfield',
    '#title' => t('Problem fixed'),
    '#default_value' => $def['finish'],
    '#maxlength' => '19', '#size' => '30',
    '#description' => t('Date format: year-month-day, year-month-day hour:minute'),
    '#prefix' => '<div class="ticket-form-line">',
    '#suffix' => '</div>',
  );

  $result = db_query("SELECT mail_address FROM {ticket_template} WHERE gid = %d", $gid);
  $mailto = db_fetch_array($result);
  if ( !empty($mailto['mail_address']) ) {
    // Ha megvan adva mail_address a csoporhoz akkor megjelennek a
    $SQL = 'SELECT email_id, mailto, email_name, def FROM {ticket_email} WHERE gid = %d AND active = 1 ORDER BY email_name';
    $result = db_query($SQL, $gid);
    while ($row = db_fetch_array($result)) {
      $mail[$row['email_id']] = $row['email_name'];
      if ( $row['def'] ) {
        $def['email_id'][] = $row['email_id'];
      }
    }
    if ( ! $add ) {
      $def['email_id'] = array();
      $SQL = 'SELECT email_id FROM {ticket_rel_ticket_email} WHERE tid = %d';
      $result = db_query($SQL, $def['tid']);
      while ($row = db_fetch_array($result)) {
        $def['email_id'][] = $row['email_id'];
      }
    }

    if ( count($mail) ) {
      $form['mail'] = array(
        '#input' => TRUE,
        '#type' => 'checkboxes',
        '#title' => t('Mail group'),
        '#options' => $mail,
        '#default_value' => isset($def['email_id']) ? $def['email_id'] : array(),
        '#columns' => 3,
        '#suffix' => '<br style="clear:both;"/>',
        '#theme' => 'checkbox_columns',
      );
    }

    $form['cc'] = array(
      '#type' => 'textfield',
      '#title' => t('CC'),
      '#default_value' => $def['cc'],
      '#maxlength' => '255', '#size' => '60',
      '#prefix' => '<div class="ticket-form-line">',
      '#suffix' => '</div>',
    );
  }
  else {
    $form['cc'] = array(
      '#type' => 'value',
      '#value' => '',
    );
  }

  $form['summary'] = array(
    '#type' => 'textfield',
    '#title' => t('Short summary'),
    '#default_value' => $def['summary'],
    '#maxlength' => '255',
    '#size' => '60',
    '#prefix' => '<div class="ticket-form-line">',
    '#suffix' => '</div>',
    '#required' => TRUE,
  );

  $form['detail'] = array(
    '#type' => 'textarea',
    '#title' => t('Detail'),
    '#default_value' => $def['detail'],
    '#rows' => '6',
    '#required' => TRUE,
  );

  $form['affected'] = array(
    '#type' => 'textarea',
    '#title' => t('Affected'),
    '#default_value' => $def['affected'],
    '#rows' => '3',
  );

  $form['actions'] = array(
    '#type' => 'textarea',
    '#title' => t('Actions'),
    '#default_value' => $def['actions'],
    '#rows' => '3',
  );

  $form['time_to_fix'] = array(
    '#type' => 'textfield',
    '#title' => t('Time to fix'),
    '#default_value' => $def['time_to_fix'],
    '#maxlength' => '250', '#size' => '60',
  );

  $form['fix'] = array(
    '#type' => 'textarea',
    '#title' => t('Fix'),
    '#default_value' => $def['fix'],
    '#rows' => '3',
  );
  if ( ticket_access('ticket upload files', $u_id, $gid) || ticket_access('view ticket uploaded files', $u_id, $gid) ) {
    if ( isset($def['tid']) ) {
      $tid = $def['tid'];
    }
    else {
      $tid = 'new';
    }
    $form += _ticket_files_form_add($u_id, $gid, $tid, 0, $def['files']);
  }
  return $form;
}

/**
 * _ticket_files_form_add: files form hozzadasa
 * @param $u_id - unit id
 * @param $gid - group id
 * @param $def - form default erteki
 */
function _ticket_files_form_add($u_id, $gid, $tid, $eid, $files = array()) {
  $form = array();
  if ( ticket_access('ticket upload files', $u_id, $gid) || ticket_access('view ticket uploaded files', $u_id, $gid) ) {
    $form['attachments'] = array(
      '#type' => 'fieldset',
      '#title' => t('File attachments'),
      '#collapsible' => TRUE,
      '#collapsed' => empty($files),
      '#description' => t('Changes made to the attachments are not permanent until you save this post.'),
      '#prefix' => '<div class="attachments">',
      '#suffix' => '</div>',
    );
    $e_name = '';
    if ( $eid === 'new') {
      $e_name = '-event';
    }

    $form['attachments']['wrapper'] = array(
      '#prefix' => '<div id="attach'. $e_name .'-wrapper">',
      '#suffix' => '</div>',
    );

    if ( ticket_access('ticket upload files', $u_id, $gid) ) {
      include_once drupal_get_path('module', 'ticket') .'/ticket.files.inc';
      if (!empty($_SESSION['ticket_upload_files'][$u_id][$gid][$tid][$eid])) {
        foreach ($_SESSION['ticket_upload_files'][$u_id][$gid][$tid][$eid] as $file) {
          _ticket_file_delete($file);
        }
        unset($_SESSION['ticket_upload_files'][$u_id][$gid][$tid][$eid]);
      }

      $form['attachments']['wrapper'] += _ticket_files_form(array('files' => $files) , $u_id, $gid, $tid, $eid);
      $form['#attributes']['enctype'] = 'multipart/form-data';
    }
    else {
      if ( count($files) ) {
        $form['attachments']['#description'] = '';
        $form['attachments']['wrapper'] = array(
          '#theme' => 'ticket_files_form_view',
          '#prefix' => '<div id="attach-wrapper">',
          '#suffix' => '</div>',
          '#type' => 'item',
          '#title' => '',
          '#value' => $files,
        );
      }
      else {
        unset($form['attachments']);
      }
    }
  }
  return $form;
}

/*
 * theme_ticket_files_form_view: hibajegyhez csatolt allomanyok listazasa
 */
function theme_ticket_files_form_view(&$form) {
  drupal_render($form);
  return theme('ticket_files_view', $form['#value']);
}

/**
 * ticket_add: ticket hozzaadas
 * @param: $u_id - unit id
 * @param: $gid - group id
 */
function ticket_add(&$form_state, $u_id, $gid) {
  global $user;
  if ( _ticket_menu_active($u_id, $gid) ) {
    // alapertelmezett ertekek
    $def['assigned'] = $user->uid;
    $def['start'] = date('*Y-m-d H:i');
    $def['finish'] = '';
    $def['cc'] = '';
    $def['summary'] = '';
    $def['detail'] = '';
    $def['affected'] = '';
    $def['actions'] = '';
    $def['time_to_fix'] = '';
    $def['fix'] = '';

    // form elkeszitese
    $form = _ticket_form($u_id, $gid, 1, $def);

    $form['u_id'] = array(
      '#type' => 'value',
      '#value' => $u_id,
    );

    $form['gid'] = array(
      '#type' => 'value',
      '#value' => $gid,
    );

    $form['submit'] = array(
      '#type' => 'submit',
      '#value' => t('Save'),
      '#prefix' => '<div class = "ticket-help">'. l(t('help'), 'ticket/help/ticket') .'</div>',
    );
    return $form;
  }
  else {
    drupal_goto('ticket/'. $u_id);
  }
}

/**
 * ticket_add_validate: ticket hozzaadas ellenorzese
 */
function ticket_add_validate($form, &$form_state) {
  // problem start mezoben levo datum ellenorzese
  // Validate the "authored on" field. As of PHP 5.1.0, strtotime returns FALSE instead of -1 upon failure.
  if (!empty($form_state['values']['start']) && strtotime($form_state['values']['start']) <= 0) {
    form_set_error('start', t('Non-date format.'));
  }
  // problem finish mezoben levo datum ellenorzese
  if (!empty($form_state['values']['finish'])) {
    if (strtotime($form_state['values']['finish']) <= 0) {
      form_set_error('finish', t('Non-date format.'));
    }
    if (strtotime($form_state['values']['start']) > 0) {
      if (strtotime($form_state['values']['start']) > strtotime($form_state['values']['finish'])) {
        form_set_error('finish', t('Date is earlier than Problem started!'));
      }
    }
  }
  // cc mezoben levo mail cim(ek) ellenorzese
  if ($form_state['values']['cc'] != '') {
    if ( !_ticket_chk_emails($form_state['values']['cc']) ) {
      form_set_error('cc', t('Faulty e-mail adddress(es).'));
    }
  }
}

/**
 * ticket_add_submit: ticket hozzaadas submit
 */
function ticket_add_submit($form, &$form_state, $goto = 1) {
  global $user;

  // kezdo idopont ellenorzese, ha nem volt megadva az aktualis idovel valo feltoltese.
  $form_state['values']['start'] = strtotime($form_state['values']['start']);
  // ha van megadva finish ido akkor annak megfelelo formaba hozasa, es az SQL kiegeszitese.
  if (!empty($form_state['values']['finish'])) {
    $form_state['values']['finish'] = strtotime($form_state['values']['finish']);
    $sql_param = ", %d";
  }
  else {
    $form_state['values']['finish'] = 'NULL';
    $sql_param = ", %s";
  }

  // hibajegy letrehozoja, ha queue-bol jon a letrehozas akkor mas lehet a letrehozo.
  if ( isset($form_state['values']['authored']) ) {
    $uid = $form_state['values']['authored'];
  }
  else {
    $uid = $user->uid;
  }
  // ticket hozza adasa.
  $SQL = "INSERT INTO {ticket_ticket} (uid, gid, priority_id, type_id, scope_id, site_id, fixer_id,";
  $SQL .= " assigned, cc, summary, detail, affected, actions, time_to_fix, fix, created, start, finish)";
  $SQL .= " VALUES (%d, %d, %d, %d, %d, %d, %d, %d, '%s', '%s', '%s', '%s', '%s', '%s', '%s', %d, %d". $sql_param .")";
  db_query($SQL, $uid, $form_state['values']['gid'], $form_state['values']['priority'], $form_state['values']['type'], $form_state['values']['scope'], $form_state['values']['site'], $form_state['values']['fixer'], $form_state['values']['assigned'], $form_state['values']['cc'], $form_state['values']['summary'], $form_state['values']['detail'], $form_state['values']['affected'], $form_state['values']['actions'], $form_state['values']['time_to_fix'], $form_state['values']['fix'], time(), $form_state['values']['start'], $form_state['values']['finish']);
  $tid = db_last_insert_id('{ticket_ticket}', 'tid');

  $SQL = "INSERT INTO {ticket_event} (tid, reassigned, created, status_id) VALUES (%d, %d, %d, %d)";
  db_query($SQL, $tid, $form_state['values']['assigned'], time(), $form_state['values']['status']);
  $eid = db_last_insert_id('{ticket_event}', 'eid');

  db_query("INSERT INTO {ticket_rel_event} (tid, eid) VALUES (%d, %d)", $tid, $eid);

  if ( count($form_state['values']['mail']) ) {
    $form_state['values']['mail'] = array_diff($form_state['values']['mail'], array(0));
  }
  // mail id - ticket id parok letrehozasa
  if ( count($form_state['values']['mail']) ) {
    foreach ($form_state['values']['mail'] as $key => $mail_id) {
      db_query("INSERT INTO {ticket_rel_ticket_email} (tid, email_id) VALUES (%d, %d)", $tid, $key);
    }
  }

  // File csatolas
  if ( ticket_access('ticket upload files', $form_state['values']['u_id'], $form_state['values']['gid']) ) {
    if ( !empty($form_state['values']['files']) ) {
      $now = time();
      foreach ($form_state['values']['files'] as $file) {
        if ( !$file['remove'] ) {
          $file['timestamp'] = $now;
          _ticket_file_save($tid, 0, $uid, $file);
        }
      }
    }
  }

  // level kuldes
  $result = db_query("SELECT * FROM {ticket_template} WHERE gid = %d", $form_state['values']['gid']);
  $template = db_fetch_array($result);
  if ( !empty($template['mail_address'] ) ) {
    drupal_mail('ticket', 'add_ticket', '', language_default(), array('tid' => $tid, 'template' => $template), NULL, FALSE);
    // assigned mail
    drupal_mail('ticket', 'new_assigned', '', language_default(), array('tid' => $tid, 'eid' => $eid, 'template' => $template), NULL, FALSE);
  }

  if ( $goto ) {
    drupal_goto('ticket/'. $form_state['values']['u_id'] .'/'. $form_state['values']['gid']);
  }
}

/**
 * ticket_add_queue: add ticket in queue
 */
function ticket_add_queue(&$form_state, $u_id, $gid) {
  global $user;

  drupal_add_css(drupal_get_path('module', 'ticket') .'/ticket.css');

  $SQL = 'SELECT scope_id, scope_name, def FROM {ticket_scope} WHERE gid = %d AND active = 1 ORDER BY weight, scope_name';
  $result = db_query($SQL, $gid);
  while ($row = db_fetch_array($result)) {
    $scope[$row['scope_id']] = $row['scope_name'];
    if ( ($row['def']) && ( !isset($def['scope_id']) ) ) {
      $def['scope_id'] = $row['scope_id'];
    }
  }
  if ( count($scope) ) {
    $form['scope'] = array(
      '#type' => 'select',
      '#title' => t('Scope'),
      '#options' => $scope,
      '#default_value' => $def['scope_id'],
      '#prefix' => '<div class="ticket-form-line-select">',
      '#suffix' => '</div>',
      '#required' => TRUE,
    );
  }
  else {
    $form['scope'] = array(
      '#type' => 'value',
      '#value' => 1,
    );
  }

  $SQL = 'SELECT site_id, site_name, def FROM {ticket_site} WHERE gid = %d AND active = 1 ORDER BY weight, site_name';
  $result = db_query($SQL, $gid);
  while ($row = db_fetch_array($result)) {
    $site[$row['site_id']] = $row['site_name'];
    if ( ($row['def']) && ( !isset($def['site_id']) ) ) {
      $def['site_id'] = $row['site_id'];
    }
  }

  if ( count($site) ) {
    $form['site'] = array(
      '#type' => 'select',
      '#title' => t('Site'),
      '#options' => $site,
      '#default_value' => $def['site_id'],
      '#prefix' => '<div class="ticket-form-line-select">',
      '#suffix' => '</div>',
      '#required' => TRUE,
    );
  }
  else {
    $form['site'] = array(
      '#type' => 'value',
      '#value' => 1,
    );
  }

  $SQL = 'SELECT priority_id, priority_name, def FROM {ticket_priority} WHERE gid = %d AND active = 1 ORDER BY weight, priority_name';
  $result = db_query($SQL, $gid);
  while ($row = db_fetch_array($result)) {
    $priority[$row['priority_id']] = $row['priority_name'];
    if ( ($row['def']) && ( !isset($def['priority_id']) ) ) {
      $def['priority_id'] = $row['priority_id'];
    }
  }

  $form['priority'] = array(
    '#type' => 'select',
    '#title' => t('Priority'),
    '#options' => $priority,
    '#default_value' => $def['priority_id'],
    '#prefix' => '<div class="ticket-form-line-select">',
    '#suffix' => '</div>',
    '#required' => TRUE,
  );

  $form['summary'] = array(
    '#type' => 'textfield',
    '#title' => t('Short summary'),
    '#default_value' => '',
    '#maxlength' => '255',
    '#size' => '60',
    '#prefix' => '<div class="ticket-form-line">',
    '#suffix' => '</div>',
    '#required' => TRUE,
  );

  $form['detail'] = array(
    '#type' => 'textarea',
    '#title' => t('Detail'),
    '#default_value' => '',
    '#rows' => '6',
    '#required' => TRUE,
  );

  $form['gid'] = array(
    '#type' => 'value',
    '#value' => $gid,
  );
  $form['u_id'] = array(
    '#type' => 'value',
    '#value' => $u_id,
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#prefix' => '<div class = "ticket-help">'. l(t('help'), 'ticket/help/queue') .'</div>',
  );
  return $form;
}

/**
 * ticket_add_queue_submit: ticket hozzaadasa a queue-hoz
 */
function ticket_add_queue_submit($form, &$form_state) {
  global $user;

  // ticket hozza adasa az adatbazishoz
  $SQL = "INSERT INTO {ticket_queue} (uid, gid, priority_id, scope_id, site_id, created, summary, detail)";
  $SQL .= " VALUES (%d, %d, %d, %d, %d, %d, '%s', '%s')";
  db_query($SQL, $user->uid, $form_state['values']['gid'], $form_state['values']['priority'], $form_state['values']['scope'], $form_state['values']['site'], time(), $form_state['values']['summary'], $form_state['values']['detail']);

  // send notification
  $qid = db_last_insert_id('{ticket_queue}', 'qid');
  $result = db_query("SELECT * FROM {ticket_template} WHERE gid = %d", $form_state['values']['gid']);
  $template = db_fetch_array($result);
  if ( !empty($template['mail_address'] ) ) {
    drupal_mail('ticket', 'add_queue', '', language_default(), array('qid' => $qid, 'gid' => $form_state['values']['gid'], 'template' => $template), NULL, FALSE);
  }

  drupal_set_message(t('Thank you! Your request queued.'), 'status');

  drupal_goto('ticket/'. $form_state['values']['u_id'] .'/'. $form_state['values']['gid']);
}

/**
 * ticket_simple_list: egyszeru ticket lista
 * @param: $u_id - unit id
 * @param: $gid - group id
 */
function ticket_simple_list($u_id, $gid, $tid = NULL) {
  global $ticket_conf;
  // csak aktiv unit es csoport eseten mukodik
  if ( _ticket_menu_active($u_id, $gid) ) {
    if ( empty($tid) ) {
      if ( (ticket_access('ticket reader', $u_id, $gid)) ) {
        // oldal frissitesi ideje
        drupal_set_html_head('<meta http-equiv="refresh" content="'. $ticket_conf['page_refresh'] .'" />');
        $header = array(
          array('data' => t('Ticket ID'), 'field' => 't.tid', 'sort' => 'DESC'),
          array('data' => t('Summary'), 'field' => 't.summary'),
          array('data' => t('Type'), 'field' => 'tt.type_name'),
          array('data' => t('Status'), 'field' => 'ts.status_name'),
          array('data' => t('Opened by'), 'field' => 'u.name'),
          array('data' => t('Priority'), 'field' => 'tp.weight'),
          array('data' => t('Problem started'), 'field' => 't.start'),
          array('data' => t('Date updated'), 'field' => 'e.created'),
          array('data' => t('Updates'), 'field' => 'tre.num'),
        );
        _ticket_list_sql_sort();

        $SQL = "SELECT t.tid, t.gid, t.summary, tt.type_name, ts.status_name, t.uid";
        $SQL .= ", tp.priority_name, tp.weight, ts.stage, t.start, e.created, tre.num";
        $SQL .= " FROM {ticket_ticket} t, {ticket_rel_event} tre, {ticket_event} e, {ticket_status} ts, {ticket_priority} tp";
        $SQL .= ", {ticket_type} tt, {ticket_group} tg, {users} u";
        $SQL .= " WHERE t.closed = 0 AND t.gid = %d AND tg.gid = t.gid AND t.tid = tre.tid";
        $SQL .= " AND tre.eid = e.eid AND e.status_id = ts.status_id";
        $SQL .= " AND t.priority_id = tp.priority_id AND t.type_id = tt.type_id AND t.uid = u.uid";
        $SQL .= tablesort_sql($header, '');

        $result = pager_query($SQL, $ticket_conf['limit'], 0, NULL, $gid);
        $rows = _ticket_list_table($result, $u_id);

        // table
        $output = theme('ticket_table_list', $header, $rows);
        // pager
        $output .= theme('pager', NULL, $ticket_conf['limit']);
        return $output;
      }
      else {
        $result = db_query('SELECT description FROM {ticket_group} WHERE gid = %d', $gid);
        $row = db_fetch_array($result);
        $output = $row['description'];
      }
      return $output;
    }
    else {
      // Hibajegy betoltese
      if (is_numeric($tid)) {
        $SQL = "SELECT tg.u_id, tg.gid FROM {ticket_ticket} t, {ticket_group} tg WHERE t.tid = %d AND t.gid = tg.gid";
        $result = db_query($SQL, $tid);
        $row = db_fetch_array($result);
        if ( ($row['u_id'] == $u_id) AND ($row['gid'] == $gid) ) {
          if ( ticket_access(array('ticket reader', 'ticket manager'), $u_id, $gid) ) {
            return ticket_page($u_id, $gid, $tid);
          }
          drupal_access_denied();
        }
        else {
          drupal_not_found();
        }
        return;
      }
    }
  }
  // Ha a kereses ide teved akkor tovabbitas
  if (strtolower($u_id) == 'search') {
    $links = func_get_args();
    unset($links[0]);
    drupal_goto('ticket/search/simple/'. implode('/', $links));
  }
  drupal_goto('ticket/'. $u_id);
}

/**
 * theme_ticket_table_list: theme hook
 * @param: $header - tablazat fejlece
 * @param: $rows - tablazat sorai
 */
function theme_ticket_table_list($header, $rows) {
  drupal_add_css(drupal_get_path('module', 'ticket') .'/ticket.css');
  $output = '<div id="ticket">';
  $output .= theme('table', $header, $rows);
  $output .= '</div>';
  return $output;
}

function ticket_list_form(&$form_state, $u_id, $gid, $def) {
  // listazas parameterei, ha meg nem nezte ezt a listat akkor beallitja az alapertelmezett ertekeket
  $simple_status = array('-1' => t('any'), '0' => t('open'), '1' => t('closed'));
  $status['-1'] = t('any');
  $type['-1'] = t('any');
  $assigned['-1'] = t('anybody');

  // valaszthato tulajdonsagok ertekeinek listaja
  if ($gid) {
    // egy csoport listaja
    $SQL = 'SELECT status_id, status_name, def FROM {ticket_status} WHERE gid = %d AND active = 1 ORDER BY weight, status_name';
    $result = db_query($SQL, $gid);
    while ($row = db_fetch_array($result)) {
      $status[$row['status_id']] = $row['status_name'];
    }

    $SQL = 'SELECT type_id, type_name, def FROM {ticket_type} WHERE gid = %d AND active = 1 ORDER BY weight, type_name';
    $result = db_query($SQL, $gid);
    while ($row = db_fetch_array($result)) {
      $type[$row['type_id']] = $row['type_name'];
    }

    $SQL = "SELECT u.uid, u.name FROM {ticket_permission} tp, {users_roles} ur, {users} u ";
    $SQL .= " WHERE ( ( (tp.u_id = 0 OR tp.u_id = %d) AND tp.gid = 0 ) OR tp.gid = %d) AND tp.perm LIKE '%ticket manager%'";
    $SQL .= " AND ur.rid = tp.rid AND ur.uid = u.uid ORDER BY u.name";
    $result = db_query($SQL, $u_id, $gid);
    while ($row = db_fetch_array($result)) {
      $assigned[$row['uid']] = $row['name'];
    }
  }
  else {
    $SQL = "SELECT ts.status_name FROM {ticket_group} tg, {ticket_status} ts";
    $SQL .= " WHERE tg.u_id = %d AND tg.gid IN (%s) AND tg.gid = ts.gid AND ts.active = 1 GROUP BY ts.status_name ORDER BY ts.weight, ts.status_name";
    $result = db_query($SQL, $u_id, $def['groups']);
    while ($row = db_fetch_array($result)) {
      $status[$row['status_name']] = $row['status_name'];
    }

    $SQL = "SELECT tt.type_name FROM {ticket_group} tg, {ticket_type} tt";
    $SQL .= " WHERE tg.u_id = %d AND tg.gid IN (%s) AND tg.gid = tt.gid AND tt.active = 1 GROUP BY tt.type_name ORDER BY tt.weight, tt.type_name";
    $result = db_query($SQL, $u_id, $def['groups']);
    while ($row = db_fetch_array($result)) {
      $type[$row['type_name']] = $row['type_name'];
    }

    $SQL = "SELECT u.uid, u.name FROM {ticket_permission} tp, {users_roles} ur, {users} u ";
    $SQL .= " WHERE (tp.u_id = 0 OR tp.u_id = %d) AND tp.perm LIKE '%ticket manager%'";
    $SQL .= " AND ur.rid = tp.rid AND ur.uid = u.uid ORDER BY u.name";
    $result = db_query($SQL, $u_id);
    while ($row = db_fetch_array($result)) {
      $assigned[$row['uid']] = $row['name'];
    }
  }

  $form['simple_status'] = array(
    '#type' => 'select',
    '#title' => t('Simple status'),
    '#options' => $simple_status,
    '#default_value' => $def['simple_status'],
    '#prefix' => '<div class = "ticket-line">',
    '#suffix' => '</div>',
    '#required' => TRUE,
  );

  // form elkeszitese
  if ( count($status) ) {
    $form['status'] = array(
      '#type' => 'select',
      '#title' => t('Status'),
      '#options' => $status,
      '#default_value' => $def['status'],
      '#prefix' => '<div class = "ticket-line">',
      '#suffix' => '</div>',
      '#required' => TRUE,
    );
  }

  if ( count($type) ) {
    $form['type'] = array(
      '#type' => 'select',
      '#title' => t('Type'),
      '#options' => $type,
      '#default_value' => $def['type'],
      '#prefix' => '<div class = "ticket-line">',
      '#suffix' => '</div>',
      '#required' => TRUE,
    );
  }

  if ( count($assigned) ) {
    $form['assigned'] = array(
      '#type' => 'select',
      '#title' => t('Assigned to'),
      '#options' => $assigned,
      '#default_value' => $def['assigned'],
      '#prefix' => '<div class = "ticket-line">',
      '#suffix' => '</div>',
      '#required' => TRUE,
    );
  }

  $form['u_id'] = array(
    '#type' => 'value',
    '#value' => $u_id,
  );

  $form['gid'] = array(
    '#type' => 'value',
    '#value' => $gid,
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#attributes' => array('class' => 'refresh-submit'),
    '#value' => t('Refresh')
  );
  return $form;
}

/**
 * ticket_list_form_submit: ticket list submit
 */
function ticket_list_form_submit($form, &$form_state) {
  $def['simple_status'] = $form_state['values']['simple_status'];
  $def['type'] = $form_state['values']['type'];
  $def['status'] = $form_state['values']['status'];
  $def['assigned'] = $form_state['values']['assigned'];
  // sessionbe menti az alapertelmezett beallitasokat
  $_SESSION['ticket_list_'. $form_state['values']['u_id'] .'_'. $form_state['values']['gid']] = $def;
}

/**
 * ticket_list: ticket list
 */
function ticket_list($u_id, $gid = NULL) {
  global $ticket_conf, $user, $_GET;
  if ( _ticket_menu_active($u_id, $gid) ) {
    drupal_set_html_head('<meta http-equiv="refresh" content="'. $ticket_conf['page_refresh'] .'" />');
    // js ami eltunteti a submit gombot es a select ertekvaltasra automatikusan submitol
    drupal_add_js(drupal_get_path('module', 'ticket') .'/ticket.js');

    if ( empty($_SESSION['ticket_list_'. $u_id .'_'. $gid]) ) {
      $def['simple_status'] = -1;
      $def['status'] = -1;
      $def['type'] = -1;
      $def['assigned'] = -1;
    }
    else {
      $def = $_SESSION['ticket_list_'. $u_id .'_'. $gid];
    }
    $header = array(
    array('data' => t('Ticket ID'), 'field' => 't.tid', 'sort' => 'DESC'),
    array('data' => t('Summary'), 'field' => 't.summary'),
    array('data' => t('Type'), 'field' => 'tt.type_name'),
    array('data' => t('Status'), 'field' => 'ts.status_name'),
    array('data' => t('Opened by'), 'field' => 'u.name'),
    array('data' => t('Priority'), 'field' => 'tp.weight'),
    array('data' => t('Problem started'), 'field' => 't.start'),
    array('data' => t('Date updated'), 'field' => 'e.created'),
    array('data' => t('Updates'), 'field' => 'tre.num'),
    );

    _ticket_list_sql_sort();

    if ( empty($gid) ) {
      // egy unit group listaja
      if ( ticket_access('ticket manager', $u_id, 0) ) {
        $SQL = "SELECT gid FROM {ticket_group} WHERE u_id = %d ORDER BY weight, group_name";
        $result = db_query($SQL, $u_id);
      }
      else {
        $SQL = "SELECT tg.gid, tg.group_name FROM {ticket_permission} tp, {users_roles} ur, {ticket_group} tg";
        $SQL .= " WHERE ur.uid = %d AND ur.rid = tp.rid AND tp.u_id = %d AND tp.perm LIKE '%ticket manager%'";
        $SQL .= " AND tp.gid = tg.gid ORDER BY tg.group_name";
        $result = db_query($SQL, $user->uid, $u_id);
      }

      $groups = array();
      while ($row = db_fetch_array($result)) {
        $groups[] = $row['gid'];
      }
      $def['groups'] = implode(',', $groups);
    }

    $sql['table'] = $sql['where'] = $param = array();
    $i = 2;
    // csoporton beluli lista elkeszitese
    if ($gid) {
      $list_form = drupal_get_form('ticket_list_form', $u_id, $gid, $def);
      $param[0] = $u_id;
      $param[1] = $gid;
      if ( $def['type'] != -1 ) {
        $sql['where'][] = ' AND t.type_id = %d ';
        $param[$i] = $def['type'];
        $i++;
      }
      if ( $def['simple_status'] != -1 ) {
        $sql['where'][] = ' AND t.closed = %d ';
        $param[$i] = $def['simple_status'];
        $i++;
      }
      if ( $def['status'] != -1 ) {
        $sql['where'][] = ' AND ts.status_id = %d ';
        $param[$i] = $def['status'];
        $i++;
      }
      if ( $def['assigned'] != -1 ) {
        $sql['where'][] = ' AND e.reassigned = %d ';
        $param[$i] = $def['assigned'];
      }
      $i++;

      // lista lekerdezese az adatbazisbol
      $SQL = "SELECT t.tid, t.gid, t.summary, tt.type_name, ts.status_name, t.uid";
      $SQL .= ", tp.priority_name, tp.weight, ts.stage, t.start, e.created, tre.num";
      $SQL .= " FROM {ticket_ticket} t, {ticket_rel_event} tre, {ticket_event} e, {ticket_status} ts, {ticket_priority} tp";
      $SQL .= ", {ticket_type} tt, {ticket_group} tg, {users} u";
      $SQL .= " WHERE tg.u_id = %d AND tg.gid = %d AND t.uid = u.uid";
      $SQL .= " AND tg.gid = t.gid AND t.tid = tre.tid";
      $SQL .= " AND tre.eid = e.eid AND e.status_id = ts.status_id";
      $SQL .= " AND t.priority_id = tp.priority_id AND t.type_id = tt.type_id ";
      $SQL .= implode(' ', $sql['where']);
      $SQL .= tablesort_sql($header, '');
      $result = pager_query($SQL, $ticket_conf['limit'], 0, NULL, $param);
    }
    elseif ( !empty($def['groups']) ) {
      // uniton beluli lista elkeszitese
      $list_form = drupal_get_form('ticket_list_form', $u_id, $gid, $def);
      $param[0] = $u_id;
      $param[1] = $def['groups'];
      if ( $def['type'] != -1 ) {
        $sql['where'][] = "AND t.type_id = tt.type_id AND tt.type_name = '%s'";
        $param[$i] = $def['type'];
        $i++;
      }
      if ( $def['simple_status'] != -1 ) {
        $sql['where'][] = 'AND t.closed = %d';
        $param[$i] = $def['simple_status'];
        $i++;
      }
      if ( $def['status'] != -1 ) {
        $sql['where'][] = " AND ts.status_name = '%s' ";
        $param[$i] = $def['status'];
        $i++;
      }
      if ( $def['assigned'] != -1 ) {
        $sql['where'][] = " AND e.reassigned  = '%s' ";
        $param[$i] = $def['assigned'];
      }
      $i++;

      // lista lekerdezese az adatbazisbol
      $SQL = "SELECT t.tid, t.gid, t.summary, tt.type_name, ts.status_name, t.uid";
      $SQL .= ", tp.priority_name, tp.weight, ts.stage, t.start, e.created, tre.num";
      $SQL .= " FROM {ticket_ticket} t, {ticket_rel_event} tre, {ticket_event} e, {ticket_status} ts, {ticket_priority} tp";
      $SQL .= ", {ticket_type} tt, {ticket_group} tg, {users} u";
      $SQL .= " WHERE tg.u_id = %d AND tg.gid IN (%s) AND t.uid = u.uid";
      $SQL .= " AND tg.gid = t.gid AND t.tid = tre.tid AND tre.eid = e.eid";
      $SQL .= " AND e.status_id = ts.status_id AND t.priority_id = tp.priority_id";
      $SQL .= " AND t.type_id = tt.type_id ";
      $SQL .= implode(' ', $sql['where']);
      $SQL .= tablesort_sql($header, '');
      $result = pager_query($SQL, $ticket_conf['limit'], 0, NULL, $param);
    }

    if ($i > 2) {
      // tablazat es lapozo elkeszitese
      $rows = _ticket_list_table($result, $u_id);

      // tablazat
      $table = theme('ticket_table_list', $header, $rows);
      // pager
      $pager .= theme('pager', NULL, $ticket_conf['limit']);

      return theme('ticket_list', $list_form, $table, $pager);
    }
    else {
      return t('The unit does contain any groups.');
    }
  }
  else {
    drupal_goto('ticket/'. $u_id);
  }
}

/**
 * theme_ticket_list: theme hook
 */
function theme_ticket_list($list_form, $table = NULL, $pager = NULL) {
  drupal_add_css(drupal_get_path('module', 'ticket') .'/ticket.css');
  $output = '';
  $output .= '<div id="ticket_header">';
  $output .= $list_form;
  $output .= '</div>';

  if ( isset($table) ) {
    $output .= '<div id="ticket_table">';
    $output .= $table;
    $output .= '</div>';
  }
  if ( isset($pager) ) {
    $output .= '<div id="ticket_footer">';
    $output .= $pager;
    $output .= '</div>';
  }
  return $output;
}

function ticket_page($u_id, $gid, $tid) {
  if ( _ticket_menu_active($u_id, $gid) ) {
    drupal_add_css(drupal_get_path('module', 'ticket') .'/ticket.css');
    $closed = db_fetch_array(db_query("SELECT closed FROM {ticket_ticket} WHERE tid = %d", $tid));

    if ( (ticket_access('ticket manager', $u_id, $gid)) && !($closed['closed']) ) {
      return ticket_mng($u_id, $gid, $tid);
    }
    elseif ( ticket_access('ticket reader', $u_id, $gid) ) {
      return ticket_view($u_id, $gid, $tid);
    }
    else {
      drupal_access_denied();
      return;
    }
  }
  else {
    drupal_goto('ticket/'. $u_id);
  }
}

/**
 * ticket_mng: ticket szerkesztes oldal
 * @param: $u_id - unit id
 * @param: $gid - group id
 * @param: $tid - ticket id
 */
function ticket_mng($u_id, $gid, $tid) {
  $ticket = drupal_get_form('ticket_edit', $u_id, $gid, $tid);
  $events = ticket_events_view($u_id, $gid, $tid);
  $add_event = drupal_get_form('ticket_add_event', $u_id, $gid, $tid);
  $move = drupal_get_form('ticket_move', $u_id, $gid, $tid);

  return theme('ticket_mng', $u_id, $gid, $tid, $ticket, $events, $add_event, $move);
}

/**
 * ticket_mng: ticket szerkesztes oldal
 * @param: $u_id - unit id
 * @param: $gid - group id
 * @param: $tid - ticket id
 */
function theme_ticket_mng($u_id, $gid, $tid, $ticket, $events, $add_event, $move) {

  $bc = drupal_get_breadcrumb();
  $bc[] = l(_ticket_group_name($gid), 'ticket/'. $u_id .'/'. $gid);
  drupal_set_breadcrumb($bc);

  drupal_set_title( t('Ticket ID: !tid', array('!tid' => $tid) ) );

  // hibajegy keszitojenek es lezart allapotanak lekerdezese
  $result = db_query("SELECT uid FROM {ticket_ticket} WHERE tid = %d", $tid);
  $uid = db_fetch_array($result);
  $creator = theme('username', user_load($uid['uid']));

  $output = '<div id="ticket">';
  $output .= '<fieldset class=" collapsible"><legend>'. t('Ticket') .'</legend>';
  $output .= '<div>'. t('Created by: !name', array('!name' => $creator)) ."</div>\n";
  $output .= $ticket ."</fieldset></div>\n";

  if ( ! empty($events) ) {
    $output .= '<fieldset class=" collapsible"><legend>'. t('Events') .'</legend>'. $events .'</fieldset>';
  }

  $output .= $add_event;
  $output .= $move;

  return $output;
}

/**
 * ticket_edit: ticket szerkesztes
 * @param: $u_id - unit id
 * @param: $gid - group id
 * @param: $tid - ticket id
 */
function ticket_edit(&$form_state, $u_id, $gid, $tid) {
  // alapertelmezett ertekek
  $SQL = "SELECT t.tid, t.gid, t.uid, t.start, t.finish, t.summary, t.detail, t.affected, t.actions";
  $SQL .= ", t.time_to_fix, t.fix, t.assigned, t.cc, tt.type_id, tp.weight, tp.priority_id";
  $SQL .= ", tf.fixer_id, tsc.scope_id, tsi.site_id, tre.num";
  $SQL .= " FROM {ticket_ticket} t, {ticket_rel_event} tre, {ticket_priority} tp, {ticket_type} tt, {users} u";
  $SQL .= ", {ticket_fixer} tf, {ticket_scope} tsc, {ticket_site} tsi";
  $SQL .= " WHERE t.tid = %d AND t.tid = tre.tid AND t.priority_id = tp.priority_id AND t.type_id = tt.type_id";
  $SQL .= " AND t.assigned = u.uid AND t.fixer_id = tf.fixer_id AND t.scope_id = tsc.scope_id AND t.site_id = tsi.site_id";

  $result = db_query($SQL, $tid);
  $ticket = db_fetch_array($result);
  $ticket['start'] = format_date($ticket['start'], 'custom', 'Y-m-d H:i');
  if ( empty($ticket['finish']) ) {
    $ticket['finish'] = date('*Y-m-d H:i');
  }
  else {
    $ticket['finish'] = format_date($ticket['finish'], 'custom', 'Y-m-d H:i');
  }

  // feltoltott file lista
  if ( ticket_access('ticket upload files', $u_id, $gid) || ticket_access('view ticket uploaded files', $u_id, $gid) ) {
    $SQL = "SELECT fid, tid, eid, uid, filename, filemime, filesize, timestamp, list FROM {ticket_files}";
    $SQL .= " WHERE tid = %d AND eid = 0";
    if ( !ticket_access('ticket upload files', $u_id, $gid) && ticket_access('view ticket uploaded files', $u_id, $gid) ) {
      $SQL .= " AND list = 1";
    }
    $SQL .= " ORDER BY filename, timestamp";
    $result = db_query($SQL, $tid);
    while ( $file = db_fetch_array($result) ) {
      $ticket['files'][$file['fid']] = $file;
    }

  }

  // form elkeszitese
  $form = _ticket_form($u_id, $gid, 0, $ticket);

  $form['u_id'] = array(
    '#type' => 'value',
    '#value' => $u_id,
  );

  $form['gid'] = array(
    '#type' => 'value',
    '#value' => $gid,
  );

  $form['tid'] = array(
    '#type' => 'value',
    '#value' => $tid,
  );

  $form['assigned_id'] = array(
    '#type' => 'value',
    '#value' => $ticket['assigned'],
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#prefix' => '<div class = "ticket-help">'. l(t('help'), 'ticket/help/ticket') .'</div><div class="ticket-line">',
    '#suffix' => '</div>',
  );

  $SQL = 'SELECT status_id, status_name, def FROM {ticket_status} WHERE gid = %d AND active = 1 AND closed = 1 ORDER BY weight, status_name';
  $result = db_query($SQL, $gid);
  while ($row = db_fetch_array($result)) {
    $closed[$row['status_id']] = $row['status_name'];
    if ( ($row['def']) && ( !isset($def['status_id']) ) ) {
      $def['status_id'] = $row['status_id'];
    }
  }

  // ticket lezarashoz status valasztas
  if ( count($closed) ) {
    $form['sub']['status'] = array(
      '#type' => 'select',
      '#title' => t('Status'),
      '#options' => $closed,
      '#default_value' => $def['status_id'],
      '#prefix' => '<div class="ticket-line">',
      '#suffix' => '</div>',
      '#required' => TRUE,
    );

    $form['sub']['close'] = array(
      '#type' => 'submit',
      '#value' => t('Close'),
      '#prefix' => '<div class="ticket-line">',
      '#suffix' => '</div>',
    );
  }
  return $form;
}

/**
 * ticket_edit_validate: ticket modositas ellenorzese
 */
function ticket_edit_validate($form, &$form_state) {
  // problem finish mezoben levo datum ellenorzese
  if ( (!empty($form_state['values']['finish']) && ( drupal_substr($form_state['values']['finish'], 0, 1) != '*' ) ) || ($form_state['values']['op'] == t('Close')) ) {
    if (strtotime($form_state['values']['finish']) <= 0) {
      form_set_error('finish', t('Non-date format.'));
    }
    if (strtotime($form['start']['#value']) > 0) {
      if (strtotime($form['start']['#value']) > strtotime($form_state['values']['finish'])) {
        form_set_error('finish', t('Date is earlier than Problem started!'));
      }
    }
  }

  // cc mezoben levo mail cim(ek) ellenorzese
  if ($form_state['values']['cc'] != '') {
    if ( !_ticket_chk_emails($form_state['values']['cc']) ) {
      form_set_error('cc', t('Faulty e-mail adddress(es).'));
    }
  }
}

/**
 * ticket_edit_submit: ticket modositas submit
 */
function ticket_edit_submit($form, &$form_state) {
  global $user;

  $form_state['values']['cc'] = preg_replace(array('/ +/', '/ ,+/'), array(' ', ','), $form_state['values']['cc']);

  // kezdo idopont ellenorzese, ha nem volt megadva az aktualis idovel valo feltoltese.
  $form_state['values']['start'] = strtotime($form['start']['#value']);
  // ha van megadva finish ido akkor annak megfelelo formaba hozasa, es az SQL kiegeszitese.
  if ( ( !empty($form_state['values']['finish']) ) && ( drupal_substr($form_state['values']['finish'], 0, 1) != '*' ) ) {
    $form_state['values']['finish'] = strtotime($form_state['values']['finish']);
    $sql_extra = ", finish = %d";
  }
  else {
    $form_state['values']['finish'] = 'NULL';
    $sql_extra = ", finish = %s";
  }

  // ticket modositasa.
  $SQL = "UPDATE {ticket_ticket} SET priority_id = %d, type_id = %d, scope_id = %d, site_id = %d, fixer_id = %d, cc = '%s',";
  $SQL .= " summary = '%s', detail = '%s', affected = '%s', actions = '%s', time_to_fix = '%s', fix = '%s'". $sql_extra;
  $SQL .= " WHERE tid = %d";
  db_query($SQL, $form_state['values']['priority'], $form_state['values']['type'], $form_state['values']['scope'], $form_state['values']['site'], $form_state['values']['fixer'], $form_state['values']['cc'], $form_state['values']['summary'], $form_state['values']['detail'], $form_state['values']['affected'], $form_state['values']['actions'], $form_state['values']['time_to_fix'], $form_state['values']['fix'], $form_state['values']['finish'], $form_state['values']['tid']);

  // ticket id - mail id parok torlese
  db_query("DELETE FROM {ticket_rel_ticket_email} WHERE tid = %d", $form_state['values']['tid']);
  if ( count($form_state['values']['mail']) ) {
    $form_state['values']['mail'] = array_diff($form_state['values']['mail'], array(0));
  }
  // az uj mail id - ticket id parok letrehozasa
  if ( count($form_state['values']['mail']) ) {
    foreach ($form_state['values']['mail'] as $key => $mail_id) {
      db_query("INSERT INTO {ticket_rel_ticket_email} (tid, email_id) VALUES (%d, %d)", $form_state['values']['tid'], $key);
    }
  }

  $now = time();
  if ( ticket_access('ticket upload files', $form_state['values']['u_id'], $form_state['values']['gid']) ) {
    if ( !empty($form_state['values']['files']) ) {
      foreach ($form_state['values']['files'] as $file) {
        if ( $file['remove'] ) {
          if ( empty($file['filepath']) ) {
            db_query("DELETE FROM {ticket_files} WHERE fid = %d", $file['fid']);
          }
        }
        else {
          if ( empty($file['filepath']) ) {
            $SQL = "UPDATE {ticket_files} SET filename = '%s', list = %d WHERE fid = %d";
            db_query($SQL, $file['filename'], $file['list'], $file['fid']);
          }
          else {
            $file['timestamp'] = $now;
            _ticket_file_save($form_state['values']['tid'], 0, $user->uid, $file);
          }
        }
      }
    }
  }

  // hibajegy lezarasa
  if ($form_state['values']['op'] == t('Close')) {
    $result = db_query("SELECT eid FROM {ticket_event} WHERE uid = 0 AND tid = %d", $form_state['values']['tid']);
    // ha ez az elso esemeny akkor az ures esemenyt updatelni kell
    if ($row = db_fetch_array($result)) {
      $SQL = "UPDATE {ticket_event} SET uid = %d, created = %d, description = '%s', status_id = %d";
      $SQL .= " WHERE eid = %d";
      db_query($SQL, $user->uid, time(), t('Closed.'), $form_state['values']['status'], $row['eid']);
    }
    else {
      _ticket_insert_event($form_state['values']['tid'], $user->uid, $form_state['values']['assigned_id'], $now, t('Closed.'), $form_state['values']['status']);
    }
    db_query("UPDATE {ticket_ticket} SET closed = 1 WHERE tid = %d", $form_state['values']['tid']);
    // level kuldes
    $result = db_query("SELECT * FROM {ticket_template} WHERE gid = %d", $form_state['values']['gid']);
    $template = db_fetch_array($result);
    if ( !empty($template['mail_address'] ) ) {
      drupal_mail('ticket', 'close_ticket', '', language_default(), array('tid' => $form_state['values']['tid'], 'template' => $template), NULL, FALSE);
    }
  }
}

/**
 * ticket_add_event: add event
 */
function ticket_add_event(&$form_state, $u_id, $gid, $tid) {
  // esemeny form elkeszitese
  $form['sub'] = array(
    '#type' => 'fieldset',
    '#title' => t('Add event'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $form['sub']['description'] = array(
    '#type' => 'textarea',
    '#title' => t('Description'),
    '#rows' => '6',
    '#required' => TRUE,
  );

  // statusok levalogatasa, szinezese, a legutolso status lesz az alapertelmezett
  $SQL = 'SELECT status_id, status_name, stage, def FROM {ticket_status} WHERE gid = %d AND active = 1 AND closed = 0 ORDER BY weight, status_name';
  $result = db_query($SQL, $gid);
  while ($row = db_fetch_array($result)) {
    $status[$row['status_id']] = $row['status_name'];
    $status_stage[$row['status_id']] = 'stage-'. $row['stage'];
    if ( ($row['def']) && ( !isset($def['status_id']) ) ) {
      $def['status_id'] = $row['status_id'];
    }
  }
  // ha van felveve esemeny akkor az utolso statuszat allitja be
  $SQL = 'SELECT status_id FROM {ticket_event} te, {ticket_rel_event} tre';
  $SQL .= ' WHERE tre.tid = %d AND tre.eid = te.eid AND te.uid > 0 ORDER BY created DESC';
  $result = db_query($SQL, $tid);
  if ($row = db_fetch_array($result)) {
    $def['status_id'] = $row['status_id'];
  }

  if ( count($status) ) {
    $form['sub']['status'] = array(
      '#input' => TRUE,
      '#type' => 'select',
      '#title' => t('Status'),
      '#options' => $status,
      '#class' => $status_stage,
      '#default_value' => $def['status_id'],
      '#prefix' => '<div class="ticket-form-line">',
      '#suffix' => '</div>',
      '#required' => TRUE,
      '#theme' => 'color_select',
    );
  }

  // hibafelelosok kigyujtese, a legutoso felelos beallitasa alapertelmezettnek
  $SQL = "SELECT u.uid, u.name FROM {ticket_permission} tp, {users_roles} ur, {users} u ";
  $SQL .= " WHERE ( ( (tp.u_id = 0 OR tp.u_id = %d) AND tp.gid = 0 ) OR tp.gid = %d) AND tp.perm LIKE '%ticket manager%'";
  $SQL .= " AND ur.rid = tp.rid AND ur.uid = u.uid ORDER BY u.name";
  $result = db_query($SQL, $u_id, $gid);

  while ($row = db_fetch_array($result)) {
    $assigned[$row['uid']] = $row['name'];
  }
  $result = db_query_range("SELECT reassigned, created FROM {ticket_event} WHERE tid = %d ORDER BY created DESC", $tid, 0, 1);
  $row = db_fetch_array($result);
  $def['reassigned'] = $row['reassigned'];

  if ( count($assigned) ) {
    $form['sub']['assigned'] = array(
      '#type' => 'select',
      '#title' => t('Re-assigned to'),
      '#options' => $assigned,
      '#default_value' => $def['reassigned'],
      '#prefix' => '<div class="ticket-form-line">',
      '#suffix' => '</div>',
      '#required' => TRUE,
    );
  }
  if ( ticket_access('ticket upload files', $u_id, $gid) || ticket_access('view ticket uploaded files', $u_id, $gid) ) {
    $form_files = _ticket_files_form_add($u_id, $gid, $tid, 'new');
    $form['sub']['attachments'] = $form_files['attachments'];
    $form['#attributes'] = $form_files['#attributes'];

    unset($form_files);
  }

  $form['tid'] = array(
    '#type' => 'value',
    '#value' => $tid,
  );

  $form['u_id'] = array(
    '#type' => 'value',
    '#value' => $u_id,
  );

  $form['gid'] = array(
    '#type' => 'value',
    '#value' => $gid,
  );

  $form['sub']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#prefix' => '<div class = "ticket-help">'. l(t('help'), 'ticket/help/event') .'</div>',
  );
  return $form;
}

function _ticket_insert_event($tid, $uid, $assigned, $time, $description, $status) {
  $SQL = 'INSERT INTO {ticket_event} (tid, uid, reassigned, created, description, status_id)';
  $SQL .= " VALUES (%d, %d, %d, %d, '%s', %d)";
  db_query($SQL, $tid, $uid, $assigned, $time, $description, $status);
  $eid = db_last_insert_id('{ticket_event}', 'eid');
  $SQL = "UPDATE {ticket_rel_event} SET eid = %d, num = num+1 WHERE tid = %d";
  db_query($SQL, $eid, $tid);
  return $eid;
}

/**
 * ticket_add_event_submit: ticket event hozzaadas submit
 */
function ticket_add_event_submit($form, &$form_state) {
  global $user;

  $result = db_query("SELECT eid FROM {ticket_event} WHERE uid = 0 AND tid = %d", $form_state['values']['tid']);
  // ha ez az elso esemeny akkor az ures esemenyt updatelni kell
  $now = time();
  if ($row = db_fetch_array($result)) {
    $eid = $row['eid'];
    $SQL = "UPDATE {ticket_event} SET uid = %d, reassigned = %d, created = %d";
    $SQL .= ", description = '%s', status_id = %d WHERE eid = %d";
    db_query($SQL, $user->uid, $form_state['values']['assigned'], $now, $form_state['values']['description'], $form_state['values']['status'], $eid);
    $SQL = "UPDATE {ticket_rel_event} SET num = num+1 WHERE tid = %d";
    db_query($SQL, $form_state['values']['tid']);
  }
  else {
    $eid = _ticket_insert_event($form_state['values']['tid'], $user->uid, $form_state['values']['assigned'], $now, $form_state['values']['description'], $form_state['values']['status']);
  }

  // File csatolas
  if ( ticket_access('ticket upload files', $form_state['values']['u_id'], $form_state['values']['gid']) ) {
    if ( !empty($form_state['values']['files']) ) {
      foreach ($form_state['values']['files'] as $file) {
        if ( !$file['remove'] ) {
          $file['timestamp'] = $now;
          _ticket_file_save($form_state['values']['tid'], $eid, $user->uid, $file);
        }
      }
    }
  }

  // level kuldes
  $result = db_query("SELECT * FROM {ticket_template} WHERE gid = %d", $form_state['values']['gid']);
  $template = db_fetch_array($result);
  if ( !empty($template['mail_address'] ) ) {
    drupal_mail('ticket', 'add_event', '', language_default(), array('tid' => $form_state['values']['tid'], 'template' => $template), NULL, FALSE);

    if ( ($form['sub']['assigned']['#default_value'] != $form_state['values']['assigned']) || ($form_state['values']['assigned'] != $user->uid) ) {
      drupal_mail('ticket', 'new_assigned', '', language_default(), array('tid' => $form_state['values']['tid'], 'eid' => $eid, 'template' => $template), NULL, FALSE);
    }
  }
}

/**
 * ticket_move: ticket atmozgatasa masik csoportba
 */
function ticket_move(&$form_state, $u_id, $gid, $tid) {
  global $user;

  // hibajegy mozgatasa olyan csoportba ahol a felhasznalo ticket managger joggal rendelkezik
  $SQL = "SELECT count(*) AS count FROM {ticket_permission} tp, {users_roles} ur, {permission} p";
  $SQL .= " WHERE ur.uid = %d AND tp.perm LIKE '%ticket manager%' AND p.perm LIKE '%ticket access%'";
  $SQL .= " AND tp.rid = ur.rid AND tp.rid = p.rid AND ( (tp.u_id = 0 OR tp.u_id = %d) AND tp.gid = 0)";
  $result = db_query($SQL, $user->uid, $u_id);
  $row = db_fetch_array($result);
  if ( $row['count'] ) {
    $SQL = "SELECT gid, group_name FROM {ticket_group} WHERE u_id = %d ORDER BY group_name";
    $result = db_query($SQL, $u_id);
  }
  else {
    $SQL = "SELECT tg.gid, tg.group_name";
    $SQL .= " FROM {ticket_permission} tp, {users_roles} ur, {permission} p, {ticket_group} tg";
    $SQL .= " WHERE ur.uid = %d AND tp.perm LIKE '%ticket manager%' AND p.perm LIKE '%ticket access%'";
    $SQL .= " AND tp.rid = ur.rid AND tp.rid = p.rid AND tp.u_id = %d AND tp.gid = tg.gid";
    $result = db_query($SQL, $user->uid, $u_id);
  }
  $groups = array();
  while ($row = db_fetch_array($result)) {
    $groups[$row['gid']] = $row['group_name'];
  }

  // mozgatas form
  $form['move'] = array(
    '#type' => 'fieldset',
    '#title' => t('Move to'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $form['move']['group'] = array(
    '#type' => 'select',
    '#title' => t('Group'),
    '#options' => $groups,
    '#default_value' => $gid,
    '#prefix' => '<div class="ticket-form-line">',
    '#suffix' => '</div>',
  );
  $form['u_id'] = array(
    '#type' => 'value',
    '#value' => $u_id,
  );

  $form['gid'] = array(
    '#type' => 'value',
    '#value' => $gid,
  );

  $form['tid'] = array(
    '#type' => 'value',
    '#value' => $tid,
  );

  $form['move']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Move to'),
    '#prefix' => '<div class = "ticket-help">'. l(t('help'), 'ticket/help/moveto') .'</div>',
  );

  return $form;
}

/**
 * ticket_move_submit: ticket atmozgatasa masik csoportba, submit
 */
function ticket_move_submit($form, &$form_state) {
  $SQL = "SELECT tp.priority_name, tt.type_name, tsc.scope_name, tsi.site_name, tf.fixer_name ";
  $SQL .= " FROM {ticket_ticket} t, {ticket_priority} tp, {ticket_type} tt, {ticket_scope} tsc, {ticket_site} tsi, {ticket_fixer} tf";
  $SQL .= " WHERE t.tid = %d AND t.priority_id = tp.priority_id AND t.type_id = tt.type_id AND t.scope_id = tsc.scope_id AND t.site_id = tsi.site_id AND t.fixer_id = tf.fixer_id";
  $result = db_query($SQL, $form_state['values']['tid']);
  if ($row = db_fetch_array($result)) {
    // azonos nevu tulajdonsagok keresese
    $list = array('type', 'priority', 'scope', 'site', 'fixer');
    foreach ($list as $element) {
      $SQL = "SELECT ". $element ."_id FROM {ticket_". $element ."} ";
      $SQL .= " WHERE gid = %d AND ". $element ."_name = '%s' ORDER BY def";
      $rs = db_query($SQL, $form_state['values']['group'], $row[$element .'_name']);
      // ha van egyezo akkor frissitunk arra
      if ($re = db_fetch_array($rs)) {
        db_query("UPDATE {ticket_ticket} SET ". $element ."_id = %d WHERE tid = %d", $re[$element .'_id'], $form_state['values']['tid']);
      }
      else {
        // alapertelmezett tulajdonsag kikeresese, ha nincs akkor 0
        $SQL = "SELECT ". $element ."_id FROM {ticket_". $element ."} ";
        $SQL .= ' WHERE gid = %d AND def = 1 ORDER BY def';
        $rs = db_query($SQL, $form_state['values']['group']);
        if ($re = db_fetch_array($rs)) {
          db_query("UPDATE {ticket_ticket} SET ". $element ."_id = %d WHERE tid = %d", $re[$element .'_id'], $form_state['values']['tid']);
        }
        else {
          db_query("UPDATE {ticket_ticket} SET ". $element ."_id = 1 WHERE tid = %d", $form_state['values']['tid']);
        }
      }
    }
  }

  // levelezo "partnerek" atvitele
  $result = db_query("SELECT tm.mailto FROM {ticket_rel_ticket_email} tr, {ticket_email} tm WHERE tr.tid = %d AND tr.email_id = tm.email_id", $form['tid']);
  $mail = array();
  while ($row = db_fetch_array($result)) {
    $mail[] = $row['mailto'];
  }
  if ( count($mail) ) {
    $SQL = "SELECT email_id FROM {ticket_email} WHERE gid = %d AND mailto IN (". implode(',', array_map("_ticket_txt2db", $mail)) .') ORDER BY def';
    $result = db_query($SQL, $form_state['values']['group']);
    db_query("DELETE FROM {ticket_rel_ticket_email} WHERE tid = %d", $form_state['values']['tid']);
    if ( db_num_rows($result) ) {
      while ($row = db_fetch_array($result)) {
        db_query("INSERT INTO {ticket_rel_ticket_email} (tid, email_id) VALUES (%d, %d)", $form_state['values']['tid'], $row['email_id']);
      }
    }
    else {
      $SQL = 'SELECT email_id FROM {ticket_email} WHERE gid = %d AND def = 1 ORDER BY def';
      $result = db_query($SQL, $form_state['values']['group']);
      while ($row = db_fetch_array($result)) {
        db_query("INSERT INTO {ticket_rel_ticket_email} (tid, email_id) VALUES (%d, %d)", $form_state['values']['tid'], $row['email_id']);
      }
    }
  }

  // Esemeny mozgatasa, vagy uj esemeny hozzafuzese.
  $SQL = "SELECT te.eid, te.uid, te.tid, te.reassigned, ts.status_name FROM {ticket_event} te, {ticket_status} ts";
  $SQL .= " WHERE te.tid = %d AND te.status_id = ts.status_id ORDER BY te.created DESC ";
  $result = db_query($SQL, $form_state['values']['tid']);
  if ($row = db_fetch_array($result)) {
    $SQL = "SELECT status_id FROM {ticket_status} WHERE gid = %d AND status_name = '%s' ORDER BY def";
    $rs = db_query($SQL, $form_state['values']['group'], $row['status_name']);
    // ha van egyezo akkor frissitunk arra
    if ($s_row = db_fetch_array($rs)) {
      db_query("UPDATE {ticket_event} SET status_id = %d WHERE eid = %d", $s_row['status_id'], $row['eid']);
    }
    else {
      $SQL = 'SELECT status_id FROM {ticket_status} WHERE gid = %d AND def = 1 ORDER BY def';
      $rs = db_query($SQL, $form_state['values']['group']);
      if ($s_row = db_fetch_array($rs)) {
        if ($row['uid'] == 0) {
          // ha nem volt meg esemeny akkor az alapertelmezettre modositjuk az allapot jelzot
          db_query("UPDATE {ticket_event} SET status_id = %d WHERE eid = %d", $s_row['status_id'], $row['eid']);
        }
        else {
          // ha volt mar esemeny akkor, uj esemeny hozza fuzese
          _ticket_insert_event($row['tid'], $user->uid, $row['reassigned'], time(), t('Reloacted.'), $s_row['status_id']);
        }
      }
    }
  }
  // ugras az uj cimere
  db_query("UPDATE {ticket_ticket} SET gid = %d WHERE tid = %d", $form_state['values']['group'], $form_state['values']['tid']);
  drupal_goto('ticket/'. $form_state['values']['u_id'] .'/'. $form_state['values']['group'] .'/'. $form_state['values']['tid']);
}


/**
 * ticket_view: ticket oldal megjelenitese
 * @param: $u_id - unit id
 * @param: $gid - group id
 * @param: $tid - ticket id
 */
function ticket_view($u_id, $gid, $tid) {
  $SQL = "SELECT t.tid, t.gid, t.uid, t.assigned, t.start, t.finish, t.summary, t.detail, t.affected, t.actions";
  $SQL .= ", t.time_to_fix, t.fix, t.closed, u.name, tt.type_name, tp.weight, tp.priority_name";
  $SQL .= ", tf.fixer_name, tsc.scope_name, tsi.site_name, tre.num";
  $SQL .= " FROM {ticket_ticket} t, {ticket_rel_event} tre, {ticket_priority} tp, {ticket_type} tt, {users} u";
  $SQL .= ", {ticket_fixer} tf, {ticket_scope} tsc, {ticket_site} tsi";
  $SQL .= " WHERE t.tid = %d AND t.tid = tre.tid AND t.priority_id = tp.priority_id AND t.type_id = tt.type_id";
  $SQL .= " AND t.assigned = u.uid AND t.fixer_id = tf.fixer_id AND t.scope_id = tsc.scope_id AND t.site_id = tsi.site_id";

  $result = db_query($SQL, $tid);
  $ticket = db_fetch_array($result);

  if ( ticket_access('ticket upload files', $u_id, $gid) || ticket_access('view ticket uploaded files', $u_id, $gid) ) {
    $SQL = "SELECT fid, tid, eid, uid, filename, filemime, filesize, timestamp, list FROM {ticket_files}";
    $SQL .= " WHERE tid = %d AND eid = 0";
    if ( !ticket_access('ticket upload files', $u_id, $gid) && ticket_access('view ticket uploaded files', $u_id, $gid) ) {
      $SQL .= " AND list = 1";
    }
    $SQL .= " ORDER BY filename";
    $rs = db_query($SQL, $tid);
    while ($file = db_fetch_array($rs)) {
      $ticket['files'][] = $file;
    }
  }

  $events = $reopen = '';
  if ($ticket['num']) {
    $events = ticket_events_view($u_id, $gid, $tid);
  }

  if ( ticket_access('ticket manager', $u_id, $gid) ) {
    $reopen = drupal_get_form('ticket_reopen', $gid, $tid, $ticket['assigned']);
  }
  $ticket = theme('ticket_ticket_view', $ticket);

  return theme('ticket_view', $ticket, $events, $reopen);
}

/**
 * theme_ticket_ticket_view: ticket megjelenitese
 * @param: $ticket - ticket adatlapja
 * @param: $events - tickethez tartozo esemenyek
 * @param: $reopen - ticket ujramegnyitasara szolgal
 */
function theme_ticket_view($ticket, $events, $reopen) {
  $output = '<div id="ticket">'. $ticket .'</div>';
  if ( !empty($events) ) {
    $output .= '<div id="events">';
    $output .= '<div class="head">'. t('Events') .':</div>';
    $output .= $events .'</div>';
  }

  if ( !empty($reopen) ) {
    $output .= '<div id="reopen">';
    $output .= $reopen;
    $output .= '</div>';
  }

  return $output;
}

/**
 * theme_ticket_ticket_view: ticket megjelenitese
 * @param: $ticket - ticket adatlapja
 */
function theme_ticket_ticket_view($ticket) {
  $result = db_query("SELECT tu.u_id, tu.unit_name FROM {ticket_unit} tu, {ticket_group} tg WHERE tu.u_id = tg.u_id AND tg.gid = %d", $ticket['gid']);
  $unit = db_fetch_array($result);

  $bc = drupal_get_breadcrumb();
  $bc[] = l(_ticket_group_name($ticket['gid']) , 'ticket/'. $unit['u_id'] .'/'. $ticket['gid']);
  drupal_set_breadcrumb($bc);

  drupal_set_title( t('Ticket ID: !tid', array('!tid' => $ticket['tid']) ) );

  // hibajegy keszitojenek es lezart allapotanak lekerdezese
  $creator = theme('username', user_load($ticket['uid']));
  $output .= '<div>'. t('Created by: !name', array('!name' => $creator)) ."</div>\n";
  // hibajegy tablazatos kiiratasa
  $output .= '<table class = "view">'."\n";
  $output .= '<tr><td class="head">'. t('Type') .': </td> <td>'. $ticket['type_name'] .'</td> <td class="head">'. t('Priority') .':  </td> <td class="priority-'. $ticket['weight'] .'">'. $ticket['priority_name'] .'</td></tr>'."\n";
  $i = 0;
  if ( $ticket['scope_name'] != '-' ) {
    $output .= '<tr><td class="head">'. t('Scope') .':  </td> <td>'. $ticket['scope_name'] .'</td>';
    $i++;
  }

  if ( $ticket['site_name'] != '-' ) {
    if ( $i%2 ) {
      $output .= ' <td class="head">'. t('Site') .':  </td> <td>'. $ticket['site_name'] .'</td></tr>'."\n";
    }
    else {
      $output .= '<tr><td class="head">'. t('Site') .':  </td> <td>'. $ticket['site_name'] .'</td>';
    }
    $i++;
  }

  if ( $ticket['fixer_name'] != '-' ) {
    if ( $i%2 ) {
      $output .= ' <td class="head">'. t('Fixer') .':  </td> <td>'. $ticket['fixer_name'] .'</td></tr>'."\n";
    }
    else {
      $output .= '<tr><td class="head">'. t('Fixer') .':  </td> <td>'. $ticket['fixer_name'] .'</td>';
    }
    $i++;
  }

  if ( $i%2 ) {
    $output .= ' <td class="head">'. t('Assigned to') .':  </td> <td>'. $ticket['name'] .'</td></tr>'."\n";
  }
  else {
    $output .= '<tr><td class="head">'. t('Assigned to') .':  </td> <td>'. $ticket['name'] .'</td> <td></td><td></td></tr>'."\n";
  }

  $output .= '<tr><td class="head">'. t('Problem started') .':  </td> <td>'. format_date($ticket['start'], 'small') .'</td>';
  $output .= ' <td class="head">'. t('Problem finish') .':  </td> <td>';
  if ($ticket['closed']) {
    $output .= format_date($ticket['finish'], 'small');
  }
  else {
    $output .= t('Not closed!');
  }

  $output .= '</td></tr>'."\n";
  $output .= '</table>'."\n";

  if ( isset($ticket['sent_mail']) && ($ticket['sent_mail'] != '') ) {
    $output .= '<div class="head">'. t('Sent mail') .":</div>\n";
    $output .= '<div class="data">'. $ticket['sent_mail'] ."</div>\n";
  }
  if ( isset($ticket['cc']) && ($ticket['cc'] != '') ) {
    $output .= '<div class="head">'. t('CC') .":</div>\n";
    $output .= '<div class="data">'. $ticket['cc'] ."</div>\n";
  }

  $output .= '<div class="head">'. t('Short summary') .":</div>\n";
  $output .= '<div class="data">'. htmlspecialchars($ticket['summary'], ENT_QUOTES, 'UTF-8') ."</div>\n";
  $output .= '<div class="head">'. t('Detail') .":</div>\n";
  $output .= '<div class="data">'. nl2br(htmlspecialchars($ticket['detail'], ENT_QUOTES, 'UTF-8')) ."</div>\n";
  if ($ticket['affected'] != '') {
    $output .= '<div class="head">'. t('Affected') .":</div>\n";
    $output .= '<div class="data">'. nl2br(htmlspecialchars($ticket['affected'], ENT_QUOTES, 'UTF-8')) ."</div>\n";
  }
  if ($ticket['action'] != '') {
    $output .= '<div class="head">'. t('Action') .":</div>\n";
    $output .= '<div class="data">'. nl2br(htmlspecialchars($ticket['action'], ENT_QUOTES, 'UTF-8')) ."</div>\n";
  }
  if ($ticket['time_to_fix'] != '') {
    $output .= '<div class="head">'. t('Time to fix') .":</div>\n";
    $output .= '<div class="data">'. htmlspecialchars($ticket['time_to_fix'], ENT_QUOTES, 'UTF-8') ."</div>\n";
  }
  if ($ticket['fix'] != '') {
    $output .= '<div class="head">'. t('Fix') .":</div>\n";
    $output .= '<div class="data">'. nl2br(htmlspecialchars($ticket['fix'], ENT_QUOTES, 'UTF-8')) ."</div>\n";
  }

  if ( isset($ticket['files']) ) {
    $output .= theme('ticket_files_view', $ticket['files']);
  }

  return $output;
}

/*
 * theme_ticket_files_view: hibajegyhez csatolt allomanyok listazasa
 */
function theme_ticket_files_view($files) {
  $header = array(
    t('File attachments'),
    t('Size'),
  );
  $rows = array();
  foreach ($files as $file) {
    $rows[] = array(
    l($file['filename'], 'ticket/files/'. $file['fid'] .'/'. $file['filename'], array('attributes' => array('target' => '_blank'))),
    format_size($file['filesize']),
    );
  }
  return theme('table', $header, $rows);
}


/**
 * ticket_events_view: ticket esemenyek lekerdezese
 * @param: $u_id - unit id
 * @param: $gid - group id
 * @param: $tid - ticket id
 */
function ticket_events_view($u_id, $gid, $tid) {
  // tablazat fejlece
  $header = array(
    array('data' => t('Date')),
    array('data' => t('Description')),
    array('data' => t('Added by')),
    array('data' => t('Assigned to')),
    array('data' => t('Status')),
  );

  if ( ticket_access('ticket upload files', $u_id, $gid) || ticket_access('view ticket uploaded files', $u_id, $gid) ) {
    $SQL = "SELECT eid FROM {ticket_files}";
    $SQL .= " WHERE tid = %d AND eid > 0";
    if ( !ticket_access('ticket upload files', $u_id, $gid) && ticket_access('view ticket uploaded files', $u_id, $gid) ) {
      $SQL .= " AND list = 1";
    }
    $result = db_query($SQL, $tid);
    $eid_list = array();
    while ( $row = db_fetch_array($result) ) {
      $eid_list[$row['eid']] = $row['eid'];
    }
  }

  $file_column = count($eid_list);

  if ( $file_column ) {
    $header[] = array('data' => t('File attachments'));
  }


  $result = db_query("SELECT e.eid, e.created, e.description, e.uid, e.reassigned, ts.status_name, ts.stage FROM {ticket_event} e, {ticket_status} ts WHERE e.uid > 0 AND e.status_id = ts.status_id AND tid = %d ORDER BY e.created", $tid);
  $rows = array();
  // esemenyek tablazatba irasa
  while ($row = db_fetch_array($result)) {
    if ( isset($eid_list[$row['eid']]) ) {
      $SQL = "SELECT fid, tid, eid, uid, filename, filemime, filesize, timestamp, list FROM {ticket_files}";
      $SQL .= " WHERE eid = %d";
      if ( !ticket_access('ticket upload files', $u_id, $gid) && ticket_access('view ticket uploaded files', $u_id, $gid) ) {
        $SQL .= " AND list = 1";
      }
      $rs = db_query($SQL, $row['eid']);
      while ($file = db_fetch_array($rs)) {
        $files[] = '<span class = "ticket-nowrap">'. l($file['filename'], 'ticket/files/'. $file['fid'] .'/'. $file['filename'], array('attributes' => array('target' => '_blank'))) .' ('. format_size($file['filesize']) .')</span>';
      }
    }
    $line = array(
    array('data' => format_date($row['created'], 'small') ),
    array('data' => nl2br(htmlspecialchars($row['description'], ENT_QUOTES, 'UTF-8'))),
    array('data' => theme('username', user_load($row['uid'])) ),
    array('data' => theme('username', user_load($row['reassigned'])) ),
    array('data' => $row['status_name'], 'class' => 'stage-'. $row['stage']),
    );
    if ( isset($eid_list[$row['eid']]) ) {
      $line[] = implode(', ', $files);
    }
    elseif ( $file_column ) {
      $line[] = '';
    }
    $rows[] = $line;
    $files = array();
  }
  if ( !empty($rows)) {
    return theme('ticket_events_view', $header, $rows);
  }
}

/**
 * theme_ticket_events_view: ticket esemenyek megjelenitese
 * @param: $tid - ticket id
 */
function theme_ticket_events_view($header, $rows) {
  return theme('table', $header, $rows);
}

/**
 * ticket_reopen: ticket ujranyitasa
 * @param: $gid - group id
 * @param: $tid - ticket id
 * @param: $assigned - assigned user id
 */
function ticket_reopen(&$form_state, $gid, $tid, $assigned) {
  // ujra megnyitashoz szukseges form
  $form['gid'] = array(
    '#type' => 'value',
    '#value' => $gid,
  );

  $form['tid'] = array(
    '#type' => 'value',
    '#value' => $tid,
  );

  $form['assigned'] = array(
    '#type' => 'value',
    '#value' => $assigned,
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Reopen')
  );
  return $form;
}

/**
 * ticket_reopen_submit: ticket ujranyitasa
 */
function ticket_reopen_submit($form, &$form_state) {
  global $user;

  $result = db_query('SELECT status_id FROM {ticket_status} WHERE gid = %d AND def = 1', $form_state['values']['gid']);
  if ( $row = db_fetch_array($result) ) {
    _ticket_insert_event($form_state['values']['tid'], $user->uid, $form_state['values']['assigned'], time(), t('Reopen.'), $row['status_id']);
    db_query("UPDATE {ticket_ticket} SET closed = 0 WHERE tid = %d", $form_state['values']['tid']);
  }
}

/**
 * ticket_queue: ticket ujranyitasa
 */
function ticket_queue($u_id, $gid, $qid = NULL) {
  global $ticket_conf;

  if ( _ticket_menu_active($u_id, $gid) ) {
    if ( empty($qid) ) {
      // elbiralasra varo hibajelentesek listaja
      $SQL = "SELECT tq.qid, tp.weight, tp.priority_name, tsc.scope_name, tsi.site_name, tq.created, tq.summary ";
      $SQL .= " FROM {ticket_queue} tq, {ticket_priority} tp, {ticket_scope} tsc, {ticket_site} tsi";
      $SQL .= " WHERE tq.gid = %d AND tq.priority_id = tp.priority_id AND tq.scope_id = tsc.scope_id";
      $SQL .= " AND tq.site_id = tsi.site_id ORDER BY tq.created DESC";

      // egy oldalra kerulo sorok szama
      $result = pager_query($SQL, $ticket_conf['limit'], 0, NULL, $gid);

      while ( $row = db_fetch_array($result) ) {
        $rows[] = array(
          array('data' => l($row['summary'], 'ticket/'. $u_id .'/'. $gid .'/queue/'. $row['qid'])),
          array('data' => $row['priority_name'], 'class' => 'priority-'. $row['weight']),
          array('data' => $row['scope_name']),
          array('data' => $row['site_name']),
          array('data' => format_date($row['created'], 'small') ),
        );
      }
      // tablazat kiirasa
      return theme('ticket_queue_list', $rows);
    }
    elseif ( is_numeric($qid) ) {
      $result = db_query("SELECT * FROM {ticket_queue} WHERE qid = %d", $qid);
      if ( $q = db_fetch_array($result) ) {
        drupal_set_title(t('Queue') .' - '. $q['summary']);
        $q['u_id'] = $u_id;
        return drupal_get_form('ticket_queue_mng', $q);
      }
    }
    drupal_goto('ticket/'. $u_id .'/'. $gid);
  }
  else {
    drupal_goto('ticket/'. $u_id);
  }
}

/**
 * theme_ticket_queue_list: queue list theme hook
 */
function theme_ticket_queue_list($rows) {
  drupal_add_css(drupal_get_path('module', 'ticket') .'/ticket.css');
  drupal_set_title(t('Queue'));

  $header = array(
    array('data' => t('Summary')),
    array('data' => t('Priority')),
    array('data' => t('Scope')),
    array('data' => t('Site')),
    array('data' => t('Date')),
  );
  $output = '<div id="ticket">';
  $output .= theme('table', $header, $rows);
  $output .= '</div>';

  return $output;
}

function ticket_queue_mng(&$form_state, $q) {
  global $user;

  drupal_add_css(drupal_get_path('module', 'ticket') .'/ticket.css');

  $q['start'] = format_date($q['created'], 'small');

  $form = array();
  if ($q['uid']) {
    $q_user = user_load($q['uid']);
    $q_user_name = $q_user->name;
    unset($q_user);
  }
  else {
    $q_user_name = variable_get('anonymous', t('Anonymous'));
  }

  $form['authored'] = array(
    '#input' => TRUE,
    '#type' => 'radios',
    '#title' => t('Created by'),
    '#options' => array($q['uid'] => $q_user_name, $user->uid => $user->name),
    '#required' => TRUE,
    '#description' => t('Choose the ticket owner. The owner can either remain the original entity who created the ticket or can be the original ticket sender.'),
  );

  // form letrehozasa
  $form += _ticket_form($q['u_id'], $q['gid'], 1, $q);

  $form['u_id'] = array(
    '#type' => 'value',
    '#value' => $q['u_id'],
  );

  $form['gid'] = array(
    '#type' => 'value',
    '#value' => $q['gid'],
  );

  $form['qid'] = array(
    '#type' => 'value',
    '#value' => $q['qid'],
  );

  $form['uid'] = array(
    '#type' => 'value',
    '#value' => $q['uid'],
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );

  $form['delete'] = array(
    '#type' => 'submit',
    '#value' => t('Delete')
  );
  return $form;
}

/**
 * ticket_queue_mng_validate: validalas ticket add szerint ha nem torlunk
 */
function ticket_queue_mng_validate($form, &$form_state) {
  if ($form_state['values']['op'] != t('Delete')) {
    ticket_add_validate($form, $form_state);
  }
}

/**
 * ticket_queue_mng_submit: queue torlese, vagy queue elembol ticket
 * letrehozas
 */
function ticket_queue_mng_submit($form, &$form_state) {
  if ($form_state['values']['op'] != t('Delete')) {
    ticket_add_submit($form, $form_state, 0);
  }
  db_query("DELETE FROM {ticket_queue} WHERE qid = %d", $form_state['values']['qid']);
  $url = 'ticket/'. $form_state['values']['u_id'] .'/'. $form_state['values']['gid'];
  $title = '';
  $result = db_query("SELECT count(*) AS count FROM {ticket_queue} WHERE gid = %d GROUP BY gid", $form_state['values']['gid']);
  if ( $row = db_fetch_array($result) ) {
    $title = t('Queue (!num)', array('!num' => $row['count']));
    $url .= '/queue';
  }
  $menu = db_fetch_array( db_query("SELECT * FROM {menu_links} WHERE link_path = '%s' ", 'ticket/'. $form_state['values']['u_id'] .'/'. $form_state['values']['gid'] .'/queue') );
  $menu['options'] = array();
  $menu['link_title'] = $title;
  menu_link_save($menu);

  drupal_goto($url);
}

