<?php
// $Id: ticket.search.inc,v 1.1.4.4 2009/07/22 13:29:27 york Exp $
/**
 * _ticket_search_base: hibajegy kereses lelke
 * @param $def - alapertelmezett keresesi ertekek
 * @param $links - url parameter
 * @param $u_id - unit id
 * @param $gid - group id
 */
function _ticket_search_base($def, $links, $u_id = NULL, $gid = NULL) {
  $form = array();
  if ( isset($u_id) ) {
    $form['u_id'] = array(
      '#type' => 'value',
      '#value' => $u_id,
    );
  }
  else {
    $def['unit'] = -1;
  }

  if ( isset($gid) ) {
    $form['gid'] = array(
      '#type' => 'value',
      '#value' => $gid,
    );
  }
  else {
    $def['group'] = -1;
  }

  unset($links[0], $links[1]);
  // ha tortent kereses
  if ( count($links) ) {
    // a link parameterbol csinal tombot
    $links = _ticket_search_get_default($links);
    // link ertekeivel felul irja az alapertelmezett ertekeket
    $def = array_merge($def, $links);
    if ( !is_array($def['date1']) ) {
      // datum szetdarabolasa
      list($y, $m, $d) = explode('-', $def['date1']);
      $def['date1'] = array();
      $def['date1']['y'] = $y;
      $def['date1']['m'] = $m;
      $def['date1']['d'] = $d;
    }
    if ( !is_array($def['date2']) ) {
      // datum szetdarabolasa
      list($y, $m, $d) = explode('-', $def['date2']);
      $def['date2'] = array();
      $def['date2']['y'] = $y;
      $def['date2']['m'] = $m;
      $def['date2']['d'] = $d;
    }
  }

  // kereses lehetseges ertekei
  $var = _ticket_search_attrib($u_id, $gid);
  // form elkeszitese
  _ticket_search_form($form, $var, $def);

  $form['src']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Search')
  );

  // ha volt mar kereses
  if ( count($links) ) {
    $form['src']['#collapsed'] = TRUE;
    $links['u_id'] = $u_id;
    $links['gid'] = $gid;
    _ticket_search($links, $var);
    // kereses eredmenye
    list($table, $pager) = _ticket_list_table($u_id, $gid);
  }

  // kereses formja
  $search_form = drupal_get_form('ticket_search_form', $form);
  // kereses oldal megjelenitese
  return theme('ticket_list', $search_form, $table, $pager);
}

/**
 * ticket_search: ticket search
 * @param: $type - search type (simple/advanced)
 * @param: $u_id - Unit Id
 * @param: $gid - Group Id
 */
function ticket_search($type, $u_id = NULL, $gid = NULL) {
  global $ticket_conf;

  if ( !empty($u_id) ) {
    if ( !_ticket_menu_active($u_id, $gid) ) {
      drupal_goto('ticket/'. $u_id);
    }
  }
  $links = func_get_args();
  unset($links[0], $links[1], $links[2]);
  $search['form'] = $search['result'] = '';

  $def['priority'] = $def['site'] = $def['status'] = $def['uid'] =
  $def['assigned'] =
  $def['date1']['y'] = $def['date1']['m'] = $def['date1']['d'] =
  $def['date2']['y'] = $def['date2']['m'] = $def['date2']['d'] = -1;
  $def['summary'] = $def['detail'] = '';

  if ($type == 'advanced') {
    $def['type'] = $def['scope'] = $def['fixer'] = -1;
    $def['affected'] = $def['actions'] = $def['time_to_fix'] = $def['fix'] = '';
  }

  if ( !empty($links)) {
    if ($links[3] != 'all') {
      $links = _ticket_search_get_default($links);

      $def = array_merge($def, $links);
      if ( !is_array($def['date1']) ) {
        // datum szetdarabolasa
        list($date['y'], $date['m'], $date['d']) = explode('-', $def['date1']);
        $def['date1'] = $date;
      }
      if ( !is_array($def['date2']) ) {
        // datum szetdarabolasa
        list($date['y'], $date['m'], $date['d']) = explode('-', $def['date2']);
        $def['date2'] = $date;
      }
    }
  }

  $var = _ticket_search_attrib($u_id, $gid);

  $collapsed = FALSE;
  // ha volt mar kereses
  if ( count($links) ) {
    if ($links[3] != 'all') {
      unset($links[3]);
    }
    $header = array(
      array('data' => t('Ticket ID'), 'field' => 't.tid'),
      array('data' => t('Summary'), 'field' => 't.summary'),
      array('data' => t('Type'), 'field' => 'type.type_name'),
      array('data' => t('Status'), 'field' => 'status.status_name'),
      array('data' => t('Opened by'), 'field' => 't.uid'),
      array('data' => t('Priority'), 'field' => 'priority.weight'),
      array('data' => t('Problem started'), 'field' => 't.start'),
      array('data' => t('Date updateed'), 'field' => 'te.created'),
      array('data' => t('Updates'), 'field' => 'tre.num'),
    );

    $collapsed = TRUE;
    $links['u_id'] = $u_id;
    $links['gid'] = $gid;
    $sql = _ticket_search($links, $var);

    $SQL = "SELECT t.tid, t.gid, t.summary, t.uid, t.start, te.created, tre.num, tg.u_id, type.type_name";
    $SQL .= ", priority.priority_name, priority.weight, status.status_name, status.stage";
    $SQL .= " FROM {ticket_ticket} t, {ticket_rel_event} tre, {ticket_event} te, {ticket_status} status";
    $SQL .= ", {ticket_priority} priority, {ticket_type} type, {ticket_group} tg". implode(' ', $sql['from']);
    $SQL .= " WHERE tg.gid = t.gid AND t.tid = tre.tid";
    $SQL .= " AND tre.eid = te.eid AND te.status_id = status.status_id";
    $SQL .= " AND t.priority_id = priority.priority_id AND t.type_id = type.type_id ". implode(' ', $sql['where']);
    $SQL = str_replace('t.status_id', 'te.status_id', $SQL);
    $SQL .= ' '. tablesort_sql($header, '');

    $result = pager_query($SQL, $ticket_conf['limit'], 0, NULL, $sql['param']);

    $rows = array();
    // tablazat sorainak elkeszitese
    while ($row = db_fetch_array($result)) {
      $row['summary'] = l($row['summary'], 'ticket/'. $row['u_id'] .'/'. $row['gid'] .'/'. $row['tid']);
      $row['tid'] = l($row['tid'], 'ticket/'. $row['u_id'] .'/'. $row['gid'] .'/'. $row['tid']);
      $row['name'] = theme('username', user_load($row['uid']));

      $rows[] = array(
        array('data' => $row['tid']),
        array('data' => $row['summary']),
        array('data' => $row['type_name']),
        array('data' => $row['status_name'], 'class' => 'stage-'. $row['stage']),
        array('data' => $row['name']),
        array('data' => $row['priority_name'], 'class' => 'priority-'. $row['weight']),
        array('data' => format_date($row['start'], 'small'), 'class' => 'date'),
        array('data' => format_date($row['created'], 'small'), 'class' => 'date'),
        array('data' => $row['num']),
      );
    }
    // kereses eredmenye
    $search['result'] = theme('ticket_search_list', $header, $rows);
    $search['pager'] = theme('pager', NULL, $ticket_conf['limit']);

  }
  // kereses formja
  $search['form'] = drupal_get_form('ticket_search_form', $var, $def, $u_id, $gid, $collapsed);
  // kereses oldal megjelenitese
  return theme('ticket_search', $search);
}

/**
 * theme_ticket_search_list: theme hook
 * @param: $rows - tablazat sorai
 */
function theme_ticket_search_list($header, $rows) {
  $output = '<div id="ticket">';
  $output .= theme('table', $header, $rows);
  $output .= '</div>';
  return $output;
}

/**
 * theme_ticket_search_list: theme hook
 * @param: $rows - tablazat sorai
 */
function theme_ticket_search($search) {
  drupal_add_css(drupal_get_path('module', 'ticket') .'/ticket.css');
  return $search['form'] . $search['result'] . $search['pager'];
}

/**
 * _ticket_search_get_default: a keresett ertekek alapertelmezett beallitasa a formon
 * @param $links - modositja az alapertelmezett ertekeket
 * @return form alapertelmezett elemeit adja vissza
 */
function _ticket_search_get_default($links) {
  $txt = array('summary', 'detail', 'affected', 'actions', 'time_to_fix', 'fix', 'description');

  // alapertelemezett ertekek felul irasa a link parameter alapjan
  $def = array();
  if (count($links)) {
    $prev_key = '';
    foreach ($links as $value) {
      if ( strpos($value, ':') ) {
        list($key, $link) = explode(':', $value);
        if ( FALSE === array_search($key, $txt) ) {
          if ( strpos($link, ',') ) {
            $link = explode(',', $link);
          }
        }
        $def[$key] = $link;
        $prev_key = $key;
      }
      else {
        $def[$prev_key] .= '/'. $value;
      }
    }
  }
  return $def;
}

/**
 * _ticket_search_attrib: kereses atributumai
 * @param $u_id - unit id
 * @param $gid - group id
 * @return $var - ertekek
 */
function _ticket_search_attrib($u_id = NULL, $gid = NULL) {
  global $user;

  $list = array('type', 'priority', 'scope', 'site', 'fixer', 'status');
  // csoporton beluli kereses
  if ( isset($u_id) && isset($gid) ) {
    // ticket tulajdonsagainak kigyujtese
    foreach ($list as $element) {
      $var[$element] = array();
      $SQL = "SELECT ". $element ."_id, ". $element ."_name FROM {ticket_". $element ."} WHERE gid = %d ORDER BY ";
      if ($element == 'status') {
        $SQL .= "closed, ";
      }
      $SQL .= "weight, ". $element ."_name";
      $result = db_query($SQL, $gid);
      $var[$element][-1] = t('any');
      $num_rows = FALSE;
      while ($row = db_fetch_array($result)) {
        $num_rows = TRUE;
        $var[$element][$row[$element .'_id']] = $row[$element .'_name'];
      }
      if ( !$num_rows ) {
        unset($var[$element]);
      }
    }
    $groups = $gid;
  }
  elseif ( isset($u_id) ) {
    // uniton beluli kereses
    // azon csoportok kigyujtese ahol kereshet
    if ( ( ticket_access('ticket manager', $u_id, 0) ) || ( ticket_access('ticket reader', $u_id, 0) ) ) {
      $SQL = "SELECT gid, group_name FROM {ticket_group} WHERE u_id = %d AND active = 1 ORDER BY group_name";
      $result = db_query($SQL, $u_id);
    }
    else {
      $SQL = "SELECT tg.gid, tg.group_name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {ticket_group} tg";
      $SQL .= " WHERE tp.u_id = %d AND ur.uid = %d AND ur.rid = tp.rid AND tp.rid = p.rid AND tg.gid = tp.gid AND tg.active = 1";
      $SQL .= " AND p.perm LIKE '%ticket access%' AND (tp.perm LIKE '%ticket manager%' OR tp.perm LIKE '%ticket reader%')";
      $SQL .= " ORDER BY tg.group_name";
      $result = db_query($SQL, $u_id, $user->uid);
    }
    // csak ha van olyan csoport ahol kereshet akkor megy tovabb
    $var['group'][-1] = t('any');
    $num_rows = FALSE;
    while ($row = db_fetch_array($result)) {
      $num_rows = TRUE;
      $var['group'][$row['gid']] = $row['group_name'];
      $groups[] = $row['gid'];
    }
    if ( $num_rows ) {
      $groups = implode(',', $groups);
      // ticket tulajdonsagainak kigyujtese
      foreach ($list as $element) {
        $SQL = "SELECT ". $element ."_name FROM {ticket_". $element ."} ";
        $SQL .= ' WHERE gid IN (%s) GROUP BY '. $element .'_name ORDER BY ';
        if ($element == 'status') {
          $SQL .= "closed, ";
        }
        $SQL .= "weight, ". $element ."_name";
        $result = db_query($SQL, $groups);
        $var[$element][-1] = t('any');
        $num_rows = FALSE;
        while ($row = db_fetch_array($result)) {
          $num_rows = TRUE;
          $var[$element][$row[$element .'_name']] = $row[$element .'_name'];
        }
        if ( !$num_rows ) {
          unset($var[$element]);
        }
      }
    }
  }
  else {
    // globalis kereses
    $var['unit'][-1] = t('any');
    $var['group'][-1] = t('any');
    $units = $groups = array();
    if ( ( ticket_access('ticket manager', 0, 0) ) || ( ticket_access('ticket reader', 0, 0) ) ) {
      // osszes unit lekerdezese
      $SQL = "SELECT u_id, unit_name FROM {ticket_unit} WHERE active = 1";
      $result = db_query($SQL);
      while ($row = db_fetch_array($result)) {
        $var['unit'][$row['u_id']] = $row['unit_name'];
        $units[] = $row['u_id'];
      }
      $units = implode(',', $units);
      // osszes csoport lekerdezese
      $SQL = "SELECT tg.gid, tg.group_name FROM {ticket_group} tg, {ticket_unit} tu";
      $SQL .= " WHERE tu.u_id = tg.u_id AND tu.active = 1 AND tg.active = 1";
      $result = db_query($SQL);
      while ($row = db_fetch_array($result)) {
        $var['group'][$row['gid']] = $row['group_name'];
        $groups[] = $row['gid'];
      }
    }
    else {
      // unitok lekerdezese amiben kereshet
      $SQL = "SELECT tu.u_id, tu.unit_name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {ticket_unit} tu";
      $SQL .= " WHERE ur.uid = %d AND ur.rid = tp.rid AND ur.rid = p.rid AND tp.u_id = tu.u_id AND tu.active = 1";
      $SQL .= " AND p.perm LIKE '%ticket access%' AND (tp.perm LIKE '%ticket manager%' OR tp.perm LIKE '%ticket reader%')";
      $SQL .= " GROUP BY tu.u_id, tu.unit_name ORDER BY tu.unit_name";
      $result = db_query($SQL, $user->uid);
      while ($row = db_fetch_array($result)) {

        $var['unit'][$row['u_id']] = $row['unit_name'];
        $units[] = $row['u_id'];
      }
      $units = implode(',', $units);

      // csoportok lekerdezese amiben kereshet (amelyik unit osszes csoportjara vonatkozo joga van)
      $SQL = "SELECT tg.gid, tg.group_name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {ticket_group} tg";
      $SQL .= " WHERE tp.u_id IN (%s) AND (tp.gid = 0 OR tp.gid = tg.gid ) AND tg.u_id = tp.u_id AND ur.uid = %d";
      $SQL .= " AND tp.rid = p.rid AND p.rid = ur.rid AND tg.active = 1";
      $SQL .= " AND p.perm LIKE '%ticket access%' AND (tp.perm LIKE '%ticket manager%' OR tp.perm LIKE '%ticket reader%')";
      $SQL .= " GROUP BY tg.gid, tg.group_name ";
      $SQL .= " ORDER BY tg.group_name";
      $result = db_query($SQL, $units, $user->uid);
      while ($row = db_fetch_array($result)) {
        $var['group'][$row['gid']] = $row['group_name'];
        $groups[] = $row['gid'];
      }
    }
    if ( !empty($groups) ) {
      $groups = implode(',', $groups);
      // ticket tulajdonsagainak kigyujtese
      foreach ($list as $element) {
        $SQL = "SELECT ". $element ."_name FROM {ticket_". $element ."} ";
        $SQL .= ' WHERE gid IN (%s) GROUP BY '. $element .'_name ORDER BY ';
        if ($element == 'status') {
          $SQL .= "closed, ";
        }
        $SQL .= "weight, ". $element ."_name";
        $result = db_query($SQL, $groups);
        $var[$element][-1] = t('any');
        $num_rows = FALSE;
        while ($row = db_fetch_array($result)) {
          $num_rows = TRUE;
          $var[$element][$row[$element .'_name']] = $row[$element .'_name'];
        }
        if ( !$num_rows ) {
          unset($var[$element]);
        }
      }
    }
  }

  if ( !empty($groups) ) {
    // felelosok kigyujtese
    $var['assigned'] = array();
    $var['assigned'][-1] = t('anybody');
    // ticket karbantartoinak kigyujtese
    $SQL = "SELECT t.assigned, u.name FROM {ticket_ticket} t, {users} u ";
    $SQL .= " WHERE";
    if (is_numeric($groups)) {
      $SQL .= " t.gid = %d";
    }
    else {
      $SQL .= " t.gid IN (%s)";
    }
    $SQL .= " AND t.assigned = u.uid GROUP BY t.assigned, u.name";
    $SQL .= " ORDER BY u.name";
    $result = db_query($SQL, $groups);

    $assigned = array();
    while ($row = db_fetch_array($result)) {
      $assigned[$row['name']] = $row['assigned'];
    }
    $SQL = "SELECT te.reassigned, u.name FROM {ticket_ticket} t, {ticket_event} te, {users} u ";
    $SQL .= " WHERE";
    if (is_numeric($groups)) {
      $SQL .= " t.gid = %d";
    }
    else {
      $SQL .= " t.gid IN (%s)";
    }
    $SQL .= " AND t.tid = te.tid AND te.reassigned = u.uid GROUP BY te.reassigned, u.name";
    $SQL .= " ORDER BY u.name";
    $result = db_query($SQL, $groups);
    // felelosok kigyujtese
    $reassigned = array();
    while ($row = db_fetch_array($result)) {
      $reassigned[$row['name']] = $row['reassigned'];
    }
    unset($reassigned[0]);
    $var['assigned'] += array_flip( array_merge($assigned, $reassigned) );
    unset($var['assigned'][0]);
  }

  $var['uid'] = $var['assigned'];

  // 2005-tol napjainkig
  $var['date']['y'][-1] = '*';
  for ( $i = 2005;$i <= date('Y') ;$i++ ) {
    $var['date']['y'][$i] = $i;
  }
  $var['date']['m'][-1] = '*';
  for ( $i = 1;$i <= 12 ;$i++ ) {
    if ( $i < 10 ) {
      $var['date']['m'][$i] = '0'. $i;
    }
    else {
      $var['date']['m'][$i] = $i;
    }
  }
  $var['date']['d'][-1] = '*';
  for ( $i = 1;$i <= 31 ;$i++ ) {
    if ( $i < 10 ) {
      $var['date']['d'][$i] = '0'. $i;
    }
    else {
      $var['date']['d'][$i] = $i;
    }
  }
  return $var;
}

function _ticket_search_event_attrib($u_id, $gid = NULL) {
  global $user;

  $var['created'] = $var['reassigned'] = array();
  // csoporton beluli kereses
  if ( isset($gid) ) {
    // ticket status tulajdonsag kigyujtese
    $var['status'] = array();
    $SQL = "SELECT status_id, status_name FROM {ticket_status} WHERE gid = %d AND closed = 0 ORDER BY weight, status_name";
    $result = db_query($SQL, $gid);

    $var['status'][-1] = t('any');
    while ($row = db_fetch_array($result)) {
      $var['status'][$row['status_id']] = $row['status_name'];
    }
    $groups = $gid;
  }
  else {
    // uniton beluli kereses
    // azon csoportok kigyujtese ahol kereshet
    if ( ( ticket_access('ticket manager', $u_id, 0) ) || ( ticket_access('ticket reader', $u_id, 0) ) ) {
      $SQL = "SELECT gid, group_name FROM {ticket_group} WHERE u_id = %d AND active = 1 ORDER BY group_name";
      $result = db_query($SQL, $u_id);
    }
    else {
      $SQL = "SELECT tg.gid, tg.group_name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {ticket_group} tg";
      $SQL .= " WHERE tp.u_id = %d AND ur.uid = %d AND ur.rid = tp.rid AND tp.rid = p.rid AND tg.gid = tp.gid AND tg.active = 1";
      $SQL .= " AND p.perm LIKE '%ticket access%' AND (tp.perm LIKE '%ticket manager%' OR tp.perm LIKE '%ticket reader%')";
      $SQL .= " ORDER BY tg.group_name";
      $result = db_query($SQL, $u_id, $user->uid);
    }
    // csak ha van olyan csoport ahol kereshet akkor megy tovabb
    $var['group'][-1] = t('any');
    $num_rows = FALSE;
    while ($row = db_fetch_array($result)) {
      $num_rows = TRUE;
      $var['group'][$row['gid']] = $row['group_name'];
      $groups[] = $row['gid'];
    }
    if ( $num_rows ) {
      $groups = implode(',', $groups);
      // ticket status tulajdonsag kigyujtese
      $SQL = 'SELECT status_name FROM {ticket_status} WHERE gid IN (%s) AND closed = 0 GROUP BY status_name';
      $SQL .= " ORDER BY weight, status_name";
      $result = db_query($SQL, $groups);

      $var['status'][-1] = t('any');
      while ($row = db_fetch_array($result)) {
        $var['status'][$row['status_name']] = $row['status_name'];
      }
    }
  }

  if ( !empty($groups) ) {
    // felelosok kigyujtese
    $var['reassigned'] = array();
    $var['reassigned'][-1] = t('anybody');
    // ticket karbantartoinak kigyujtese
    $SQL = "SELECT t.assigned, u.name FROM {ticket_ticket} t, {users} u ";
    $SQL .= " WHERE";
    if (is_numeric($groups)) {
      $SQL .= " t.gid = %d";
    }
    else {
      $SQL .= " t.gid IN (%s)";
    }
    $SQL .= " AND t.assigned = u.uid GROUP BY t.assigned, u.name";
    $SQL .= " ORDER BY u.name";
    $result = db_query($SQL, $groups);

    $assigned = array();
    while ($row = db_fetch_array($result)) {
      $assigned[$row['name']] = $row['assigned'];
    }
    $SQL = "SELECT te.reassigned, u.name FROM {ticket_ticket} t, {ticket_event} te, {users} u ";
    $SQL .= " WHERE";
    if (is_numeric($groups)) {
      $SQL .= " t.gid = %d";
    }
    else {
      $SQL .= " t.gid IN (%s)";
    }
    $SQL .= " AND t.tid = te.tid AND te.reassigned = u.uid GROUP BY te.reassigned, u.name";
    $SQL .= " ORDER BY u.name";
    $result = db_query($SQL, $groups);
    // felelosok kigyujtese
    $reassigned = array();
    while ($row = db_fetch_array($result)) {
      $reassigned[$row['name']] = $row['reassigned'];
    }
    unset($reassigned[0]);
    $var['reassigned'] += array_flip( array_merge($assigned, $reassigned) );
    unset($var['reassigned'][0]);
  }

  $var['uid'] = $var['reassigned'];

  return $var;
}

/**
 * _ticket_search_form: kereses form kiiratasa
 * @param $var - form value
 * @param $def - default form value
 * @param $u_id - unit id
 * @param $gid - group id
 * @param $collapsed - form element hidden
 * @return array()  - drupal form
 */
function _ticket_search_form($var, $def, $u_id, $gid, $collapsed = FALSE) {
  $form = array();
  if ( isset($u_id) ) {
    $form['u_id'] = array(
      '#type' => 'value',
      '#value' => $u_id,
    );
  }
  elseif ( empty($def['unit']) ) {
    $def['unit'] = -1;
  }

  if ( isset($gid) ) {
    $form['gid'] = array(
      '#type' => 'value',
      '#value' => $gid,
    );
  }
  elseif ( empty($def['group']) ) {
    $def['group'] = -1;
  }

  $form['src'] = array(
    '#type' => 'fieldset',
    '#title' => t('Search'),
    '#collapsible' => TRUE,
    '#collapsed' => $collapsed,
  );

  $form['src']['attrib'] = array(
    '#type' => 'fieldset',
    '#title' => t('Attributes'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );
  if ( count($var['unit']) && isset($def['unit']) ) {
    $form['src']['attrib']['unit'] = array(
      '#type' => 'select',
      '#multiple' => TRUE,
      '#title' => t('Units'),
      '#options' => $var['unit'],
      '#default_value' => $def['unit'],
      '#prefix' => '<div class="ticket-form-multiple">',
      '#suffix' => '</div>',
    );
  }

  if ( count($var['group']) && isset($def['group']) ) {
    $form['src']['attrib']['group'] = array(
      '#type' => 'select',
      '#multiple' => TRUE,
      '#title' => t('Groups'),
      '#options' => $var['group'],
      '#default_value' => $def['group'],
      '#prefix' => '<div class="ticket-form-multiple">',
      '#suffix' => '</div>',
    );
  }

  if ( count($var['uid']) && isset($def['uid']) ) {
    $form['src']['attrib']['uid'] = array(
      '#type' => 'select',
      '#multiple' => TRUE,
      '#title' => t('Opened by'),
      '#options' => $var['uid'],
      '#default_value' => $def['uid'],
      '#prefix' => '<div class="ticket-form-multiple">',
      '#suffix' => '</div>',
    );
  }

  if ( count($var['assigned']) && isset($def['assigned']) ) {
    $form['src']['attrib']['assigned'] = array(
      '#type' => 'select',
      '#multiple' => TRUE,
      '#title' => t('Assigned to'),
      '#options' => $var['assigned'],
      '#default_value' => $def['assigned'],
      '#prefix' => '<div class="ticket-form-multiple">',
      '#suffix' => '</div>',
    );
  }


  $form['src']['t-attrib'] = array(
    '#type' => 'fieldset',
    '#title' => t('Ticket attributes'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  if ( count($var['type']) && isset($def['type']) ) {
    $form['src']['t-attrib']['type'] = array(
      '#type' => 'select',
      '#multiple' => TRUE,
      '#title' => t('Type'),
      '#options' => $var['type'],
      '#default_value' => $def['type'],
      '#prefix' => '<div class="ticket-form-multiple">',
      '#suffix' => '</div>',
    );
  }

  if ( count($var['priority']) && isset($def['priority']) ) {
    $form['src']['t-attrib']['priority'] = array(
      '#type' => 'select',
      '#multiple' => TRUE,
      '#title' => t('Priority'),
      '#options' => $var['priority'],
      '#default_value' => $def['priority'],
      '#prefix' => '<div class="ticket-form-multiple">',
      '#suffix' => '</div>',
    );
  }

  if ( count($var['scope']) && isset($def['scope']) ) {
    $form['src']['t-attrib']['scope'] = array(
      '#type' => 'select',
      '#multiple' => TRUE,
      '#title' => t('Scope'),
      '#options' => $var['scope'],
      '#default_value' => $def['scope'],
      '#prefix' => '<div class="ticket-form-multiple">',
      '#suffix' => '</div>',
    );
  }

  if ( count($var['site']) && isset($def['site']) ) {
    $form['src']['t-attrib']['site'] = array(
      '#type' => 'select',
      '#multiple' => TRUE,
      '#title' => t('Site'),
      '#options' => $var['site'],
      '#default_value' => $def['site'],
      '#prefix' => '<div class="ticket-form-multiple">',
      '#suffix' => '</div>',
    );
  }

  if ( count($var['fixer']) && isset($def['fixer']) ) {
    $form['src']['t-attrib']['fixer'] = array(
      '#type' => 'select',
      '#multiple' => TRUE,
      '#title' => t('Fixer'),
      '#options' => $var['fixer'],
      '#default_value' => $def['fixer'],
      '#prefix' => '<div class="ticket-form-multiple">',
      '#suffix' => '</div>',
    );
  }

  if ( count($var['status']) && isset($def['status']) ) {
    $form['src']['t-attrib']['status'] = array(
      '#type' => 'select',
      '#multiple' => TRUE,
      '#title' => t('Status'),
      '#options' => $var['status'],
      '#default_value' => $def['status'],
      '#prefix' => '<div class="ticket-form-multiple">',
      '#suffix' => '</div>',
    );
  }

  $form['src']['date'] = array(
    '#type' => 'fieldset',
    '#title' => t('Problem started'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $form['src']['date']['date1-y'] = array(
    '#type' => 'select',
    '#title' => t('From'),
    '#options' => $var['date']['y'],
    '#default_value' => $def['date1']['y'],
    '#prefix' => '<div class="ticket-form-date">',
    '#suffix' => '<span class = "sep"> - </span></div>',
  );

  $form['src']['date']['date1-m'] = array(
    '#type' => 'select',
    '#title' => '',
    '#options' => $var['date']['m'],
    '#default_value' => $def['date1']['m'],
    '#prefix' => '<div class="ticket-form-date">',
    '#suffix' => '<span class = "sep"> - </span></div>',
  );

  $form['src']['date']['date1-d'] = array(
    '#type' => 'select',
    '#title' => '',
    '#options' => $var['date']['d'],
    '#default_value' => $def['date1']['d'],
    '#prefix' => '<div class="ticket-form-date">',
    '#suffix' => '</div>',
  );

  $form['src']['date']['date2-y'] = array(
    '#type' => 'select',
    '#title' => t('To'),
    '#options' => $var['date']['y'],
    '#default_value' => $def['date2']['y'],
    '#prefix' => '<div class="ticket-form-date">',
    '#suffix' => '<span class = "sep"> - </span></div>',
  );

  $form['src']['date']['date2-m'] = array(
    '#type' => 'select',
    '#title' => '',
    '#options' => $var['date']['m'],
    '#default_value' => $def['date2']['m'],
    '#prefix' => '<div class="ticket-form-date">',
    '#suffix' => '<span class = "sep"> - </span></div>',
  );

  $form['src']['date']['date2-d'] = array(
    '#type' => 'select',
    '#title' => '',
    '#options' => $var['date']['d'],
    '#default_value' => $def['date2']['d'],
    '#prefix' => '<div class="ticket-form-date">',
    '#suffix' => '</div>',
  );

  $form['src']['summary'] = array(
    '#type' => 'textfield',
    '#title' => t('Short summary'),
    '#default_value' => $def['summary'],
    '#maxlength' => '255',
    '#size' => '60',
    '#prefix' => '<div class="ticket-form-line">',
    '#suffix' => '</div>',
  );

  $form['src']['detail'] = array(
    '#type' => 'textarea',
    '#title' => t('Detail'),
    '#default_value' => $def['detail'],
    '#rows' => '2',
  );

  if ( isset($def['affected']) ) {
    $form['src']['affected'] = array(
      '#type' => 'textarea',
      '#title' => t('Affected'),
      '#default_value' => $def['affected'],
      '#rows' => '2',
    );
  }

  if ( isset($def['actions']) ) {
    $form['src']['actions'] = array(
      '#type' => 'textarea',
      '#title' => t('Actions'),
      '#default_value' => $def['actions'],
      '#rows' => '2',
    );
  }

  if ( isset($def['time_to_fix']) ) {
    $form['src']['time_to_fix'] = array(
      '#type' => 'textfield',
      '#title' => t('Time to fix'),
      '#default_value' => $def['time_to_fix'],
      '#maxlength' => '250', '#size' => '60',
    );
  }

  if ( isset($def['fix']) ) {
    $form['src']['fix'] = array(
      '#type' => 'textarea',
      '#title' => t('Fix'),
      '#default_value' => $def['fix'],
      '#rows' => '2',
    );
  }
  return $form;
}


/**
 * ticket_search_form: kereses form kiiratasa
 * @param $form_state - drupal form variable
 * @param $var - form value
 * @param $def - default form value
 * @param $u_id - unit id
 * @param $gid - group id
 * @param $collapsed - ticket serach element hidden
 */
function ticket_search_form(&$form_state, $var, $def, $u_id, $gid, $collapsed = FALSE) {

  $form = _ticket_search_form($var, $def, $u_id, $gid, $collapsed);
  $form['src']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Search')
  );

  return $form;
}

/**
 * ticket_search_form_submit: ticket search submit hook
 */
function ticket_search_form_submit($form, &$form_state) {
  _ticket_search_set_date($form_state);
  // keresesi parameterekbol url keszitese
  $url = 'ticket';
  if (isset($form_state['values']['u_id']) && !is_array($form_state['values']['u_id'])) {
    $url .= '/'. $form_state['values']['u_id'];
    if (isset($form_state['values']['gid']) && !is_array($form_state['values']['gid'])) {
      $url .= '/'. $form_state['values']['gid'];
    }
  }

  if (isset($form_state['values']['affected'])) {
    $url .= '/search/advanced';
  }
  else {
    $url .= '/search/simple';
  }
  $url .= _ticket_search_link($form_state['values']);

  // visszateres a cimmel, alapesetben ugras arra az oldalra
  $form_state['redirect'] = $url;
}

function _ticket_search_set_date(&$form_state) {
  // datum darabok ossze illesztese
  if ($form_state['values']['date1-y'] != '-1') {
    $date = $form_state['values']['date1-y'] .'-';
    if ($form_state['values']['date1-m'] != '-1') {
      $date .= $form_state['values']['date1-m'] .'-';
    }
    else {
      $date .= '01-';
    }
    if ($form['date1-d'] != '-1') {
      $date .= $form_state['values']['date1-d'];
    }
    else {
      $date .= '01';
    }
    $form_state['values']['date1'] = $date;
  }
  unset($form_state['values']['date1-y'], $form_state['values']['date1-m'], $form_state['values']['date1-d']);

  // datum darabok ossze illesztese
  if ($form_state['values']['date2-y'] != '-1') {
    $date = $form_state['values']['date2-y'] .'-';
    if ($form_state['values']['date2-m'] != '-1') {
      $date .= $form_state['values']['date2-m'] .'-';
    }
    else {
      $date .= '01-';
    }
    if ($form_state['values']['date2-d'] != '-1') {
      $date .= $form_state['values']['date2-d'];
    }
    else {
      $date .= '01';
    }
    $form_state['values']['date2'] = $date;
  }
  unset($form_state['values']['date2-y'], $form_state['values']['date2-m'], $form_state['values']['date2-d']);
}


/**
 * _ticket_search_link: Kitoltott form parametereibol linket keszit
 * @param $values - form altal atadott ertekek
 * @return $link - a form ertekeibol keszitett linket adja vissza
 */
function _ticket_search_link($values) {
  $banned = array('op', 'submit', 'form_build_id', 'form_token', 'form_id', 'u_id', 'gid');
  foreach ($values as $key => $value) {
    if ( !in_array($key, $banned) ) {
      if ( is_array($value) ) {
        if ( !isset($value['-1']) ) {
          $link .= '/'. $key .':';
          foreach ($value as $sub_value) {
            $link .= $sub_value .',';
          }
          $link = trim($link, ',');
        }
      }
      else {
        if ( !(($value == '-1') || ($value == '')) ) {
          $link .= '/'. $key .':'. $value;
        }
      }
    }
  }
  if ( empty($link) ) {
    $link = '/all';
  }

  return $link;
}

/**
 * _ticket_search: kereses a ticketek kozott
 * @param $links - linkbol atalakitott keresesi feltetelek
 * @param $var - kereses form ertekei
 */
function _ticket_search($links, $var) {
  $sql['from'] = $sql['where'] = $sql['param'] = array();

  $i = 0;
  // ha a kereses globalis akkor szerepelnek unitok is
  if ( isset($var['unit']) ) {
    // unitok hozza illesztese a kereseshez
    if ( isset($links['unit']) ) {
      if ( is_array($links['unit']) ) {
        $sql['where'][] = ' AND tg.u_id IN (%s)';
        $sql['param'][$i] = implode(',', $links['unit']);
      }
      else {
        $sql['where'][] = ' AND tg.u_id = %d';
        $sql['param'][$i] = $links['unit'];
      }
    }
    else {
      if ( count($var['unit']) > 1 ) {
        $sql['where'][] = ' AND tg.u_id IN (%s)';
        $sql['param'][$i] = implode(',', array_slice(array_keys($var['unit']), 1));
      }
    }
    $i++;
  }
  // ha a kereses globalis vagy uniton beluli akkor szerepelnek csoportok is
  if ( isset($var['group']) ) {
    if ( isset($links['group']) ) {
      $links['gid'] = $links['group'];
    }
    else {
      if ( count($var['group']) > 1 ) {
        $links['gid'] = array_slice(array_keys($var['group']), 1);
      }
    }
  }

  $list = array('gid', 'uid');
  foreach ($list as $element) {
    // csoport es felhasznalo szerinti kereses
    if ( isset($links[$element]) ) {
      if ( is_array($links[$element]) ) {
        $sql['where'][] = ' AND t.'. $element .' IN (%s)';
        $sql['param'][$i] = implode(',', $links[$element]);
      }
      else {
        $sql['where'][] = ' AND t.'. $element .' = %d';
        $sql['param'][$i] = $links[$element];
      }
      $i++;
    }
  }
  // keresett felelosok meghagyasa
  if ( isset($links['assigned']) ) {
    if ( is_array($links['assigned']) ) {
      $sql['where'][] = ' AND te.reassigned IN (%s)';
      $sql['param'][$i] = implode(',', $links['assigned']);
    }
    else {
      $sql['where'][] = ' AND te.reassigned = %d ';
      $sql['param'][$i] = $links['assigned'];
    }
    $i++;
  }

  // datum szerinti kereses, megadott datumanal ujabbakat keres
  if ( isset($links['date1']) ) {
    $sql['where'][] = " AND t.start >= %d";
    $sql['param'][$i] = strtotime($links['date1']);
    $i++;
  }

  // datum szerinti kereses, megadott datumnal regebbieket keres
  if ( isset($links['date2']) ) {
    $sql['where'][] = " AND t.start <= %d";
    $sql['param'][$i] = strtotime($links['date2']);
    $i++;
  }

  $from_extra = array('scope', 'site', 'fixer');
  if ( !isset($var['group']) ) {
    // ha csoporton beluli a kereses
    $list = array('type', 'priority', 'status', 'scope', 'site', 'fixer');
    foreach ($list as $element) {
      if ( isset($links[$element]) ) {
        if ( in_array($element, $from_extra) ) {
          $sql['from'][] = ', {ticket_'. $element .'} '. $element .'';
        }
        if ( is_array($links[$element]) ) {
          $sql['where'][] = ' AND t.'. $element .'_id IN (%s)';
          $sql['param'][$i] = implode(',', $links[$element]);
        }
        else {
          $sql['where'][] = ' AND t.'. $element .'_id = %d';
          $sql['param'][$i] = $links[$element];
        }
        $i++;
      }
    }
  }
  else {
    // ha tobb csoport kozott is kereseshet
    $run = 0;
    $list = array('type', 'priority', 'status', 'scope', 'site', 'fixer');
    foreach ($list as $element) {
      if ( isset($links[$element]) ) {
        if ( in_array($element, $from_extra) ) {
          $sql['from'][] = ', {ticket_'. $element .'} '. $element .'';
        }
        $sql['where'][] = ' AND t.gid = '. $element .'.gid';
        if ( is_array($links[$element]) ) {
          $sql['where'][] = ' AND '. $element .'.'. $element .'_id = t.'. $element .'_id AND '. $element .'.'. $element .'_name IN ('. implode(',', array_map("_ticket_txt2db", $links[$element])) .')';
        }
        else {
          $sql['where'][] = ' AND '. $element .'.'. $element .'_id = t.'. $element .'_id AND '. $element .'.'. $element ."_name = '%s'";
          $sql['param'][$i] = $links[$element];
          $i++;
        }
      }
    }
  }

  // Szoveges keresesi parameterek
  $list = array('summary', 'detail', 'affected', 'actions', 'time_to_fix', 'fix');
  foreach ($list as $element) {
    if ( isset($links[$element]) ) {
      $sql['where'][] = ' AND t.'. $element ." LIKE '%%%s%'";
      $sql['param'][$i] = str_replace('*', '%', $links[$element]);
      $i++;
    }
  }
  return $sql;
}

/**
 * _ticket_search_event: kereses a ticket esemenyek kozott
 * @param $links - linkbol atalakitott keresesi feltetelek
 * @param $var - kereses form ertekei
 */
function _ticket_search_event($links, $var) {
  $sql['where'] = $sql['param'] = array();

  $i = 0;
  // ha a kereses uniton beluli akkor szerepelnek csoportok is
  if ( isset($var['group']) ) {
    if ( isset($links['group']) ) {
      $links['gid'] = $links['group'];
    }
    else {
      if ( count($var['group']) > 1 ) {
        $links['gid'] = array_slice(array_keys($var['group']), 1);
      }
    }
  }

  // csoport szerinti kereses
  if ( isset($links['gid']) ) {
    if ( is_array($links['gid']) ) {
      $sql['where'][] = ' AND t.gid IN (%s)';
      $sql['param'][$i] = implode(',', $links['gid']);
    }
    else {
      $sql['where'][] = ' AND t.gid = %d';
      $sql['param'][$i] = $links['gid'];
    }
    $i++;
  }

  $list = array('reassigned', 'uid');
  foreach ($list as $element) {
    // felelos es felhasznalo szerinti kereses
    if ( isset($links[$element]) ) {
      if ( is_array($links[$element]) ) {
        $sql['where'][] = ' AND te.'. $element .' IN (%s)';
        $sql['param'][$i] = implode(',', $links[$element]);
      }
      else {
        $sql['where'][] = ' AND te.'. $element .' = %d';
        $sql['param'][$i] = $links[$element];
      }
      $i++;
    }
  }

  if ( !isset($var['group']) ) {
    // ha csoporton beluli a kereses
    if ( isset($links['status']) ) {
      if ( is_array($links['status']) ) {
        $sql['where'][] = ' AND te.status_id IN (%s)';
        $sql['param'][$i] = implode(',', $links['status']);
      }
      else {
        $sql['where'][] = ' AND te.status_id = %d';
        $sql['param'][$i] = $links['status'];
      }
      $i++;
    }
  }
  else {
    // ha tobb csoport kozott is kereseshet
    if ( isset($links['status']) ) {
      $sql['where'][] = ' AND t.gid = status.gid';
      if ( is_array($links['status']) ) {
        $sql['where'][] = ' AND status.status_id = te.status_id AND status.status_name IN ('. implode(',', array_map("_ticket_txt2db", $links['status'])) .')';
      }
      else {
        $sql['where'][] = " AND status.status_id = te.status_id AND status.status_name = '%s'";
        $sql['param'][$i] = $links['status'];
        $i++;
      }
    }
  }

  // Szoveges keresesi parameter
  if ( isset($links['description']) ) {
    $sql['where'][] = " AND te.description LIKE '%%%s%'";
    $sql['param'][$i] = str_replace('*', '%', $links['description']);
    $i++;
  }
  return $sql;
}

// SQL utasitas parameterenek szurese
function _ticket_txt2db($txt) {
  return "'". db_escape_string($txt) ."'";
}

/**
 * ticket_search_tid: hibajegy azonosito alapjan keres
 */
function ticket_search_tid() {
  $form['tid'] = array(
    '#type' => 'textfield',
    '#title' => t('Ticket ID'),
    '#maxlength' => '20',
    '#size' => '20',
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Search')
  );

  return $form;
}

/**
 * ticket_search_tid_validate: ticket search tid form validate
 */
function ticket_search_tid_validate($form, &$form_state) {
  include_once drupal_get_path('module', 'ticket') .'/ticket.jump.inc';
  $error = ticket_ticketid($form_state['values']['tid']);
  form_set_error('', $error);
}

/**
 * _ticket_export: ticket exportalas
 * @param $result - SQL lekerdezes
 * @param $mode - csv vagy web lesz a kimenet
 */
function _ticket_export_files($result, $mode) {
  if ($mode == 'csv') {
    while ($file = db_fetch_array($result)) {
      $f[$file['tid']][] = url('ticket/files/'. $file['fid'] .'/'. $file['filename'], array('absolute' => TRUE)) .' ('. format_size($file['filesize']) .')';
    }
  }
  else {
    while ($file = db_fetch_array($result)) {
      $f[$file['tid']][] = '<span class = "ticket-nowrap">'. l($file['filename'], 'ticket/files/'. $file['fid'] .'/'. $file['filename'], array('attributes' => array('target' => '_blank'))) .' ('. format_size($file['filesize']) .')</span>';
    }
  }

  $files = array();
  foreach ($f as $tid => $file) {
    $files[$tid] = implode(', ', $file);
  }

  return $files;
}

/**
 * _ticket_export: ticket exportalas
 * @param $result - SQL lekerdezes
 * @param $files - hibajegyekhez kapcsolodo fileok
 * @param $field - azok a mezok amik az exportba irodnak
 * @param $mode - csv vagy web lesz a kimenet
 */
function _ticket_export($result, $files, $field, $mode) {
  // valaszthato mezok
  if ( !is_array($field) ) {
    $field = array($field);
  }

  // az adatbazis mezokhoz rendelt megjelenitesi nev
  $pre_header = array(
    'unit_name' => t('Unit'),
    'group_name' => t('Group'),
    'tid' => t('Ticket ID'),
    'uid' => t('Opened by'),
    'assigned' => t('Assigned to'),
    'priority_name' => t('Priority'),
    'start' => t('Problem started'),
    'finish' => t('Problem fixed'),
    'length' => t('Problem length'),
    'num' => t('Event number'),
    'fixer_name' => t('Fixer'),
    'type_name' => t('Type'),
    'status_name' => t('Status'),
    'site_name' => t('Site'),
    'scope_name' => t('Scope'),
    'summary' => t('Short summary'),
    'detail' => t('Detail'),
    'affected' => t('Affected'),
    'actions' => t('Actions'),
    'time_to_fix' => t('Time to fix'),
    'files' => t('Files'),
    'fix' => t('Fix'),
  );

  // kivalasztott mezok kigyujtese (adatbazis lekerdezeshez es kiiratashoz egyarant)
  foreach ($field as $f) {
    $header[] = array('data' => $pre_header[$f]);
  }

  $rows = array();
  $all_length = 0;
  while ($row = db_fetch_array($result)) {
    // ha weboldalra lesz kiiratva akkor a specialis karaktereket at kell alakitani ugy, hogy megjelenjenek az oldalon
    // ez azert lett kiemelve, mert a ticket id-bol link lesz, es akkor a summarynal hibas link keletkezne
    $tid = $row['tid'];

    $line = array();
    // ticket hosszanak kiszamitasa
    if ( !empty($row['finish']) ) {
      $finish = $row['finish'];
    }
    else {
      $finish = time();
    }
    $row['length'] = $finish - $row['start'];
    $all_length += $row['length'];

    // a kivalasztott mezoket a megfelelo formara alakitjuk
    foreach ($field as $f) {
      if ($f == 'all_length') {
        continue;
      }
      switch ($f) {
        case 'start':
          // timestamp formatum atalakitasa rendes datumra
          $row['start'] = format_date($row['start'], 'small');
        break;

        case 'finish':
          // timestamp formatum atalakitasa rendes datumra
          if ( !empty($row['finish']) ) {
            $row['finish'] = format_date($row['finish'], 'small');
          }
          else {
            $row['finish'] = t('Not closed!');
          }
        break;

        case 'length':
          // timestamp formatum atalakitasa rendes datumra
          $row['length'] = format_interval($row['length'], 3);
        break;

        case 'files':
          if ( count($files[$tid]) ) {
            $row['files'] = $files[$tid];
          }
          else {
            $row['files'] = '-';
          }
        break;

        default:
          if ($mode == 'csv') {
            switch ($f) {
              case 'summary':
              case 'detail':
              case 'affected':
              case 'actions':
              case 'time_to_fix':
              case 'fix':
                // ha csv-be lesz kiiratva akkor a sortores karaktereket kitorlesre kerulnek
                $row[$f] = str_replace(array("\n", "\r", "\r\n"), ' ', $row[$f]);
                // valamint a " jelbol ' keszul, es a tartalom "" koze kerul, igy szerepelhet a szovegben ; karakter is
                $row[$f] = '"'. str_replace('"', "'", $row[$f]) .'"';
              break;

              case 'uid':
              case 'assigned':
                // felhasznalo azonositojat lecsereljuk a nevere
                $user = check_plain(user_load($row[$f]));
                $row[$f] = check_plain($user->name);
              break;
            }
          }
          else {
            switch ($f) {
              case 'tid':
                $row['tid'] = l($row['tid'], 'ticket/'. $row['u_id'] .'/'. $row['gid'] .'/'. $tid);
              break;

              case 'summary':
                $row['summary'] = l($row['summary'], 'ticket/'. $row['u_id'] .'/'. $row['gid'] .'/'. $tid);
              break;

              case 'detail':
              case 'affected':
              case 'actions':
              case 'time_to_fix':
              case 'fix':
                // ha weboldalra lesz kiiratva akkor a specialis karaktereket at kell alakitani ugy, hogy megjelenjenek az oldalon
                $row[$f] = nl2br(htmlspecialchars($row[$f], ENT_QUOTES, 'UTF-8'));
              break;

              case 'uid':
              case 'assigned':
                // felhasznalo azonositojat lecsereljuk a nevere
                $row[$f] = theme('username', user_load($row[$f]));
              break;

              case 'priority_name':
                $row['priority_name'] = array('data' => $row['priority_name'], 'class' => 'priority-'. $row['weight']);
              break;

              case 'status_name':
                $row['status_name'] = array('data' => $row['status_name'], 'class' => 'stage-'. $row['stage']);
              break;
            }
          }
        break;
      }
      // ha a mezonek nincs erteke akkor alapertelemzett ertek a: -
      if ( !isset($row[$f]) ) {
        $row[$f] = '-';
      }

      $line[] = $row[$f];
    }
    // csv eseten a mezok koze ; kerul beirasra
    if ($mode == 'csv') {
      $rows[] = implode(';', $line);
    }
    else {
      $rows[] = $line;
    }
  }
  // kiiratas, csv-nel fileba web-nel tablazatba
  if ($mode == 'csv') {
    $output = implode("\r\n", $rows);
  }
  else {
    if ( array_search('all_length', $field) ) {
      $colspan[0] = array_search('length', $field);
      $colspan[1] = count($field)-$colspan[0]-1;
      $all_length = format_interval($all_length, 3);
      $rows[] = array(
        array('data' => t('Total problem length') .':', 'colspan' => $colspan[0]),
        array('data' => $all_length, 'colspan' => $colspan[1]),
      );
    }
    $output = theme('table', $header, $rows);
  }
  return $output;
}

/**
 * ticket_export: ticket export
 */
function ticket_export($u_id, $gid = NULL) {
  if ( _ticket_menu_active($u_id, $gid) ) {
    $links = func_get_args();
    unset($links[0], $links[1]);
    $search['form'] = $search['result'] = '';

    $def['priority'] = $def['site'] = $def['status'] = $def['uid'] =
    $def['assigned'] = $def['type'] = $def['scope'] = $def['fixer'] =
    $def['date1']['y'] = $def['date1']['m'] = $def['date1']['d'] =
    $def['date2']['y'] = $def['date2']['m'] = $def['date2']['d'] = -1;
    $def['ssum'] = $def['detail'] = $def['affected'] = $def['actions'] =
    $def['time_to_fix'] = $def['fix'] = '';
    $def['field'] = array('tid', 'uid', 'assigned', 'priority_name', 'start', 'finish', 'length'
    , 'fixer_name', 'type_name', 'site_name', 'scope_name', 'summary');

    $def['mode'] = 'csv';

    if ( !empty($links)) {
      $links = _ticket_search_get_default($links);
      $links['field'] = array_diff($links['field'], array(0));
      $def = array_merge($def, $links);
      if ( !is_array($def['date1']) ) {
        // datum szetdarabolasa
        list($date['y'], $date['m'], $date['d']) = explode('-', $def['date1']);
        $def['date1'] = $date;
      }
      if ( !is_array($def['date2']) ) {
        // datum szetdarabolasa
        list($date['y'], $date['m'], $date['d']) = explode('-', $def['date2']);
        $def['date2'] = $date;
      }
    }

    $var = _ticket_search_attrib($u_id, $gid);
    $collapsed = FALSE;

    // ha volt mar kereses
    if ( count($links) ) {
      $collapsed = TRUE;
      $links['u_id'] = $u_id;
      $links['gid'] = $gid;
      $sql = _ticket_search($links, $var);

      // osszekapcsolasok duplazasanak kiszurese
      $sql['where'] = str_replace(array(' AND scope.scope_id = t.scope_id', ' AND site.site_id = t.site_id', ' AND fixer.fixer_id = t.fixer_id'), '', implode(' ', $sql['where']));

      $files = array();
      if ( ( in_array('files', $def['field']) ) && (ticket_access('ticket upload files', $u_id, $gid) || ticket_access('view ticket uploaded files', $u_id, $gid)) ) {
        $SQL = "SELECT tf.fid, tf.tid, tf.filename, tf.filesize";
        $SQL .= " FROM {ticket_ticket} t, {ticket_rel_event} tre, {ticket_event} te, {ticket_status} status";
        $SQL .= ", {ticket_priority} priority, {ticket_type} type, {ticket_scope} scope, {ticket_site} site";
        $SQL .= ", {ticket_fixer} fixer, {ticket_group} tg, {ticket_unit} tu, {ticket_files} tf";
        $SQL .= " WHERE tf.tid = t.tid";
        if ( !ticket_access('ticket upload files', $u_id, $gid) && ticket_access('view ticket uploaded files', $u_id, $gid) ) {
          $SQL .= " AND tf.list = 1";
        }
        $SQL .= " AND tg.gid = t.gid AND tg.u_id = tu.u_id AND t.tid = tre.tid AND tre.eid = te.eid";
        $SQL .= " AND te.status_id = status.status_id AND t.priority_id = priority.priority_id";
        $SQL .= " AND scope.scope_id = t.scope_id AND site.site_id = t.site_id";
        $SQL .= " AND fixer.fixer_id = t.fixer_id AND t.type_id = type.type_id ". $sql['where'];
        $SQL = str_replace('t.status_id', 'te.status_id', $SQL);
        $SQL .= " ORDER BY tf.tid, tf.filename";
        $result = db_query($SQL, $sql['param']);
        $files = _ticket_export_files($result, $def['mode']);
      }

      $SQL = "SELECT t.tid, t.uid, t.assigned, t.gid, t.uid, t.start, t.finish";
      $SQL .= ", te.created, tre.num, tg.u_id, t.summary, t.detail, t.affected, t.actions";
      $SQL .= ", t.time_to_fix, t.fix";
      $SQL .= ", tu.unit_name, tg.group_name, type.type_name";
      $SQL .= ", priority.priority_name, priority.weight, status.status_name, status.stage";
      $SQL .= ", scope.scope_name, site.site_name, fixer.fixer_name";
      $SQL .= " FROM {ticket_ticket} t, {ticket_rel_event} tre, {ticket_event} te, {ticket_status} status";
      $SQL .= ", {ticket_priority} priority, {ticket_type} type, {ticket_scope} scope, {ticket_site} site";
      $SQL .= ", {ticket_fixer} fixer, {ticket_group} tg, {ticket_unit} tu";
      $SQL .= " WHERE tg.gid = t.gid AND tg.u_id = tu.u_id AND t.tid = tre.tid AND tre.eid = te.eid";
      $SQL .= " AND te.status_id = status.status_id AND t.priority_id = priority.priority_id";
      $SQL .= " AND scope.scope_id = t.scope_id AND site.site_id = t.site_id";
      $SQL .= " AND fixer.fixer_id = t.fixer_id AND t.type_id = type.type_id ". $sql['where'];
      $SQL = str_replace('t.status_id', 'te.status_id', $SQL);
      $SQL .= " ORDER BY t.tid";
      $result = db_query($SQL, $sql['param']);
      // export eredmenye
      $search['result'] = _ticket_export($result, $files, $def['field'], $def['mode']);
    }

    // export formja
    $search['form'] = drupal_get_form('ticket_export_form', $var, $def, $u_id, $gid, $collapsed);
    // kereses oldal megjelenitese
    // exportalas tipusa
    if ($links['mode'] == 'csv') {
      // csv fileba kuldes
      drupal_set_header('Content-Type: text/comma-separated-values');
      drupal_set_header('Content-Disposition: attachment;filename="ticket-export.csv'.'";');
      echo $search['result'];
      return NULL;
    }
    else {
      return theme('ticket_export_web', $search);
    }
  }
  else {
    drupal_goto('ticket/'. $u_id);
  }
}

/**
 * theme_ticket_export_web: theme hook
 */
function theme_ticket_export_web($search) {
  drupal_add_css(drupal_get_path('module', 'ticket') .'/ticket.css');
  $output = '';
  $output .= '<div id = "ticket_header">';
  $output .= $search['form'];
  $output .= '</div>';

  if ( !empty($search['result']) ) {
    $output .= '<div id = "ticket_export"><div id = "ticket">';
    $output .= $search['result'];
    $output .= '</div></div>';
  }
  return $output;
}

/**
 * ticket_export: ticket export
 */
function ticket_export_form(&$form_state, $var, $def, $u_id, $gid, $collapsed = FALSE) {
  $form = _ticket_search_form($var, $def, $u_id, $gid, $collapsed);

  // form export resze
  $form['export'] = array(
    '#type' => 'fieldset',
    '#title' => t('Export'),
    '#collapsible' => TRUE,
    '#collapsed' => $collapsed,
  );

  // valaszthato mezok listaja
  $field = array(
    'unit_name' => t('Unit'),
    'group_name' => t('Group'),
    'tid' => t('Ticket ID'),
    'uid' => t('Opened by'),
    'assigned' => t('Assigned to'),
    'priority_name' => t('Priority'),
    'start' => t('Problem started'),
    'finish' => t('Problem fixed'),
    'length' => t('Problem length'),
    'num' => t('Event number'),
    'fixer_name' => t('Fixer'),
    'type_name' => t('Type'),
    'status_name' => t('Status'),
    'site_name' => t('Site'),
    'scope_name' => t('Scope'),
    'summary' => t('Short summary'),
    'detail' => t('Detail'),
    'affected' => t('Affected'),
    'actions' => t('Actions'),
    'time_to_fix' => t('Time to fix'),
    'fix' => t('Fix'),
    'files' => t('Files'),
    'all_length' => t('Total problem length'),
  );

  $form['export']['field'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Export fields'),
    '#options' => $field,
    '#default_value' => $def['field'],
    '#required' => TRUE,
  );
  $mode = array(
    'csv' => t('CSV'),
    'web' => t('Web'),
  );

  $form['export']['mode'] = array(
    '#type' => 'select',
    '#title' => t('Export format'),
    '#options' => $mode,
    '#default_value' => $def['mode'],
    '#prefix' => '<div class="ticket-form-line-export-select">',
    '#suffix' => '</div>',
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Export'),
  );
  return $form;
}

/**
 * ticket_export_form_submit: ticket export submit hook
 */
function ticket_export_form_submit($form, &$form_state) {
  _ticket_search_set_date($form_state);
  $url = 'ticket/'. $form_state['values']['u_id'];
  if (isset($form_state['values']['gid']) && !is_array($form_state['values']['gid'])) {
    $url .= '/'. $form_state['values']['gid'];
  }
  $url .= '/export';
  $url .= _ticket_search_link($form_state['values']);
  // visszateres a cimmel, alapesetben ugras arra az oldalra
  $form_state['redirect'] = $url;
}

/**
 * ticket_search_event: ticket event search
 * @param: $u_id - Unit Id
 * @param: $gid - Group Id
 */
function ticket_search_event($u_id = NULL, $gid = NULL) {
  global $ticket_conf;

  if ( !empty($u_id) ) {
    if ( !_ticket_menu_active($u_id, $gid) ) {
      drupal_goto('ticket/'. $u_id);
    }
  }


  $links = func_get_args();
  unset($links[0], $links[1]);

  $search['form'] = $search['result'] = '';
  $def['status'] = $def['uid'] = $def['reassigned'] = '-1';
  $def['description'] = '';

  if ( !empty($links)) {
    if ($links[2] != 'all') {
      $links = _ticket_search_get_default($links);

      $def = array_merge($def, $links);
    }
  }

  $var = _ticket_search_event_attrib($u_id, $gid);

  $collapsed = FALSE;
  // ha volt mar kereses
  if ( count($links) ) {
    if ($links[2] == 'all') {
      unset($links[2]);
    }
    $header = array(
      array('data' => t('Ticket ID'), 'field' => 't.tid'),
      array('data' => t('Summary'), 'field' => 't.summary'),
      array('data' => t('Type'), 'field' => 'type.type_name'),
      array('data' => t('Status'), 'field' => 'status.status_name'),
      array('data' => t('Opened by'), 'field' => 't.uid'),
      array('data' => t('Priority'), 'field' => 'priority.weight'),
      array('data' => t('Problem started'), 'field' => 't.start'),
      array('data' => t('Date updateed'), 'field' => 'te.created'),
      array('data' => t('Updates'), 'field' => 'tre.num'),
    );

    $collapsed = TRUE;
    $links['u_id'] = $u_id;
    $links['gid'] = $gid;
    $sql = _ticket_search_event($links, $var);

    $SQL = "SELECT t.tid";
    $SQL .= " FROM {ticket_ticket} t, {ticket_event} te, {ticket_rel_event} tre, {ticket_group} tg, {ticket_status} status";
    $SQL .= " WHERE tg.gid = t.gid AND t.tid = te.tid AND te.status_id = status.status_id";
    $SQL .= " AND tre.tid = t.tid AND tre.num > 0 ".implode(' ', $sql['where']);
    $SQL .= " GROUP BY tid ";
    $result = db_query($SQL, $sql['param']);

    $tids = array();
    while ($row = db_fetch_array($result)) {
      $tids[] = $row['tid'];
    }

    if (count($tids)) {

      $SQL = "SELECT t.tid, t.gid, t.summary, t.uid, t.start, te.created, tre.num, tg.u_id, type.type_name";
      $SQL .= ", priority.priority_name, priority.weight, status.status_name, status.stage";
      $SQL .= " FROM {ticket_ticket} t, {ticket_rel_event} tre, {ticket_event} te, {ticket_status} status";
      $SQL .= ", {ticket_priority} priority, {ticket_type} type, {ticket_group} tg";
      $SQL .= " WHERE tg.gid = t.gid AND t.tid = tre.tid";
      $SQL .= " AND tre.eid = te.eid AND te.status_id = status.status_id";
      $SQL .= " AND t.priority_id = priority.priority_id AND t.type_id = type.type_id AND t.tid IN (%s)";
      $SQL .= ' '. tablesort_sql($header, '');
      $result = pager_query($SQL, $ticket_conf['limit'], 0, NULL, implode(',', $tids));

      $rows = array();
      // tablazat sorainak elkeszitese
      while ($row = db_fetch_array($result)) {
        $row['summary'] = l($row['summary'], 'ticket/'. $row['u_id'] .'/'. $row['gid'] .'/'. $row['tid']);
        $row['tid'] = l($row['tid'], 'ticket/'. $row['u_id'] .'/'. $row['gid'] .'/'. $row['tid']);
        $row['name'] = theme('username', user_load($row['uid']));

        $rows[] = array(
          array('data' => $row['tid']),
          array('data' => $row['summary']),
          array('data' => $row['type_name']),
          array('data' => $row['status_name'], 'class' => 'stage-'. $row['stage']),
          array('data' => $row['name']),
          array('data' => $row['priority_name'], 'class' => 'priority-'. $row['weight']),
          array('data' => format_date($row['start'], 'small'), 'class' => 'date'),
          array('data' => format_date($row['created'], 'small'), 'class' => 'date'),
          array('data' => $row['num']),
        );
      }
    }





    // kereses eredmenye
    $search['result'] = theme('ticket_search_list', $header, $rows);
    $search['pager'] = theme('pager', NULL, $ticket_conf['limit']);
  }

  // kereses formja
  $search['form'] = drupal_get_form('ticket_search_event_form', $var, $def, $u_id, $gid, $collapsed);
  // kereses oldal megjelenitese
//  return $search['form'];
  return theme('ticket_search', $search);
}


/**
 * ticket_search_form: kereses form kiiratasa
 * @param $form_state - drupal form variable
 * @param $var - form value
 * @param $def - default form value
 * @param $u_id - unit id
 * @param $gid - group id
 * @param $collapsed - ticket serach element hidden
 */
function ticket_search_event_form(&$form_state, $var, $def, $u_id, $gid, $collapsed = FALSE) {
  $form = array();

  $form['u_id'] = array(
    '#type' => 'value',
    '#value' => $u_id,
  );

  if ( isset($gid) ) {
    $form['gid'] = array(
      '#type' => 'value',
      '#value' => $gid,
    );
  }
  elseif ( empty($def['group']) ) {
    $def['group'] = -1;
  }

  $form['src'] = array(
    '#type' => 'fieldset',
    '#title' => t('Event search'),
    '#collapsible' => TRUE,
    '#collapsed' => $collapsed,
  );

  if ( count($var['group']) && isset($def['group']) ) {
    $form['src']['group'] = array(
      '#type' => 'select',
      '#multiple' => TRUE,
      '#title' => t('Groups'),
      '#options' => $var['group'],
      '#default_value' => $def['group'],
      '#prefix' => '<div class="ticket-form-multiple">',
      '#suffix' => '</div>',
    );
  }

  $form['src']['uid'] = array(
    '#type' => 'select',
    '#multiple' => TRUE,
    '#title' => t('Created by'),
    '#options' => $var['uid'],
    '#default_value' => $def['uid'],
    '#prefix' => '<div class="ticket-form-multiple">',
    '#suffix' => '</div>',
  );

  $form['src']['reassigned'] = array(
    '#type' => 'select',
    '#multiple' => TRUE,
    '#title' => t('Assigned to'),
    '#options' => $var['reassigned'],
    '#default_value' => $def['reassigned'],
    '#prefix' => '<div class="ticket-form-multiple">',
    '#suffix' => '</div>',
  );

  $form['src']['status'] = array(
    '#type' => 'select',
    '#multiple' => TRUE,
    '#title' => t('Status'),
    '#options' => $var['status'],
    '#default_value' => $def['status'],
    '#prefix' => '<div class="ticket-form-multiple">',
    '#suffix' => '</div>',
  );

  $form['src']['description'] = array(
    '#type' => 'textarea',
    '#title' => t('Description'),
    '#default_value' => $def['description'],
    '#rows' => '2',
    '#prefix' => '<div class="ticket-form-textbox">',
    '#suffix' => '</div>',
  );

  $form['src']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Search')
  );

  return $form;
}

/**
 * ticket_search_event_form_submit: ticket search submit hook
 */
function ticket_search_event_form_submit($form, &$form_state) {
  // keresesi parameterekbol url keszitese
  $url = 'ticket/'. $form_state['values']['u_id'];

  if (isset($form_state['values']['gid']) && !is_array($form_state['values']['gid'])) {
    $url .= '/'. $form_state['values']['gid'];
  }

  $url .= '/search/event'._ticket_search_link($form_state['values']);

  // visszateres a cimmel, alapesetben ugras arra az oldalra
  $form_state['redirect'] = $url;
}
